/*
  # Controller/CivilianController.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  #
  # $Id: CivilianController.java,v 1.12 2002/06/08 08:36:24 yoshikia Exp $
 */
package Controller;

import java.util.*;
import java.io.*;
import rescueAgent.Generic.*;
import rescueAgent.AreaMap.*;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼ǻ̱Ȥ򥳥ȥ뤹륯饹<BR>
 * CivilianController:
 * Controll Civilian Agent in Rescue simulation
 **/
public class CivilianController extends MovingObjectController{

  /********************************************************************/
  // 󥹥ȥ饯

  public CivilianController(int id,IO io,int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);

    System.gc(); // ١쥯μ¹
    System.out.println("My ID: "+ id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SubClassܺٵʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){

    // ޤsuperƤ, ưΥȶ̤ν¹
    super.init(msg_header,msg_data);
    // ʲǻ̱ͭν򤹤(Ǥϲ⤷ʤ)
  }

  /********************************************************************/
  /** ưΥȸͭιưԤʤ<BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected int[] uniqueDeciding(int[] msg_header, int[] msg_data){
    // Civilian饹ϴŪ˻Ȥʤ,ŪʼϤʤ
    return null; // Ȥꤢ⤷ʤäȤˤƤ
  }

  /********************************************************************/
  /** ƸİưΥȤˤȤä,٤åɤȽꤹ롣
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected boolean shouldReadMessage(int[] msg_header){
    // Civilian饹ϴŪ˻Ȥʤ,ŪʼϤʤ
    return false; // Ȥꤢʹʤ褦ˤƤ
  }

  /********************************************************************/
  /** ߽, ⤷ϻ꤫åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * , ϤåȤä, ǡ١ȥ֥ȤιԤʤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForRescueAgent(int ka_command,
					      int senderID, Message message){
    // Civilian饹ϴŪ˻Ȥʤ,ŪʼϤʤ
    return null; // Ȥꤢ⤷ʤäȤˤƤ
  }
    
  /********************************************************************/
  /** ̱åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * ߤΤȤ, Υ᥽åɤǼ¹Ԥ뤳ȤϤʤΤǲ⤷ʤ֤롣
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForCivilian(int ka_command,
					   int senderID, String message){
    // Civilian饹ϴŪ˻Ȥʤ,ŪʼϤʤ
    return null; // Ȥꤢ⤷ʤäȤˤƤ
  }
    
  /********************************************************************/
}
