/*
  # Controller/FireBrigadeController.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  #
  # $Id: FireBrigadeController.java,v 1.12 2002/06/08 08:36:24 yoshikia Exp $
 */
package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼Ǿ⥨Ȥ򥳥ȥ뤹륯饹<BR>
 * FireBrigadeController:
 * Controll FireBregade Agent in Rescue simulation
 **/
public class FireBrigadeController extends MovingObjectController{
  //int target = -1; // òо
  //int sayTarget = -1; // ɤӤʤΡ(02-11-28)
  int[] firedID; // ǳƤӥIDäƤ
  int[] refugeID; // ˶ᤤID
  Vector refugeList; // ID
  int[] refugeIDList; // RefugeIDꥹȡrefugeIDäƤΤ׽!
  //Random random = new Random();

  //int nowPos = -1; // ʬκpointID
  //int prevPos = -1; // ʬpointID
  //int samePosCount = 0; // samePosϢ³trueä
  //int sameRouteCount = 0; // 2 ܤƱ Road ä
  int dontArriveCount = 0;  // ɸˤɤ失Ƥʤƥå׿
  //int cantMoveCount = 0; // ưƤʤƥå׿
  //int dontArriveRefugeCount = 0; // ɸ(refuge)ƤΥƥå׿furuta
  int selfPosX; // ʬκpointXɸ 
  int selfPosY; // ʬκpointYɸ 
  int area; // ʬκ륨ꥢֹ(14) 
  boolean arealock = false; // ɤξˤƤòХꥢꤹ뤫 
  double midX; // ޥåפ Xɸ 
  double midY; // ޥåפ Yɸ 
  Vector[] maparea; // 14Ȥ5ˤƤ 

  //int tmp_confusionRoad = -1; // ڤƤͽ¬ƻ
  //Vector confusionRoad = new Vector(); // ڤƤƻΥꥹ(־)

  // å ˡʬäƤȤ(02-11-28)
  int ignoreTargetCount = -1; // 02-11-28
  int ignoreTarget = -1; // 02-11-28

  final int checkNum = 5; // ĤβлͭȤ뤫

  // òФ˴ؤ
  int extinguish_prev_target = -1; // òФо
  int extinguish_step = -1;// оݤ򲿥ƥå׾òФƤ뤫

  //###### Hear Parameter
  //int prevMsgTime = -1;
  //int rcvMsg = 0;
  //int sndMsg = 0;
  // boolean targetSet = false; // Ϥ˾òгưƤAgent(ȤäƤʤ)
  //int[][] sayTargetList = new int[3][2]; // ηʪ˴ؤƾòФƤ
  //int[] senderList = new int[3];

  //int[] fireStationList;

  // кҤΥ饹׻
  ClusterSet cs;
  int clusterSizeLimit = 110; // 饹󥰵ѤѸ³ (02-11-28)

  // ToDo : ºݤ Controller.java Ĥ٤
  // ToDo : MessageRoboCup2002  interface Ƴ٤
  // å(ޥ͡㡼)
  //MessageManager msgMan;
  //MessageRoboCup2002 msgRC2002;

  //###### DEBUG Parameter 
  boolean debug = false; // ѥǥХå⡼
  boolean miscLogMode = true; // misc ˥Ϥ⡼

  //###### Caution!!!  This is "Ultimate" Parameter
  boolean multiExt = true;
  int multiple = 2;

  // λĤ̥ѥ᡼
  int waterQuantity = -1; // ߤξΥλĿ
  boolean canExt = true; // ο夬̵ʤäƾòǽäfalse

  /********************************************************************/
  // 󥹥ȥ饯

  public FireBrigadeController(int id,IO io,int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);

    //fireStationList = getFireStationList();

    // 桼åɵΥ 50 m ΥƤ㤦饹Ȥ 
    cs = new ClusterSet(50);

    // Debug Use
    //System.out.println("(FB)ο : "
    //	       +objectManager.getFireBrigadeObjectNum());
    //System.out.println("ɽ(FS)ο : "
    //	       +objectManager.getFireStationObjectNum());

    // å
    //System.out.print("(FB)ǤMessage Send...");
    //System.out.print(Parameter.MAX_AGENT_SNDMSG_NUM +", Recieve...");
    //System.out.println(Parameter.MAX_AGENT_RCVMSG_NUM);
    //msgMan = new MessageManager(Parameter.MAX_AGENT_SNDMSG_NUM,true);

    System.gc(); // ١쥯μ¹
    //System.out.println("My ID: "+ id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SubClassܺٵʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){

    // ޤsuperƤ, ưΥȶ̤ν¹
    super.init(msg_header,msg_data);

    // ʲǾͭν򤹤
    refugeList = objectManager.getRefugeListWP(); // Ͽޤrefuge
    if(refugeList != null){ // ǤȤꤢIDǼ
      refugeIDList = new int[refugeList.size()];
      int index=0;
      Iterator it = refugeList.iterator();
      while(it.hasNext()){
	Building r = (Building)it.next();
	refugeIDList[index] = r.getID();
	index++;
      }
    }

    // ޥåפΣʬ˴ؤʬ 

    // ʪ enumeration
    Enumeration enum = objectManager.getObjectDatabase().getBuildingTable().elements();

    // ޥåפλͶκɸ    
    double maxX =  0;
    double maxY =  0;
    double minX = -1;
    double minY = -1;

    // ֤Ƚ
    while(enum.hasMoreElements()){
      Building ro = (Building)enum.nextElement();
      if (ro.getX() > maxX)
	maxX = ro.getX();
      if(minX == -1 || ro.getX() < minX)
	minX = ro.getX();
      if (ro.getY() > maxY)
	maxY = ro.getY();
      if(minY == -1 || ro.getY() < minY)
	minY = ro.getY();
    }
    midX = (maxX - minX)/2 + minX;
    midY = (maxY - minY)/2 + minY;
    //System.out.println("minX = "+ minX);
    //System.out.println("minY = "+ minY);
    //System.out.println("maxX = "+ maxX);
    //System.out.println("maxY = "+ maxY);
    //System.out.println("centerX = "+ midX);
    //System.out.println("centerY = "+ midY);

    // Building򣴤ĤΥꥢʬ
    maparea = new Vector[5]; // 14Ȥ5ˤƤ
    for(int i=0;i<5;i++)
      maparea[i] = new Vector();

    enum = objectManager.getObjectDatabase().getBuildingTable().elements();
    while(enum.hasMoreElements()){
      Building ro = (Building)enum.nextElement();
      if (ro.getX() <= midX){
	if (ro.getY() <= midY)
	  maparea[1].add(ro);
	else
	  maparea[2].add(ro);
      }
      else if (ro.getX() > midX){
	if (ro.getY() <= midY)
	  maparea[3].add(ro);
	else
	  maparea[4].add(ro);
      }
    }
    for(int i=1;i<5;i++){
      //System.out.println("MapArea["+ i +"] is "+ maparea[i].size() +" buldings.");
    }
  }

  /********************************************************************/
  /** ưΥȸͭιưԤʤ<BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected int[] uniqueDeciding(int[] msg_header, int[] msg_data){

    // СĢ碌 
    Vector message = new Vector();
    message.add(msg_header);
    message.add(msg_data);
    decideCommand(message);
    // СĢ碌 ޤ

    return null; // Ȥꤢnull֤
  }

  /********************************************************************/
  /** ⥨ȤΥᥤ롼򵭽Ҥ᥽åɡ<BR><BR>
   * @param message kernelƤå
   **/

  public void decideCommand(Vector message){

    msg_header = (int[])message.get(0); // åإå

    // ***** ʪKA_SENSE *****
    if(msg_header[0]==CommandTable.KA_SENSE){
      // $$$$ ι $$$$
      int[] msg_data = (int[])message.get(1); // åǡ
      //senseInfoParser.parseSenseInfo(msg_header,msg_data);

      //time = objectManager.getTime();
      //self = (FireBrigade)objectManager.getSelfInfo(); // ʤξι
      //RescueObject rsob = objectManager.getObject(self.getPosition());

      //msgMan.reset(); // MessageManager ι
      //sndMsg = 0;

      // ʬΰ֤ 
      //prevPos = nowPos;
      //nowPos = self.getPosition();
      //io.writeMiscLog("nowPos(ID):"+nowPos+", prevPos(ID):"+prevPos);
      //io.writeSelfLog(self.getPosition(),self.getPositionExtra());

      // Ŀ̤ιȡιưե(true:òСfalse:)
      waterQuantity = ((FireBrigade)self).getWaterQuantity();
      //System.out.print("now tank Quantity -> "+waterQuantity);
      //System.out.println(" , Max: "+Parameter.MAX_TANK_QUANT);
      if(waterQuantity == 0 && canExt == true){
	canExt = false; // òнʤʤä
	target = -1; // åȤΥꥻå
      }
      else if(waterQuantity == Parameter.MAX_TANK_QUANT &&
	      canExt == false){
	canExt = true; // òн褦ˤʤä
	target = -1; // åȤΥꥻå
	// AA_REFILL_FIN åι
	Message mes = messageManager_new.makeRefillFinMessage();
	if(mes != null){
	  // ʬν°륻󥿡, Tell
	  if(hasMyCenterObject()){
	    messageManager_new.storeTellMessage(mes,1);
	  }
	  // Sayɬ
	  messageManager_new.storeSayMessage(mes,1);
	}
      }
      //System.out.println("can Extinguish? -> "+canExt);

      // å ˡʬäƤȤ (02-11-28)
      // if (ignoreTargetCount >= 0){
      //   ignoreTargetCount--;
      //   if (ignoreTargetCount == -1){
      //     ignoreTarget = -1;
      //   }
      // }

      // ʬΤ륨ꥢ  02-12-02 ꥢåɲ
      if(arealock == true){ // åϤɤˤƤɸꥢϸ 
        io.writeMiscLog("åȥꥢ "+area+" ǥå档");
	arealock = false; // Ū˻ؼ̵¤åϲ 
      }
      else{
	if(objectManager.getPosX(self) <= midX){
	  if(objectManager.getPosY(self) <= midY)
	    area = 1;
	  else
	    area = 2;
        }
        else{
	  if(objectManager.getPosY(self) <= midY)
	    area = 3;
	  else
	    area = 4;
        }
        io.writeMiscLog("륨ꥢ(=åȥꥢ) "+area);
      }

      // ʬưʤå
      //checkHalt(rsob);

      // ɸˤɤ失Ƥʤ
      checkMayBeHalt();

      /*
      // Ƥʤνڤå
      // ()˽ڤȽƻξ󤬸Ťʤå
        // ΤˤϾ󤬣ƥåפΤΤ򤹤
      if(confusionRoad != null){
	// confusionRoad鸡ΤϡݤĤ
	for(int i=confusionRoad.size()-1; i>=0; i--){
	  // Integerλ־intѴsenseTime˳Ǽ
	  int senseTime = ((Integer[])confusionRoad.get(i))[1].intValue();
	  if(time - senseTime > 15){ // 15stepŤϺ
	    Integer[] info = (Integer[])confusionRoad.remove(i);
	    io.writeMiscLog("ڥꥹȤ:RoadID="+info[0]+",SenseTime="+info[1]);
	  }
	}
      }
      // ()ߤνھΥå
      if (checkConfusion(rsob)){
	// ǽڤ
	Integer[] info = new Integer[2];
	info[0] = new Integer(tmp_confusionRoad);
	info[1] = new Integer(time);
	confusionRoad.add(info);
	route = null; // confusionRoadޤ᤿routeκͭˤ뤿
	// todo confusionRoadˤʤȡե졼ˤƵո
	io.writeMiscLog("ǽڤƤ RoadID:"+info[0]);
        System.out.println("ǽڤƤ  RoadID:"+info[0]);
      }
      */

      // ޤäƤCivilianΥå
      //int[] buryCiv = objectManager.checkBuriedCivilian(time);
      //if(buryCiv != null){
      //  tellBuryMessage(buryCiv);
      //}

      // MessageManager ίäƤåФ
      //for (int i=0;i<msgMan.size();i++){
      //  io.tell(msgMan.getMsg(i));
      //  io.writeMiscLog("Tell Message");
      //  io.writeMiscLog(msgMan.getMsg(i).toString());
      //}
      
      // Debug
      //io.writeMiscLog("*** Display msgMan ***");
      //io.writeMiscLog(msgMan.toString());

      // ֥åι
      //((AdvObjectSet)objectManager).updateInfo(self,time);

      // routeι
      //int[] nextRoute = objectManager.recycleRoute(route,nowPos); 
      // ʤ֤ޤǵͤ
      //if(nextRoute != null){
      //  route = nextRoute;
      //}
      // $$$$ ι ޤ $$$$


      // $$$$ ư $$$
      // ʬȤβμŤΤؤɬפ뤫ɤ
      //if (AmIinjured_gotoRefuge()){
      //  io.writeMiscLog("ؤɬפä");
      //  return;
      //}
      // ԥꥹȤΥꥢ
      //clearSenderList();
      // sayTargetγǧ СǤSayTargetϤ⤦ʤ(02-11-28)
      //if(checkSayTarget(self)){ // ɤ褦 02-11-28
      //  return; // ɤ褦 02-11-28
      //} // ɤ褦 02-11-28

      if(canExt == false){ // 夬̵ƾòǽ֤ʤΤǵˤ
	// #### ե ####
	// åȼȤγǧ
	Building target_build =
	    objectManager.getObjectDatabase().getBuildingObject(target);
	// å̵ͭγǧ
	if(target == -1){ // åȤ̵ -> å
	  refugeID = objectManager.sortByDist(objectManager.getPosX(self),
						objectManager.getPosY(self),
						refugeList);
	  if(refugeID != null){
	    target = refugeID[0]; // ȤꤢƬΤΤ򥿡åȤ
	    target_build =
		objectManager.getObjectDatabase().getBuildingObject(target);
	    // åȤν
	    String bufferTarget = "";
	    for (int i=0;i<refugeID.length;i++){
	      bufferTarget += refugeID[i]+" ";
	    }
	    io.writeMiscLog("å([]) :" + bufferTarget);
	    dontArriveRefugeCount = 0; // ȤΥꥻåfuruta
	  }
	  else{ // ꤬ʤ -> ० (ºݤɬ꤬)
	    if(miscLogMode){
	      io.writeMiscLog("꤬ʤΤǵǤʤ  ०");
	    }	
	    randomWalk();
	    return;
	  }
	}

	// $$ 1ܤ $$
	// åȤåȤƤ뤫γǧ ʤʤää
	//if(target_build == null)
	//  target_build = 
	//    objectManager.getObjectDatabase().getBuildingObject(target);

	// ##########
	// trueʤư(ưor)λ
	if(supplyAction(target_build)){
	  if(miscLogMode){
	    io.writeMiscLog("0 ܤ SupplyAction λtarget =" + target);
	  }	
	  return;
	}

	// ##########
	// $$ 1ܤ ޤ $$

	for(int i=1;i<refugeID.length;i++){
	  target = refugeID[i];
	  target_build = 
	    objectManager.getObjectDatabase().getBuildingObject(target);
	  // trueʤư(ưor)λ
	  if(supplyAction(target_build)){
	    if(miscLogMode){
	      io.writeMiscLog(i+" ܤ SupplyAction λtarget = "+target);
	    }		  
	    return;
	  }
	}

	// ٤Ƥˤɤ失 -> Random Walk
	dontArriveCount++;
	//System.out.println("decidecommand(),եRandomWalk,dontArriveCount="+dontArriveCount+",time="+time);
	randomWalk();
	if(miscLogMode){
	  io.writeMiscLog("०");
	}
	return;
	// #### ե ޤ ####
      }
      else if(canExt == true){ // ޤϤΤǾòФ³
	// #### òХե ####
	// åȼȤγǧ
	Building target_build = 
	  objectManager.getObjectDatabase().getBuildingObject(target);
	// ǳƤʤ  ò  AA_EXTINGUISH_FIN åȯư
	if(target_build != null){
	  if(!target_build.isBurnning()){
	    // AA_EXTINGUISH_FIN åι
	    Message mes = messageManager_new.makeExtinguishFinMessage(target);
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	  }
	}
	//if(target != -1 && target_build.isBurnningLWithAG()){ // ǳƤ
	if(target != -1 && target_build.isBurnningLittle() &&
	   target_build.getAreaGround() < 15000 && 
	   target_build.getAreaTotal() < 70000 &&
	   getExtinguishStep() < 5){ // ǳƤ
	}
	else{ 
	  // ǳƤʤ ⤷Ͼòǽ -> ŪϤ򥯥ꥢ
	  target = -1;
	  route = null;
	};

	// кҥ饹η׻
	// 饹ν
	cs.init();
	// ʪϿ
	Vector v = objectManager.getBurningBuilding();
	if (v != null){
	  Iterator it = v.iterator();
	  if (v.size() < 100){  // кҥӥ뤬100̤ʤ齾̤ 
	    io.writeMiscLog("ǳƤӥ뤬100̤");
	    while (it.hasNext()){
	      Building b = (Building)it.next();
	      cs.add(new Cluster(b));
	      }
	  }
	  else{  // кҥӥ뤬100ʾˤʤä饨ꥢʬ 
	    io.writeMiscLog("ǳƤӥ뤬100ʾ  ꥢʬ");
	    arealock = true; // ꥢʬȶ˥ꥢå򤫤 
	    while (it.hasNext()){
	      Building b = (Building)it.next();
	      //	    System.out.println("area = "+area);
	      if (maparea[area] != null){
		Iterator it2 = maparea[area].iterator(); // 鿷 
		while(it2.hasNext()){
		  Building b2 = (Building)it2.next();
		  if(b.getID() == b2.getID())
		    cs.add(new Cluster(b));
		}
	      }
	      else{
		//System.out.println("error : maparea is null");
	      }
	    }
	  }
	  // 饹
	  // ߤ110(=clusterSizeLimit)ۤ饯饹󥰤ᡣ
	  // ׻οͤۤФȴ֤˹ʤʤäƤ뤫
	  if(cs.getClusterSize() >0 && cs.getClusterSize() <= clusterSizeLimit)
	    cs.clustering(); //  cs.getClusterSize() ϥ饹֤
	  if(cs.getClusterSize() > clusterSizeLimit){
	    //  cs.getClusterSize() ϲкҷʪΤޤ 02-11-29
	    io.writeMiscLog("饹󥰤ᡪ"); // 02-11-28
	    arealock = false; // ˽ϤAreaΥæΤǥå
	  }
	}

	// å̵ͭγǧ
	if(target == -1){ // åȤ̵ -> å
	  firedID = setTarget();
	  if(firedID != null){
	    target = firedID[0]; // ȤꤢƬΤΤ򥿡åȤ
	    // åȤν
	    String bufferTarget = "";
	    for (int i=0;i<firedID.length;i++){
	      bufferTarget += firedID[i]+" ";
	    }
	    io.writeMiscLog("åȤ :" + bufferTarget);
	  }
	  else{ // ǳƤӥ뤬ʤ -> ० <- 
	    if(miscLogMode){
	      io.writeMiscLog("ǳƤӥ뤬ʤ०");
	    }	
	    randomWalk();
	    return;
	  }
	}

	// $$ 1ܤ $$
	// åȤμդˤ뤫γǧ
	if(target_build == null)
	  target_build = 
	    objectManager.getObjectDatabase().getBuildingObject(target);

	// ##########
	// trueʤưλ
	if(oneStepAction(target_build,'1')){
	  targetInformationUpdate(target);
	  if(miscLogMode){
	    io.writeMiscLog("0 ܤ OneStepAction ǽλtarget =" + target);
	  }	
	  return;
	}

	// ##########
	// $$ 1ܤ ޤ $$

	for(int i=1;i<firedID.length && i < checkNum;i++){
	  target_build = 
	    objectManager.getObjectDatabase().getBuildingObject(firedID[i]);
	  // trueʤưλ
	  if(oneStepAction(target_build,'N')){
	    targetInformationUpdate(firedID[i]);
	    if(miscLogMode){
	      io.writeMiscLog(i + "ܤ OneStepAction ǽλtarget = "+firedID[i]);
	    }		  
	    return;
	  }
	}

	// ٤ -> Ȥˤư˾äФ뤫
	if(stayExtinguish()){
	  if(miscLogMode){
	    io.writeMiscLog("ư˾äФä");
	  }
	  dontArriveCount++;
	  //System.out.println("decidecommand(),òեstayExtinguish,dontArriveCount="+dontArriveCount+",time="+time);
	  return;
	}

	// ٤ -> Random Walk
	dontArriveCount++;
	//System.out.println("decidecommand(),òեRandomWalk,dontArriveCount="+dontArriveCount+",time="+time);
	randomWalk();
	if(miscLogMode){
	  io.writeMiscLog("०");
	}
	return;
	// #### òХե ޤ ####
      }
      // $$$$ ư ޤ $$$$
    }
    // ***** KA_SENSE ޤ *****

    else{ // Kernel褿å(Networkκ?)
      //System.err.print("KA_Message Error!! MessageHeader:");
      for(int i=0; i<msg_header.length; i++){
	//System.err.print(" "+msg_header[i]);
      }
      //System.err.println();
    }
  }

  /********************************************************************/
  // ͤϤΤʤǹư(ưor)򵯤ɤ

  boolean supplyAction(Building refuge){
    // å(refuge)ˤ ->  -> λ
    if(objectManager.hasRefugeObject(self.getPosition())){
      io.setPrefixActLog("Refilling"); // ܺ٥ޥɤΥå
      io.rest(self.getPosition()); // ˤƵ塪(ưϤΥ᥽åǼư¹)
      // AA_REST_* å, AA_REFILL_* åι
      Message mes1 = messageManager_new.makeRestMessage();
      Message mes2 = messageManager_new.makeRefillMessage();
      // ʬν°륻󥿡, Tell
      if(hasMyCenterObject()){
	if(mes1 != null){
	  messageManager_new.storeTellMessage(mes1,1);
	}
	if(mes2 != null){
	  messageManager_new.storeTellMessage(mes2,1);
	}
      }
      // Sayɬ
      if(mes1 != null){
	messageManager_new.storeSayMessage(mes1,1);
      }
      if(mes2 != null){
	messageManager_new.storeSayMessage(mes2,1);
      }
      io.writeMiscLog("ˤ -> !! target :"
		      +refuge.getID());
      dontArriveCount = 0;
      dontArriveRefugeCount = 0; // ȤΥꥻåfuruta
      cantMoveCount = 0;
      return true; // ưȤäƽλ
    }
    // åȤμդˤʤ -> åȤˤɤ失뤫γǧ
    else{
      if(miscLogMode){
	io.writeMiscLog("åȤμդˤʤ target :" + refuge.getID());
      }	      
      if(route == null || 
	 route[route.length-1] != refuge.getID()){ //ŪϤˤʤȤ
	// route̤ or routeŤ -> route׻
	if(confusionRoad != null){
	  Iterator it = confusionRoad.iterator();
	  String st = "routeκ ڤƤ RoadID:";
	  while (it.hasNext()){
	    int cRoad = ((int[])it.next())[0];
	    st += cRoad+" ";
	  }
	io.writeMiscLog(st);
	}
	else{
	io.writeMiscLog("routeκ ڤƤ RoadID:ʤ");
	}
	route = objectManager.goToDest(self.getPosition(),
				       refuge.getID(),true,confusionRoad);
      } // routeѤߤξϤΤޤ޼
      
      // routeĺɳǧ
      if(objectManager.isRouteClear(route) && 
	 route[0] != route[route.length-1]){
	if(miscLogMode){
	  String buffer = "";
	  for (int i=0;i<route.length;i++){
	    buffer = buffer + route[i] + " ";
	  }
	  io.writeMiscLog("routeĺɤʤ :" + buffer);
	}
	
	io.setPrefixActLog("ForRefilling"); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
	// ư
	// actionLog("Move","FR",route[0],route[route.length-1]);
	if(debug)
	  printRouteInfo(route);
	dontArriveCount++;
	//System.out.println("supplyAction(),롼Ȥա,dontArriveCount="+dontArriveCount+",time="+time);
	dontArriveRefugeCount++;
	if(nowPos == prevPos){
	    cantMoveCount++;
	    io.writeMiscLog("ưΤưʤƥå׿:"+cantMoveCount);
	}
	else{
	    cantMoveCount = 0;
	    io.writeMiscLog("ư褦ˤʤä");
	}
	if(cantMoveCount>4){ // 5ƥåưʤä饿åؤ
	    cantMoveCount = 0;
	    return false;
	}
	// 5ƥårefugeˤɤ失ʤä饿åȡ롼Ȥꥻå
	// ˤ꼡̥롼Ȥꤵfuruta
	if(dontArriveRefugeCount>4){
	    io.writeMiscLog("routeեå");
	    dontArriveRefugeCount = 0;
	    route = null;
	}
	return true; // ưƽλ	    
      }
      else{
	// route ĺɤä
	if(miscLogMode){
	  String buffer = "";
	  for (int i=0;i<route.length;i++){
	    buffer = buffer + route[i] + " ";
	  }
	  io.writeMiscLog("routeĺɤä: "+buffer);
	  io.writeMiscLog("ɤäƤǤ -> ΥåȤ");
	}
	// target = -1;
	route = null;
      }
    }
    return false; // ٤ƤϤ -> ꤵ줿åȤ
  }

  /********************************************************************/
  // ͤϤΤʤǹư򵯤ɤ

  boolean oneStepAction(Building target_build,char mode){
    // åȤμդˤ -> ư -> λ
    if(objectManager.getDist(self,target_build) < 
       Parameter.MAX_EXTINGUISH_RANGE){
      if(miscLogMode){
	io.writeMiscLog("åȤμդˤ target :" + target_build.getID());
      }	
      RescueObject selfPosObj = objectManager.getObject(self.getPosition());
      if(selfPosObj.getType().equals("Node")){ // ʬNodeˤ
	// ʬΰ־쥯ȤˤobjectManagerͳǡ
	selfPosX = (int)(objectManager.getPosX(self) * 1000);
	selfPosY = (int)(objectManager.getPosY(self) * 1000);
	//io.extinguish(target_build.getID(),selfPosX,selfPosY);

	if(multiExt){
	  int[] tmpTGT = new int[multiple];
	  for(int i=0;i<tmpTGT.length;i++){
	    tmpTGT[i] = target_build.getID();
	  }
	  int bID = target_build.getID();
	  int direction = (int)calcDir(selfPosX,selfPosY,target_build);
	  io.setPrefixActLog("Multiple"); // ܺ٥ޥɤΥå
	  // ̤Υѥ᡼ɲâ
	  io.extinguish(tmpTGT,direction,selfPosX,selfPosY,500);
	  // AA_EXTINGUISH åι
	  Message mes = messageManager_new.makeExtinguishMessage(bID,
								 direction,
								 selfPosX,
								 selfPosY,
								 500);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	}
	else{
	  int bID = target_build.getID();
	  int direction = (int)calcDir(selfPosX,selfPosY,target_build);
	  io.setPrefixActLog("Multiple"); // ܺ٥ޥɤΥå
	  // ̤Υѥ᡼ɲâ
	  io.extinguish(bID,direction,selfPosX,selfPosY,1000);
	  // AA_EXTINGUISH åι
	  Message mes = messageManager_new.makeExtinguishMessage(bID,
								 direction,
								 selfPosX,
								 selfPosY,
								 1000);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	}

	dontArriveCount = 0;
	return true; // òйưȤäƽλ
      }
      else if(selfPosObj.getType().equals("Road")){ // ʬRoadˤ
	// ʬΰ־쥯ȤˤobjectManagerͳǡ
	selfPosX = (int)(objectManager.getPosX(self) * 1000);
	selfPosY = (int)(objectManager.getPosY(self) * 1000);
	
	if(multiExt){
	  int[] tmpTGT = new int[multiple];
	  for(int i=0;i<tmpTGT.length;i++){
	    tmpTGT[i] = target_build.getID();
	  }
	  int bID = target_build.getID();
	  int direction = (int)calcDir(selfPosX,selfPosY,target_build);
	  io.setPrefixActLog("Multiple"); // ܺ٥ޥɤΥå
	  // ̤Υѥ᡼ɲâ
	  io.extinguish(tmpTGT,direction,selfPosX,selfPosY,500);
	  // AA_EXTINGUISH åι
	  Message mes = messageManager_new.makeExtinguishMessage(bID,
								 direction,
								 selfPosX,
								 selfPosY,
								 500);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	}
	else{
	  int bID = target_build.getID();
	  int direction = (int)calcDir(selfPosX,selfPosY,target_build);
	  io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	  // ̤Υѥ᡼ɲâ
	  io.extinguish(bID,direction,selfPosX,selfPosY,1000);
	  // AA_EXTINGUISH åι
	  Message mes = messageManager_new.makeExtinguishMessage(bID,
								 direction,
								 selfPosX,
								 selfPosY,
								 1000);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	}
	dontArriveCount = 0;
	return true; // òйưȤäƽλ
      }
    }
    
    // åȤμդˤʤ -> åȤˤɤ失뤫γǧ
    else{
      if(miscLogMode){
	io.writeMiscLog("åȤμդˤʤ target :" + target_build.getID());
      }	      
      if(route == null || 
	 route[route.length-1] != target_build.getEntrance()){ 
	// route̤ or routeŤ -> route׻
	route = objectManager.goToDest(self.getPosition(),
				       target_build.getEntrance(),true,confusionRoad);
      } // routeѤߤξϤΤޤ޼
      
      // routeĺɳǧ
      if(objectManager.isRouteClear(route) && 
	 route[0] != route[route.length-1]){
	if(miscLogMode){
	  String buffer = "";
	  for (int i=0;i<route.length;i++){
	    buffer = buffer + route[i] + " ";
	  }
	  io.writeMiscLog("routeĺɤʤ :" + buffer);
	}
	io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
	// ư
	// actionLog("Move",null,route[0],route[route.length-1]);
	if(debug)
	  printRouteInfo(route);
	dontArriveCount++;
	//System.out.println("oneStepAction(),롼Ȥ,dontArriveCount="+dontArriveCount+",time="+time);
	return true; // ưƽλ	    
      }
      else{
	// route ĺɤä
	if(miscLogMode){
	  String buffer = "";
	  for (int i=0;i<route.length;i++){
	    buffer = buffer + route[i] + " ";
	  }
	  io.writeMiscLog("routeĺɤä: "+buffer);
	  io.writeMiscLog("ɤäƤǤ -> ΥåȤ");
	}
	target = -1;
	route = null;
      }
    }
    return false; // ٤ƤϤ
  }

  /********************************************************************/
  // ʬƤ뤫ɤ椬ҤɤȤ
  // ToDo : ߥ졼󥹥ƥåפ 300 Ǥ벾꤬褯ʤ
    /*
  boolean AmIinjured_gotoRefuge(){
    if (self.getDamage() != 0){
      if ((self.getHP()-self.getDamage()*(300-time)) < 0){
	// Τޤޤȳμ¤˻ǤޤΤ
	// 	
	if(objectManager.hasRefugeObject(self.getPosition())){ 
	  // ʬrefugeˤ
	  io.setPrefixActLog("Curing"); // ܺ٥ޥɤΥå
	  io.rest(self.getPosition());
	  // AA_REST_* åι
	  Message mes = messageManager_new.makeRestMessage();
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	  io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤ -> ٷ");
	  // actionLog("Rest","CR",0,0);
	  return true;
	}
	else{
	  // ذư
	  // Ǥᤤ򸡺
	  refugeIDList = objectManager.sortByDist(objectManager.getPosX(self),
						objectManager.getPosY(self),
						refugeList);
	  for(int i=0;i<refugeIDList.length;i++){
	    route = 
	      objectManager.goToDest(self.getPosition(),refugeIDList[i],true);
	    
	    if(objectManager.isRouteClear(route)){ 
	      // routeĺɤʤ -> ư -> λ
	      io.setPrefixActLog("ForCuring"); // ܺ٥ޥɤΥå
	      io.move(route,self.getPosition());
	      String buffer = "";
	      for (int j=0;j<route.length;j++){
		buffer = buffer + route[j] + " ";
	      }
	      io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤʤ -> route ĺɤʤ -> ư (ϩ:" + buffer +")");
	      // ư
	      // actionLog("Move","FC",route[0],route[route.length-1]);
	      return true; // ưƽλ
	    }
	    else{
	      // routeĺɤ -> ΥåȤ
	    }
	  } // for loop
	  // ˤʤȤʤ,ϩʤ
	  // ToDo : ۥȤ˺³ԤǤΤ(Τޤޤȳμ¤˻)
	  io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤʤ -> ĺɤäƤɤˤ⤤ʤ -> ³");
	  return false;
	}
      }
      else if(self.getDamage() > 30){
	// ϤΤޤޤǻʤʤ椬ҤɤʤäƤƤΤ
	// ߤλŻʤɤˤä񤹤
	// ToDo : Ȥľɬפ	
	
      }
    }
    // ᡼ʤorޤ񤹤ɬפʤ
    return false;
  }
    */
  /********************************************************************/
  // Ȥꤢ᤯˲кҤоäʾΤΤ

  boolean stayExtinguish(){
    // åȤμդˤ -> ư -> λ
    int[] list = objectManager.getNearBurningBuilding(self);
    if(list == null)
      return false;

    Building target_build = 
      objectManager.getObjectDatabase().getBuildingObject(list[0]);
    return oneStepAction(target_build,'P');
  }

  /********************************************************************/

  void printRouteInfo(int[] route_array){
    for(int i=0;i<route_array.length;i++){
      if(objectManager.hasNodeObject(route_array[i])){
	//System.out.println("Node: " + route_array[i]);
      }
      else if(objectManager.hasRoadObject(route_array[i])){
	Road rob = objectManager.getObjectDatabase().getRoadObject(route_array[i]);
	rob.printInfo();
      }
      else{
	//System.out.println("????: " + route_array[i]);
      };
    };
  }

  /********************************************************************/
    /*
  void randomWalk(){
    // ToDo : objectManager.getRandomWalkRoute(self) null ֤Ƥ
    // 롣Ĵ
    route = objectManager.getRandomWalkRoute(self);
    target = -1; // åȤꥻå

    if (route != null){
      io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
      io.move(route,self.getPosition());
      // actionLog("Move","RD",route[0],route[route.length-1]);
    }
    else{
      // ToDo : ΤޤޤǤϿưǤʤʤäƤޤ
      io.setPrefixActLog("CannotMoving"); // ܺ٥ޥɤΥå
      io.rest(self.getPosition());
      io.writeMiscLog("randomWalk()  null ֤Ĵ");
      System.err.println("randomwalk error");
    }
  }
    */
  /********************************************************************/

  double calcDir(int selfPosX,int selfPosY,Building build){
    double X = build.getX() - selfPosX;
    double Y = build.getY() - selfPosY;
    double Ydir = Math.atan(-X/Y);
    double dir = Ydir * 1296000 / (2 * Math.PI);
    //System.err.println("Ext Dir : " + dir);
    
    return dir;
  }

  /********************************************************************/
  // hear & say
    /*
  public void receiveHear(Vector message){
    int senderID = msg_header[3];
    byte[] msg_data = (byte[])message.get(1); // åǡ

    // åΥॹפ򸫤
    if(prevMsgTime != time){
      rcvMsg = 0;
    }

    // ɤåϤ
    // ȤΰջַˤѤƤʤȤϤ
    // εȿǽΤǡ˺뤳
    // io.writeHearLog(KK_RCV,senderID,null);

    // å
    // !!! åParameter
    if (rcvMsg < Parameter.MAX_AGENT_RCVMSG_NUM){
      // åʾäƤʤ
      if (objectManager.hasFireBrigadeObject(senderID)
          && senderID != id && !alreadyReceive(senderID) ||
          objectManager.hasFireStationObject(senderID)){
	// ԤFireBrigade
	// ,ʬǤʤ
	// ޤFireStation

	// åȻϿ
	prevMsgTime = time;
	rcvMsg++;

	// ToDo : MessageRoboCup2002 ϰٽ clear() ʤɤ
	// ƽǤ褦ˤ٤Х饹̾ѤäƤ ok!
	msgRC2002 = new MessageRoboCup2002();
	// msgRC2002.parseHearInfo(msg_header,msg_data,time); // Ϥ
	// ʲȤĢ碌
	int[] msg_data_int = new int[msg_data.length-3];
	msg_data_int[0] = (((int)msg_data[0] & 0xFF) << 24) | 
	    (((int)msg_data[1] & 0xFF) << 16) | 
	    (((int)msg_data[2] & 0xFF) << 8) | 
	    ((int)msg_data[3] & 0xFF); // åǡĹ
	for(int i=4,counter=1; i < msg_data.length; i++,counter++){
	    msg_data_int[counter] =(int)msg_data[i]; // ĤʬintѴ
	}
	int[] msg = mergeMessage(msg_header,msg_data_int); // åη
	// ȤĢ碌ޤǡ
	msgRC2002.parseHearInfo(msg,time); // ˺

	int command = msgRC2002.getCommand();
	if(command == -1){
	  System.out.println("̤ΤΥåʤΤ̵뤹롣");
	  return;
	}
	int[] pTarget = {msgRC2002.getTarget(0)}; // getTarget(0)Ͼ
	// int[] pTarget = msgRC2002.getTarget(); // ä(02-11-25)
       	// System.out.println(" pTarget(FB) Ĺ "+ pTarget.length);
	io.writeHearLog(command,senderID,pTarget);  // check(02-11-25)

	if(command == KK_EXTINGUISH){
	  if(debug){
	    //System.out.println("Receive.Objective : " + objective);
	    //System.out.println("Receive.Target : " + pTarget);
	  }
	  
	  setSayCount(pTarget); // VersionǤsetSayCountʤ(02-11-28)
	}
	else if(command == KK_CLEAR){
	  for(int j=0;j<pTarget.length;j++){
	    if(objectManager.hasRoadObject(pTarget[j])){
	      Road r = objectManager.getObjectDatabase().
		getRoadObject(pTarget[j]);
	      r.setBlockForce(0); // åˤĺɤ0
	    }
	  }
	}
	else{
	  io.writeMiscLog("Extinguish,Clearʳ");
	  // Extinguish,Clearʳ
	  io.writeMiscLog("command : "+command);
	  String tmp_buf = "";
	  for (int j=0;j<pTarget.length;j++){
	      tmp_buf = pTarget[j] + " ";
	  }
	  io.writeMiscLog("Id:"+ tmp_buf);
	}
      }
      // μCivilianAmbulanceTeamPoliceForceΤȤޤǤޤ
      // ʸˤϤ
      else if(objectManager.hasRescueManObject(senderID)){
      }
      // ̱"help me"ȶǤ 04-04-23
      else if(objectManager.hasCivilianObject(senderID)
	      && !alreadyReceive(senderID)){
	boolean existFS = false;
	if(objectManager.getFireStationObjectNum() > 0){ // ɽ𤬤
	  existFS = true;
	}
	// ATǤʤΤfalseᤦ
	tellBurySaidCivilianMessage(self,existFS,false);
      }
    }
    // å ޤ
  }
    */
  /********************************************************************/
  /** ƸİưΥȤˤȤä,٤åɤȽꤹ롣
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected boolean shouldReadMessage(int[] msg_header){
    boolean isReceive = false;
    int senderID = msg_header[3];
    if(hasMyCenterObject()){ // °륻󥿡, 
      if(msg_header[0] == KA_HEAR_TELL){ // HearTellλ, 
	if(rcvHearTellMsgCount < 3 &&
	   objectManager.hasFireStationObject(senderID)){ // 3̤,FS
	  rcvHearTellMsgCount++; // ʹ򥫥
	  isReceive = true;
	}
      }
      else if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 1 &&  // ޤ٤ʹƤʤ,
	   objectManager.hasFireBrigadeObject(senderID)){   // ʬʳFB
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    else{ // °륻󥿡ʤ, 
      if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 3 &&  // 3̤, 
	   objectManager.hasFireBrigadeObject(senderID)){   // ʬʳFB
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    return isReceive;
  }

  /********************************************************************/
  /** ߽, ⤷ϻ꤫åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * , ϤåȤä, ǡ١ȥ֥ȤιԤʤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForRescueAgent(int ka_command,
					      int senderID, Message message){

    //  AA_JUST_FIRE_*, AA_EXTINGUSH_FIN λν򤹤Τ,
    // ֤ʤΤǳ䰦
    // ToDo:ǯˤϺꤿ!?

    return null; // ߤä֤ͤϤʤΤnull֤
  }

  /********************************************************************/
  /** ̱åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * ߤΤȤ, Υ᥽åɤǼ¹Ԥ뤳ȤϤʤΤǲ⤷ʤ֤롣
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForCivilian(int ka_command,
					   int senderID, String message){
    // ⤬Ǥ뤳Ȥϲʤ
    return null; // ⤷ʤΤnull֤
  }

  /********************************************************************/
  /**
   *  target ֤
   **/

  public int[] setTarget(){
    Vector ignitionBuilding = new Vector(); // вľηʪϿ
    Vector burningBuilding = new Vector();  // ηʪϿ

    double srcX = objectManager.getPosX(self);
    double srcY = objectManager.getPosY(self);

    // ToDo : 饹Υθ褦ˤ
    // Ȥꤢֶᤤ饹ͥŪ˾òФ

    Cluster target1stCluster = null;
    Cluster target2stCluster = null;    
    
    //  ClusterSizeclusterSizeLimit(=110)ۤCluster϶nullΤޤ
    if (cs.getClusterSize() > 0 && cs.getClusterSize() <= clusterSizeLimit){
      if (cs.getClusterSize() > 1 ){
	if (cs.getCluster(0).getDistance(srcX,srcY) < 
	    cs.getCluster(1).getDistance(srcX,srcY)){
	  target1stCluster = cs.getCluster(0);
	  target2stCluster = cs.getCluster(1);
	}
	else{
	  target1stCluster = cs.getCluster(1);
	  target2stCluster = cs.getCluster(0);
	}
	for (int i=2;i<cs.getClusterSize();i++){
	  Cluster tmpCluster = cs.getCluster(i);
	  if (tmpCluster.getDistance(srcX,srcY) <
	      target1stCluster.getDistance(srcX,srcY)){
	    target2stCluster = target1stCluster;
	    target1stCluster = cs.getCluster(i);
	  }
	  else if (tmpCluster.getDistance(srcX,srcY) <
		   target2stCluster.getDistance(srcX,srcY)){
	    target2stCluster = cs.getCluster(i);
	  }
	}
      }
      else if (cs.getClusterSize() == 1){
	// 饹Υ(饹) 1 
	target1stCluster = cs.getCluster(0);
	io.writeMiscLog("ϥ饹Ĥʤ衣");
      }
    }

    Cluster targetCluster = null;

    //   clusterSizeLimit ۤƤ targetCluster  null Τޤ
    if (target1stCluster != null && target2stCluster != null){
      if (target1stCluster.getSize() == 1){
	//  1stClusterǿʷʪˤλ 02-11-29
	Building b = (Building)target1stCluster.getElements(0);
	if (b != null){
	  if (b.getAreaGround() > 100000){
	    targetCluster = target2stCluster;
	  }
	  else{
	    targetCluster = target1stCluster;
	  }
	}
      }
      else{
	targetCluster = target1stCluster;
      }
    }
    else if (target1stCluster != null){
      // 饹Υ(饹) 1 
      targetCluster = target1stCluster;
    }

    
    if (targetCluster != null && time > 15){
      // 饹Ѥɸ
      // time > 15 ϥ饹ꤹޤͻҤߤ뤿
      // кҷʪclusterSizeLimit(=110)ʾClusteringȤʤ(׻)
      // clusterSizeLimitξ targetCluster != null ˴ޤޤƤΤ
      io.writeMiscLog("饹Ѥɸ"); // 
      Iterator it = targetCluster.iterator();
      while(it.hasNext()){
	Building ro = (Building)it.next();
	if (objectManager.getTime() - ro.getIgnitionTime() < 15){
	  io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- less than 15 minites");
	  // вľͥŪ˾ä
	  // ToDo : Υͤʤ
	  ignitionBuilding.add(ro);
	}
	else if (objectManager.getTime() - ro.getIgnitionTime() < 50){
	  io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- more than 15 minites(~50)");	  
	  // ĹǳƤӥ
	  burningBuilding.add(ro);
	}
      }
      if (ignitionBuilding.size()==0 && burningBuilding.size()==0){
	io.writeMiscLog("ɸˤ饹ϰʤΤ¾ذư"); // 
	arealock = false; // ̤Targetɸˤִ֥ꥢå 
	Vector burnB = objectManager.getBurningBuilding();
	if (burnB != null){
	  it = burnB.iterator();
	  while(it.hasNext()){
	    Building ro = (Building)it.next();
	    if (objectManager.getTime() - ro.getIgnitionTime() < 15){
	      io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- less than 15 minites");
	      // вľͥŪ˾ä
	      ignitionBuilding.add(ro);
	    }
	    else{
	      io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- more than 15 minites(~)");
	      // ĹǳƤӥ
	      burningBuilding.add(ro);
	    }
	  }
	}
      }
    }
    else{
      // 饹Ѥʤɸ
      io.writeMiscLog("饹Ѥʤɸ(˽? or 15step̤?)"); // 
      arealock = false; // ˽᤯AreaΥæΤǥå 
      Vector burnB = objectManager.getBurningBuilding();
      if (burnB != null){
	Iterator it = burnB.iterator();
	while(it.hasNext()){
	  Building ro = (Building)it.next();
	  if (objectManager.getTime() - ro.getIgnitionTime() < 5){
	    io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- less than 5 minites");
	    // вľͥŪ˾ä
	    ignitionBuilding.add(ro);
	  }
	  else if (objectManager.getTime() - ro.getIgnitionTime() < 40){
	    io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- more than 5 minites(~40)");	  
	    // ĹǳƤӥ
	    burningBuilding.add(ro);
	  }
	}
      }      
    }
    int[] ret;
    if(ignitionBuilding.size() == 0 && burningBuilding.size() == 0){
      return null;
    }
    else{
      int[] ign_ret = new int[1];
      int[] bur_ret = new int[1];
      int ign_len = 0;
      int bur_len = 0;
      if (ignitionBuilding.size() != 0){
	// ʪ礭˥
	ign_ret = objectManager.sortByBuildingSize(ignitionBuilding);
	ign_len = ign_ret.length;
      }
      if (burningBuilding.size() != 0){
	// ʪ礭˥
	bur_ret = objectManager.sortByBuildingSize(burningBuilding);
	bur_len = bur_ret.length;
      }      
      
      ret = new int[ign_len+bur_len];
      int index = 0;
      if (ignitionBuilding.size() != 0){
	for (int i=0;i<ign_len;i++){
	  ret[index++] = ign_ret[i];
	}
      }
      if (burningBuilding.size() != 0){      
	for (int i=0;i<bur_len;i++){
	  ret[index++] = bur_ret[i];
	}      
      }
    }
    return ret;
  }
  
  /********************************************************************/
  /**
   *  target ֤ No.2
   *  ʬ ID λ 1 ܤŬڤʥ饹ô
   *  ʬ ID λ 2 ܤŬڤʥ饹ô
   *  () Υ᥽å,Ƥ롣(5/29)
   *  ToDo : Ŭڤ򥳡ǥ󥰤뤳
   **/
    /*
  public int[] setTarget2(){    
    Vector ignitionBuilding = new Vector(); // вľηʪϿ
    Vector burningBuilding = new Vector();  // ηʪϿ

    // 졢ȤäƤʤäꤹ
    double srcX = objectManager.getPosX(self);
    double srcY = objectManager.getPosY(self);

    // ֤ͤ褦
    int[] ret;

    // ToDo : 饹Υθ褦ˤ
    // Ǥϥ饹ʿѱپѤŬڤٹȤ

    Cluster no1Cluster = null;
    Cluster no2Cluster = null;
    Cluster targetCluster = null;

    if (cs.getClusterSize() > 0){
      if (cs.getClusterSize() > 1){
	// 饹 2 İʾ夢Τ,ᤤ 2 Ĥɤ餫
	// ͤ򥻥å
	if ((cs.getCluster(0)).getAVGAreaTotal() < 
	    (cs.getCluster(1)).getAVGAreaTotal()){
	  no1Cluster = cs.getCluster(0);
	  no2Cluster = cs.getCluster(1);
	}
	else{
	  no1Cluster = cs.getCluster(1);
	  no2Cluster = cs.getCluster(0);	  
	}
	// ƥ
	for (int i=2;i<cs.getClusterSize();i++){
	  Cluster tmpCluster = cs.getCluster(i);
	  if (no1Cluster.getAVGAreaTotal() > 
	      tmpCluster.getAVGAreaTotal()){
	    no2Cluster = no1Cluster;	    
	    no1Cluster = tmpCluster;    
	  }
	  else if (no2Cluster.getAVGAreaTotal() > 
	      tmpCluster.getAVGAreaTotal()){
	    no2Cluster = tmpCluster;   
	  }
	}
	
	// ʬ ID ʤ 1 ֤ΤΡʤ 2 
	if ((id % 2) == 1){
	  targetCluster = no1Cluster;
	}
	else{
	  targetCluster = no2Cluster;
	}
      }
      else{
	// 饹 1 ĤʤΤǤɸˤ
	targetCluster = cs.getCluster(0);
      }
    }

    if (targetCluster != null){
      io.writeMiscLog(targetCluster.toString());
    }

    if (targetCluster != null && time > 10){
      // 饹Ѥɸ
      // time > 10 ϥ饹ꤹޤͻҤߤ뤿
      Iterator it = targetCluster.iterator();
      while(it.hasNext()){
	Building ro = (Building)it.next();
	if (objectManager.getTime() - ro.getIgnitionTime() < 5){
	  io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- less than 5 minites");
	  // вľͥŪ˾ä
	  // ToDo : Υͤʤ
	  ignitionBuilding.add(ro);
	}
	else{
	  io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- more than 5 minites");	  
	  // ĹǳƤӥ
	  burningBuilding.add(ro);
	}
      }
      if(ignitionBuilding.size() == 0 && burningBuilding.size() == 0){
	return null;
      }
      else{
	int[] ign_ret = new int[1];
	int[] bur_ret = new int[1];
	int ign_len = 0;
	int bur_len = 0;
	if (ignitionBuilding.size() != 0){
	  // 饹濴ΥƤ֤˥
	  double[] dist = new double[ignitionBuilding.size()];
	  ign_ret = new int[ignitionBuilding.size()];
	  int index = 0; 
	  for (int i=0;i<ignitionBuilding.size();i++){
	    Building b = (Building)ignitionBuilding.get(i);
	    dist[index++] = targetCluster.getDistance((double)b.getX(),(double)b.getY());
	  }
	  // ߤǤä Position Sort 򤪤ʤ 
	  for (int i=0;i<dist.length;i++){
	    int count = 0;
	    for (int j=0;j<dist.length;j++){
	      if (dist[j]< dist[i]){
		count++;
	      } 
	    }
	    ign_ret[count] = ((Building)ignitionBuilding.get(i)).getID();
	    ign_len = ign_ret.length;
	  }
	}
	if (burningBuilding.size() != 0){
	  // 饹濴ΥƤ֤˥
	  double[] dist = new double[burningBuilding.size()];
	  bur_ret = new int[burningBuilding.size()];
	  int index = 0; 
	  for (int i=0;i<burningBuilding.size();i++){
	    Building b = (Building)burningBuilding.get(i);
	    dist[index++] = targetCluster.getDistance((double)b.getX(),(double)b.getY());
	  }
	  // ߤǤä Position Sort 򤪤ʤ 
	  for (int i=0;i<dist.length;i++){
	    int count = 0;
	    for (int j=0;j<dist.length;j++){
	      if (dist[j]< dist[i]){
		count++;
	      } 
	    }
	    bur_ret[count] = ((Building)burningBuilding.get(i)).getID();
	    bur_len = bur_ret.length;
	  }
	}      
	ret = new int[ign_len+bur_len];
	int index = 0;
	if (ignitionBuilding.size() != 0){
	  for (int i=0;i<ign_len;i++){
	    ret[index++] = ign_ret[i];
	  }
	}
	if (burningBuilding.size() != 0){      
	  for (int i=0;i<bur_len;i++){
	    ret[index++] = bur_ret[i];
	  }      
	}
      }      
    }
    else{
      // 饹Ѥʤɸ
      Vector burnB = objectManager.getBurningBuilding();
      if (burnB != null){
	Iterator it = burnB.iterator();
	while(it.hasNext()){
	  Building ro = (Building)it.next();
	  if (objectManager.getTime() - ro.getIgnitionTime() < 5){
	    io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- less than 5 minites");
	    // вľͥŪ˾ä
	    ignitionBuilding.add(ro);
	  }
	  else{
	    io.writeMiscLog("("+objectManager.getTime()+")Agent ID:"+id+" Bulding ID:"+ro.getID()+"  <- more than 5 minites");	  
	    // ĹǳƤӥ
	    burningBuilding.add(ro);
	  }
	}
      }
      if(ignitionBuilding.size() == 0 && burningBuilding.size() == 0){
	return null;
      }
      else{
	int[] ign_ret = new int[1];
	int[] bur_ret = new int[1];
	int ign_len = 0;
	int bur_len = 0;
	if (ignitionBuilding.size() != 0){
	  // ʪ礭˥
	  ign_ret = objectManager.sortByBuildingSize(ignitionBuilding);
	  ign_len = ign_ret.length;
	}
	if (burningBuilding.size() != 0){
	  // ʪ礭˥
	  bur_ret = objectManager.sortByBuildingSize(burningBuilding);
	  bur_len = bur_ret.length;
	}      
	
	ret = new int[ign_len+bur_len];
	int index = 0;
	if (ignitionBuilding.size() != 0){
	  for (int i=0;i<ign_len;i++){
	    ret[index++] = ign_ret[i];
	  }
	}
	if (burningBuilding.size() != 0){      
	  for (int i=0;i<bur_len;i++){
	    ret[index++] = bur_ret[i];
	  }      
	}
      } 
    }
    return ret;
  }
    */
  /********************************************************************/
  // Ĥ˥åäƤ뤫
    /*
  boolean alreadyReceive(int sdID){
    for(int i=0;i<senderList.length;i++){
      if(senderList[i] == 0){
	senderList[i] = sdID;
	break;
      }
      else if(senderList[i] == sdID){
	return true;
      }
    }

    return false;
  }
    */
  /********************************************************************/
  // senderList Υꥢ
    /*
  void clearSenderList(){
    for(int i=0;i<senderList.length;i++){
      senderList[i] = 0;
    }
  }
    */
  /********************************************************************/
  // ήƤåȤ򥫥  VersionˤϤ⤦̵!! (02-11-28)
    /*
  void setSayCount(int[] tgt){
    for(int j=0;j<tgt.length;j++){
      for(int i=0;i<sayTargetList.length;i++){
	if(sayTargetList[i][0] == tgt[j]){
	  sayTargetList[i][1]++;
	  break;
	}
	else if(sayTargetList[i][0] == 0){
	  sayTargetList[i][0] = tgt[j];
	  sayTargetList[i][1]++;
	  break;
	}
      }
    }
  }
    */
  /********************************************************************/
  // ȤID֤  VersionˤϤ⤦̵!! (02-11-28)
    /*
  int getSayTarget(){
    int ret = 0;
    int count = 0;
    for(int i=0;i<sayTargetList.length;i++){
      if(count < sayTargetList[i][1]){
	ret = sayTargetList[i][0];
	count = sayTargetList[i][1];
      }
      else if(sayTargetList[i][0] != 0 && count == sayTargetList[i][1]){
	Building b1 = objectManager.getObjectDatabase().getBuildingObject(ret);
	Building b2 = objectManager.getObjectDatabase().
	  getBuildingObject(sayTargetList[i][0]);

	if(objectManager.calcExtinguishNum(b1)>
	   objectManager.calcExtinguishNum(b2)){
	  ret = sayTargetList[i][0];
	  count = sayTargetList[i][1];	  
	};
      }
    };

    return ret;
  }
    */
  /********************************************************************/
    //    VersionˤϤ⤦̵!! (02-11-28)
    /*
  void printSayTarget(){
    for(int i=0;i<sayTargetList.length;i++){
      //System.out.print(sayTargetList[i][0] + " : " + sayTargetList[i][1]+ " / ");
    };
  }
    */
  /********************************************************************/
    //  VersionˤϤ⤦̵!! (02-11-28)
    /*
  boolean checkSayTarget(Civilian self){
    sayTarget = getSayTarget();
    //printSayTarget();

    clearSayTarget(); // ꥢ

    if(sayTarget != 0){ // ʹɸХå
      Building target_build = 
	objectManager.getObjectDatabase().getBuildingObject(sayTarget);

      // ǳƤʤ̲
      if(!target_build.isBurnningLittle())
	return false;

      if(oneStepAction(target_build,'S'))
	return true;

    };
    
    return false;
  }
    */
  /********************************************************************/
  // ȤΥꥢ  VersionˤϤ⤦̵!! (02-11-28)
    /*
  void clearSayTarget(){
    for(int i=0;i<sayTargetList.length;i++){
      sayTargetList[i][0] = 0;
      sayTargetList[i][1] = 0;
    };
  }
    */
  /********************************************************************/
  // checkSayTarget()NullPointerExceptionΤ
  // ȤꤢɤƤФʤ褦ˤ  Versionˤ̵!! (02-11-28)
    /*
  void sayExtinguishMessage(int tgtID){
    int[] t = {tgtID};
    //io.say(KK_EXTINGUISH,t);
    // io.writeHearLog(KK_TELL_EXT,id,t); // io.saytellLog()ˤ٤!?
  }
    */
  /********************************************************************/
  // Ω˵߱åȯ 㤦ΤĴ!(02-11-28)
    /*
  void tellHaltMessage(int selfPos){
    if(fireStationList != null && fireStationList[0] > 0){
      int[] t = {selfPos};
      //io.tell(KK_HALT,t);
      // ǤAA_HALT_ATåästoreǤʤ)
      // io.writeHearLog(KK_TELL_HLT,id,t); // io.saytellLog()ˤ٤!?
      // ºݤio.saytellLog()ߤʤΤǤɤ!?
      return;
    }
    else{
      //System.err.println(id + " has no FS!!");
      sayBuffer = null;
      return;
    }
  }
    */
  /********************************************************************/
  // ޤäƤ̤꤬ͤ˸Ȥ
    /*
  void tellBuryMessage(int[] destID){
    if(fireStationList != null && fireStationList[0] > 0){
      for (int i=0;i<destID.length;i++){
	Civilian cv = objectManager.getCivilianObject(destID[i]);
	if (cv != null){
	  // RescueManObjectä
	  if(objectManager.hasRescueManObject(destID[i])){
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED_RO,cv.getPosition());
		msgRC2002.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED_RO,cv.getPosition());
		msgRC2002.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
	        msgRC2002 = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		msgRC2002.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO,cv.getPosition());
		msgRC2002.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(msgRC2002);
	  }
	  else{ // RescueObjectǤʤʤCivilianä
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
	        msgRC2002 = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED,cv.getPosition());
	        msgRC2002.setBuffering(5);
	      }
	      else{
	        // cv.getDamage() >= 20
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED,cv.getPosition());
		msgRC2002.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		msgRC2002.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		msgRC2002 = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED,cv.getPosition());
		msgRC2002.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(msgRC2002);
	  }
	}
	else{
	  io.writeMiscLog("cannot get Civilian Object id = "+destID[i]);
	}
      }
      return;
    }
    else{
      // ToDo : say Ф󤸤ʤ
      if (sndMsg < Parameter.MAX_AGENT_SNDMSG_NUM && destID.length > 0){
	Civilian cv = objectManager.getCivilianObject(destID[0]);
	io.writeMiscLog("ߤΥå : " +sndMsg);
	io.writeMiscLog("ޤäƤͤ򸫤 id = " + cv.getPosition());
	
	MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_BURY,cv.getPosition());
	//io.say(snd_msg);
	sndMsg++;
	return;
      }
    }
  }
    */
  /********************************************************************/
  // ɽIDꥹȤκ
    /*
  int[] getFireStationList(){
    int[] tmp = new int[8];
    int count = 0;

    Enumeration enum = 
      objectManager.getObjectDatabase().getFireStationTable().keys();
    while(enum.hasMoreElements()){
      Integer d = (Integer)enum.nextElement();
      tmp[count] = d.intValue();
      count++;
    }

    int[] ret = null;
    if (count != 0){
      ret = new int[count];
      System.arraycopy(tmp,0,ret,0,count);
    }
    return ret;
  }
    */
  /********************************************************************/
  // ʬưʤå
    /*
  boolean checkHalt(RescueObject rsob){
    if(rsob.getType().equals("Road") || rsob.getType().equals("Node")){
      if(nowPos == prevPos){
	samePosCount++;
	// ޤäƤ뤫ɤΥå
	if(samePosCount > 3){ // 3ʾƱˤ
	  if(rsob.getType().equals("Road")){
	    Road rd = (Road)rsob;
	    if(rd.getBlock() > 0){
	      tellHaltMessage(rd.getID());
	      System.err.println(id + " tell Halt!!");
	      samePosCount = 0;
	      return true;
	    }
	  }
	  else if(rsob.getType().equals("Node")){
	    Node nd = (Node)rsob;
	    int[] edge = nd.getEdge();
	    boolean loopEnd = false;
	    for(int i=0;i<edge.length;i++){
	      RescueObject rt = objectManager.getObject(edge[i]);
	      if(rt.getType().equals("Road")){
		Road rd = (Road)rt;
		if(rd.getBlock() < 1){ // ̤ƻä롼פȴ
		  loopEnd = true;
		  break;
		}
	      }
	    } // for loop
	    if(!loopEnd){
	      tellHaltMessage(nd.getID());
	      // System.err.println(id + " tell Halt!!");
	      samePosCount = 0;		
	      return true;
	    }
	  } // if Node
	}
      }
      else{
	samePosCount = 0;
      }
    }
    return false;
  }
    */
  /********************************************************************/
  // Ƥʤνڤå
  // 3 ƥåװʾƱƻ̤ȤƼԤƤ
  // ̩ : Position Ʊ,route Τμ road Ʊ
  // -> ƻ̤Τ򤢤¾̤뤳
  /*
  boolean checkConfusion(RescueObject rsob){
    if(rsob.getType().equals("Road") || rsob.getType().equals("Node")){
      if(nowPos == prevPos){
	int second_rd = -1;
	if (route != null){
	  if (route.length > 1){
	    RescueObject rt = objectManager.getObject(route[1]);
	    if(rt.getType().equals("Road")){
	      // nowPos  Node Ǽ Road
	      second_rd = ((Road)rt).getID();
	    }
	    else{
	      if (route.length > 2){
		RescueObject rt2 = objectManager.getObject(route[2]);
		if(rt2.getType().equals("Road")){
		  // nowPos  Road Ǽ Node Ǽ Road
		  second_rd = ((Road)rt2).getID();
		}
		else{
		  io.writeMiscLog("checkConfusion error : node - node - node ");
		}
	      }
	      else{
		io.writeMiscLog("checkConfusion error : route.length <= 2");
	      }
	    }
	  }
	  if (second_rd != -1){
	    if (tmp_confusionRoad == second_rd){
	      sameRouteCount++;
	    }
	    else{
	      tmp_confusionRoad = second_rd;
	      sameRouteCount = 0;
	    }
	  }
	  else{
	    // 2 ܤ Road ʤ
	    io.writeMiscLog("checkConfusion error : node - node - node ");
	  }
	}
	else{
	  // Route ʤ
	  tmp_confusionRoad = -1;
	  sameRouteCount = 0;
	}
	if (sameRouteCount > 1){ // 3stepϿˤ sameRouteCount > 1
	  sameRouteCount = 0;
	  return true;
	}
      }
      else{
	// Ȱ֤㤦Τ,ϰưƤ
	tmp_confusionRoad = -1;
	sameRouteCount = 0;
      }
    }
    return false;
  }
  */
  /********************************************************************/
  // ʬưʤå

  boolean checkMayBeHalt(){
    if (dontArriveCount >= 3){
      // AA_HALT_* åι
      Message mes = messageManager_new.makeHaltMessage();
      if(mes != null){
	// ʬν°륻󥿡, Tell
	if(hasMyCenterObject()){
	  messageManager_new.storeTellMessage(mes,1);
	}
	// Sayɬ
	messageManager_new.storeSayMessage(mes,1);
      }
      io.writeMiscLog("checkMayBeHalt(),ưƤʤ,dontArriveCount="
		      +dontArriveCount+",time="+time);
      dontArriveCount++;
      return true;
    }
    return false;
  }

  /********************************************************************/
  // Ʊʪ򲿥ƥå׾òФƤ뤫Ͽ
  
  void targetInformationUpdate(int target){
    if (extinguish_prev_target == -1){
      extinguish_prev_target = target;
      extinguish_step = 1;      
    }
    else{
      if (extinguish_prev_target == target){
	extinguish_step++;
      }
      else{
	extinguish_prev_target = target;
	extinguish_step = 1;      	
      }
    }
  }

  /********************************************************************/
  // òХƥå׿֤

  int getExtinguishStep(){
    return extinguish_step;
  }

  /********************************************************************/
}
