package rescueAgent.AreaMap;

//import java.io.*;
import java.util.*;

/**
 * A*르ꥺѤϩõ
 **/

class AStar{
  Hashtable route;
  Hashtable map;
  Vector tmpVec = new Vector(); // temporary Vector

  /**********************************************************************/

  AStar(Hashtable routeTable){
    route =  routeTable;
    Enumeration rt = routeTable.keys();
    map = new Hashtable();
  }

  /**********************************************************************/
  /**
   *<BR><BR>
   * @param start ID
   * @param finish ID
   **/

  int[] AStarSearch(int start,int finish,double destX,double destY,int time){
    Vector out = new Vector();
    Vector temp = new Vector();
    
    // ,
    int begin = start;
    int end = finish;
    
    //get top node off of vector and see if it is destination	
    temp.addElement(new Integer(begin));
    out.addElement(new Integer(begin));
    
    //   if so return... nothing to do
    if(start==finish){
      return getReturn(out);
    };
    
    //loop
    Enumeration j = temp.elements();       

    while (j.hasMoreElements()){
      //  is queue empty? if so return failure  
      //  else get top node off temp
      Integer z = (Integer)temp.remove(0);
      
      //see if it is destination if so return successful
      if(z.intValue()==finish) {
	return getReturn(out);		
      }
      else{
	//else grab each edge city, sort by closest distance
	//to destination city and put at front of queue
	Object[] next = getExistRoute(z.intValue(),destX,destY,time);
	
	for(int i=0;i<next.length;i++){
	  Integer tc1 = (Integer)next[i];
	  if(out.contains(tc1)){
	  }
	  else{
	    out.add(0, tc1);
	    temp.add(0, tc1);
	  }
	}
      }
    };//end loop
    
    return getReturn(out);
  }
  
  /**********************************************************************/

  int[] getReturn(Vector v){
    Object[] ri = v.toArray();
    int[] ret = new int[ri.length];
    for(int i=0;i<ri.length;i++){
      ret[i] = ((Integer)ri[i]).intValue();
      System.err.print(ret[i] + " ");
    };
    System.err.println();

    return ret;
  }

  /**********************************************************************/
  /**
   * ܤedgeΥ˥Ȥƽ
   *<BR><BR>
   * @param v ܥΡ
   * @param destination ???
   * @return Υ˥Ȥ줿ܥΡ
   **/
  /*
  Vector sortEdges (Vector v, City destination){
    Vector temp = new Vector();
    Vector sorted = new Vector();
    
    double smallestDistance = 999999;
    City closestCity = new City ( "", "", 0, 0);
    
    if( (v.size() == 1) || (v.size() == 0) ){
      //nothing to do bail
      return v;
    }
    
    Enumeration j = v.elements();
    
    while(j.hasMoreElements()){
      Enumeration i = v.elements();
      while(i.hasMoreElements()){
	City tempCity = (City) i.nextElement();
	double d = Math.sqrt((tempCity.lat - destination.lat)*
			     (tempCity.lat - destination.lat) + 
			     (tempCity.lon - destination.lon)*
			     (tempCity.lon - destination.lon) );
	if( d <= smallestDistance){
	  d = smallestDistance;
	  closestCity = tempCity;
	}	    
      }; // while i
      
      sorted.add(closestCity);
      v.remove(closestCity);
      j = v.elements();
    }; // while j
    
    return sorted;
  }
  */

  /**********************************************************************/
  /**
   * ܤΡɤIDŪϤ˶ᤤ֤
   *<BR><BR>
   * @param x ID
   * @return Ρɤ(Object)
   **/

  Object[] getExistRoute(int x,double destX,double destY,int time){
    DestinationSet ds = (DestinationSet)route.get(new Integer(x));
    int[] F = new int[ds.getDestNum()];
    int min = 0;
    int minV = 99999;

    tmpVec.clear();
    for(int i=0;i<ds.getDestNum();i++){
      Destination d = ds.getDest(i);
      F[i] = calcF(d,destX,destY);
      if(F[i] < minV){
	min = i;
	minV = F[i];
	if(d.isThroughRoute(time)){
	  // ĺͤͰʲǤХ롼Ȥ˲ä
	  tmpVec.add(0,new Integer(d.getDestID()));
	};
	continue;
      };

      if(d.isThroughRoute(time)){
	// ĺͤͰʲǤХ롼Ȥ˲ä
	tmpVec.add(new Integer(d.getDestID()));
      };
    };

    return tmpVec.toArray();
  }

  /********************************************************************/

  int calcF(Destination d,double destX,double destY){
    return (int)Math.sqrt((destX - d.getX()) * (destX - d.getX()) +
			  (destY - d.getY()) * (destY - d.getY()));
  }

  /********************************************************************/
}






















