package rescueAgent.RescueObject;
/**
 * Rescueߥ졼ˤƺɸɽǽʲΥݥȤ򼨤
 * ֥Ȥɽ
 **/

public class RiverNode extends Vertex{
  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time ֥Ȥξ󹹿줿
   **/

  public RiverNode(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public RiverNode(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_X)
      setX(value[0]);
    else if(propID == PROPERTY_Y)
      setY(value[0]);
    else if(propID == PROPERTY_EDGE)
      setEdge(value);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      RiverNode(201) Parser:
        Type(201),ID(ex.1521),X,Y,Edge(list)[ʹߤ̤ ,Signal,
        ShortCutToTurn(list),PocketToTurnAccross(list),SignalTiming(list)]

      (NUM)[=Parameter Name]            Attribute       (Value)
      -----------------------------------------------------------------------
      (  3)[=PROPERTY_HEAD]             X               (PositiveIntNumber)
      (  4)[=PROPERTY_TAIL]             Y               (PositiveIntNumber)
      (242)[=PROPERTY_EDGE]             Edge            (RiverObjectIDs list)
    */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  3 : // X    [PROPERTY_HEAD]
	offset += setX(data[start+offset+1]);
	break;
      case  4 : // Y    [PROPERTY_TAIL]
	offset += setY(data[start+offset+1]);
	break;
      case 242: // Edge [PROPERTY_EDGE]
	int counter = 0;
	while(data[start+counter+offset+1]!=0){
	  counter++;
	}
	if(counter!=0){ // Edge
	  int[] edgeList = new int[counter];
	  try{
	    System.arraycopy(data,start+offset+1,edgeList,0,counter);
	  }
	  catch(Exception e){
	    e.printStackTrace();
	  }
	  offset += setEdge(edgeList);
	}
	else{ // Edgeʤ
	  offset += setEdge(null);
	}
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  public String getType(){
    return "RiverNode";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println("R_NodeID       : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     X         : " + getX());
    System.out.println("     Y         : " + getY());
    for(int i=0;i<edge.length;i++){
      if(i==0)
	System.out.println("     Edge      : " + edge[0]);
      else
	System.out.println("               : " + edge[i]);	
    };
  }

  /********************************************************************/

}
