package rescueAgent.RescueObject;
/**
 * Rescueߥ졼֤ɽ륯饹
 **/

public class World extends VirtualObject{
  int startTime = -1;
  int longitude = -1;
  int latitude = -1;
  int windForce = -1;
  int windDirection = -1;

  /********************************************************************/
  //󥹥ȥ饯

  public World(int id){
    setID(id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_START_TIME)
      setStartTime(value[0]);
    else if(propID == PROPERTY_LONGITUDE)
      setLongitude(value[0]);
    else if(propID == PROPERTY_LATITUDE)
      setLatitude(value[0]);
    else if(propID == PROPERTY_WIND_FORCE)
      setWindForce(value[0]);
    else if(propID == PROPERTY_WIND_DIRECTION)
      setWindDirection(value[0]);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      World(208) Parser:
        Type(208),ID(ex.1),StartTime,Longitude,Latitude,WindForce,WindDir

      (NUM)[=Parameter Name]            Attribute       (Value)
      ---------------------------------------------------------------------
      ( 29)[=PROPERTY_START_TIME]       StartTime       (PositiveIntNumber)
      ( 30)[=PROPERTY_LONGITUDE]        Longitude() (PositiveIntNumber)
      ( 31)[=PROPERTY_LATITUDE]         Latitude()  (PositiveIntNumber)
      ( 32)[=PROPERTY_WIND_FORCE]       WindForce() (PositiveIntNumber)
      ( 33)[=PROPERTY_WIND_DIRECTION]   WindDir()   (0~1295999)¿ʬ
    */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  29: // StartTime
	offset += setStartTime(data[start+offset+1]);
	break;
      case  30: // Longitude()
	offset += setLongitude(data[start+offset+1]);
	break;
      case  31: // Latitude()
	offset += setLatitude(data[start+offset+1]);
	break;
      case  32: // WindForce()
	offset += setWindForce(data[start+offset+1]);
	break;
      case  33: // WindDir()
	offset += setWindDirection(data[start+offset+1]);
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  int setStartTime(int startTime){
    this.startTime = startTime;
    return 2;
  }

  /********************************************************************/

  int setLongitude(int longitude){
    this.longitude = longitude;
    return 2;
  }

  /********************************************************************/

  int setLatitude(int latitude){
    this.latitude = latitude;
    return 2;
  }

  /********************************************************************/

  int setWindForce(int windForce){
    this.windForce = windForce;
    return 2;
  }

  /********************************************************************/

  int setWindDirection(int windDirection){
    this.windDirection = windDirection;
    return 2;
  }

  /********************************************************************/

  public String getType(){
    return "World";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println(" WorldID       : " + getID());
    System.out.println("    StartTime  : " + startTime);
    System.out.println("    Longitude  : " + longitude);
    System.out.println("    Latitude   : " + latitude);
    System.out.println("    WindForce  : " + windForce);
    System.out.println("    WindDir    : " + windDirection);
  }

  /********************************************************************/
}

