/*
  # Controller/AmbulanceTeamController.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  #
  # $Id: AmbulanceTeamController.java,v 1.12 2002/06/08 08:36:24 yoshikia Exp $
 */
package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼ǵߵ⥨Ȥ򥳥ȥ뤹륯饹<BR>
 * AmbulanceTeamController:
 * Controll AmbulanceTeam Agent in Rescue simulation
 **/
public class AmbulanceTeamController extends MovingObjectController{
  boolean nowLoading = false;
  int loadCivilianID = -1;
  //int target = -1 ; // ưŪ

  //int nowPos = -1; // ʬκpointID
  //int prevPos = -1; // ʬpointID
  //int samePosCount = 0; // samePosϢ³trueä

  //double[][] refugeList;
  Vector refugeList;
  int[] refugeIDList;

  int[] prevPosHist;
  int[] PosHist;

  int[] buriednessID;
  int[] injuredID;

  //boolean debug = false;

  //###### Hear Parameter
  //int prevMsgTime = -1;
  //int rcvMsg = 0;
  //int sndMsg = 0;
  //boolean heard_helpme = false; // Ʊ˻̱HelpMeʹɤ
  int[] hearTargetList = new int[8]; 
  // CenterƤ׼ԤΤΥꥹ

  // å(ޥ͡㡼)
  //MessageManager msgMan;
  //MessageRoboCup2002 msgRC2002;

  // ͥٴ
  Vector[] msgPQ = new Vector[5];

  //Random rand = new Random();

  // ƥȤIDꥹѿ
  //int[] ambulanceCenterList;

  //boolean verbose = false;
  //boolean selfBuried = false;

  /********************************************************************/
  // 󥹥ȥ饯

  public AmbulanceTeamController(int id,IO io,int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);

    //ambulanceCenterList = objectManager.getAmbulanceCenterList();

    // Debug Use
    //System.out.println("ʪ(Building)ο : "
    //		       +objectManager.getBuildingObjectNum());
    //System.out.println("(Node)ο : "
    //		       +objectManager.getNodeObjectNum());
    //System.out.println("ƻϩ(Rode)ο : "
    //		       +objectManager.getRoadObjectNum());
    //System.out.println("̱+߽(Civilian)ο : "
    //		       +objectManager.getCivilianObjectNum());
    //System.out.println("(FB)ο : "
    //		       +objectManager.getFireBrigadeObjectNum());
    //System.out.println("ߵ(AT)ο : "
    //      +objectManager.getAmbulanceTeamObjectNum());
    //System.out.println("ٻ(PF)ο : "
    //		       +objectManager.getPoliceForceObjectNum());
    //System.out.println("߽(FB+AT+PF)ο : "
    //	       +objectManager.getRescueManObjectNum());
    //System.out.println("(Refuge)ο : "
    //		       +objectManager.getRefugeObjectNum());
    //System.out.println("ɽ(FS)ο : "
    //		       +objectManager.getFireStationObjectNum());
    //System.out.println("ߵ޽(AC)ο : "
    //	       +objectManager.getAmbulanceCenterObjectNum());
    //System.out.println("ٻ(PO)ο : "
    //		       +objectManager.getPoliceOfficeObjectNum());
    //System.out.println("(FS+AC+PO)ο : "
    //		       +objectManager.getRescueCenterObjectNum());
    
    //objectManager.makeRouteTable();

    // å
    //System.out.print("ߵ(AT)ǤMessage Send...");
    //System.out.print(Parameter.MAX_AGENT_SNDMSG_NUM +", Recieve...");
    //System.out.println(Parameter.MAX_AGENT_RCVMSG_NUM);
    //msgMan = new MessageManager(Parameter.MAX_AGENT_SNDMSG_NUM,true);
    // ͥ٥塼
    for (int i=0;i<5;i++){
      msgPQ[i] = new Vector();
    }    
    
    System.gc(); // ١쥯μ¹
    //System.out.println("My ID: "+ id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SubClassܺٵʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){

    // ޤsuperƤ, ưΥȶ̤ν¹
    super.init(msg_header,msg_data);

    // ʲǵߵͭν򤹤
    refugeList = objectManager.getRefugeListWP(); // Ͽޤrefuge
    if(refugeList != null){ // ǤȤꤢIDǼ
      refugeIDList = new int[refugeList.size()];
      int index=0;
      Iterator it = refugeList.iterator();
      while(it.hasNext()){
	Building r = (Building)it.next();
	refugeIDList[index] = r.getID();
	index++;
      }
    }
  }

  /********************************************************************/
  /** ưΥȸͭιưԤʤ<BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected int[] uniqueDeciding(int[] msg_header, int[] msg_data){

    // СĢ碌 
    Vector message = new Vector();
    message.add(msg_header);
    message.add(msg_data);
    decideCommand(message);
    // СĢ碌 ޤ

    return null; // Ȥꤢnull֤
  }

  /********************************************************************/
  /** ߵ⥨ȤΥᥤ롼򵭽Ҥ᥽åɡ<BR><BR>
   * @deprecated protected int[] uniqueDeciding(int[] msg_header,
   *             int[] msg_data) ˰ܹͽ
   * @param message kernelƤå
   **/

  private void decideCommand(Vector message){

    msg_header = (int[])message.get(0); // åإå

    // ***** ʪKA_SENSE *****
    if(msg_header[0]==CommandTable.KA_SENSE){
      // $$$$ ι $$$$
      int[] msg_data = (int[])message.get(1); // åǡ
      //senseInfoParser.parseSenseInfo(msg_header,msg_data); // Ϥ

      //time = objectManager.getTime();
      //self = (AmbulanceTeam)objectManager.getSelfInfo(); // ʤξι
      //RescueObject rsob = objectManager.getObject(self.getPosition());

      //msgMan.reset(); // MessageManager ι
      //sndMsg = 0;

      // ʬΰ֤ 
      //prevPos = nowPos;
      //nowPos = self.getPosition();
      //io.writeMiscLog("nowPos(ID):"+nowPos+", prevPos(ID):"+prevPos);
      //io.writeSelfLog(self.getPosition(),self.getPositionExtra());

      // ʬưʤå
      //checkHalt(rsob);

      // routeι
      //int[] nextRoute = objectManager.recycleRoute(route,nowPos); 
      // ʤ֤ޤǵͤ
      //if(nextRoute != null){
      //  route = nextRoute;
      //}
      // $$$$ ι ޤ $$$$

      // $$$$ ư $$$$
      // ʬ
      // ʬȤޤäƤν
      //if (helpMe()){
      //  io.writeMiscLog("ʬȤޤäƤ(buried)Τǵ߽");
      //  selfBuried = true;
      //}
      //else{
      //  if (selfBuried){
      //    // ʬ줿
      //    if(ambulanceCenterList != null && ambulanceCenterList[0] > 0){
      //      MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_FIN_HELP,self.getPosition());
      //      msgMan.addMsg(snd_msg);
      //    }
      //    else{
      //      MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_FIN_HELP,self.getPosition());
      //      io.say(snd_msg);
      //      io.writeMiscLog("ʬޤäƤ뤱,ߵ޽꤬ʤΤǽƤ");
      //    }
      //    selfBuried = false;
      //  }
      //}

      // ޤäƤCivilianΥå
      //int[] buryCiv = objectManager.checkBuriedCivilian(time);
      //if(buryCiv != null){
      //  tellBuryMessage(buryCiv);
      //}

      // MessageManager ίäƤåФ
      //for (int i=0;i<msgMan.size();i++){
      //  io.tell(msgMan.getMsg(i));
      //  io.writeMiscLog("Tell Message");
      //  io.writeMiscLog(msgMan.getMsg(i).toString());
      //}
      
      //*****************************************************//
      // ºݤιưꤹ
      // ºݤɤΥޥɤͥ褷ƹԤʤˤĤƤ
      // ʲΤ褦˷Ƥ
      // (ͥ)ʬҤɤΤعԤ
      // (ͥ)̱(Loading)ʤΤǡ³
      // (ͥ)ʪ⡢⤷ƻϩǽ
      //     ̱Ȥϡ߽(Load)Ԥʤ
      // ʪͥ٤å߷ʪˤʤС
      //     ͥ٤ι⤤ʪذư롣
      // η̡ʪˤʤС¾ηʪ
      //     Ϥʪͥ٤ι⤤ʪͭ˸¤
      //     ͥ٤ι⤤ʪؤȰư򳫻Ϥ롣
      // ʤ(ảʪˤɬ̱
      //     쥹塼ȤޤäƤȤ)
      //     ߤʪˤͤ򷡤롣
      // ʤȤϡƤηʪ˿ͤޤä
      //     ʤȤΤǡʬǤ
      //     顢عԤ
      // λ롢⤷ϣʤ硢ĺɤ
      //     кҾξϤToDo:̤(ߤ
      //                                     ०)ʤΤ
      //                                     ޤ줿ʤ


      // Debug_use
      int[] tmp;
      //tmp = objectManager.getBuildingIDListWithinCircle(1996,30.0); // FS
      //tmp = objectManager.getBuildingIDListWithinCircle(2421,30.0); // FB
      //tmp = objectManager.getBuildingIDListWithinCircle(2137,50.0); Building
      //tmp = objectManager.getBuildingIDListWithinCircle( 535,30.0); // Road
      //tmp = objectManager.getBuildingIDListWithinCircle(1084,10.0); // Node
      //tmp = objectManager.getBuildingIDListWithinCircle(9999,20.0); // badID


      // targetι
      if(target == nowPos){
	removeHearTargetList(target);
	target = -1;
      }

      // ʬȤβμŤΤؤɬפ뤫ɤ
      //if (AmIinjured_gotoRefuge()){
      //  io.writeMiscLog("ؤɬפä");
      //  return;
      //}
      // ̱ξ,³
      if (nowLoading()){
	io.writeMiscLog("̱³");
	return;
      }

      // Debug : Ʊ֤ޤäƤ̱ȵߵοå
      int[] buriedOrDmagedCivilian = objectManager.getBuriedOrDamagedCivilian(nowPos,time);
      int[] sameposAT = objectManager.getSamePosAmbulanceTeam(nowPos,time);

      if (buriedOrDmagedCivilian != null){
	io.writeMiscLog("ƱˤޤäƤorֽĤƤ׻̱ο : " + buriedOrDmagedCivilian.length);
	String buf = "";
	for (int i=0;i<buriedOrDmagedCivilian.length;i++){
	  buf += buriedOrDmagedCivilian[i] + " ";
	}
	io.writeMiscLog("ޤäƤorĤƤ̱ ID : " + buf);
      }
      else{
	io.writeMiscLog("ƱޤäƤorĤƤ̱Ϥʤ");
      }

      if (sameposAT != null){
	io.writeMiscLog("Ʊˤ AT ο : " + sameposAT.length);
	String buf = "";
	for (int i=0;i<sameposAT.length;i++){
	  buf += sameposAT[i] + " ";
	}
	io.writeMiscLog("AT  ID : " + buf);
      }
      else{
	io.writeMiscLog("Ʊˤ AT Ϥʤ");
      }

      if (buriedOrDmagedCivilian != null && sameposAT != null){
	if (buriedOrDmagedCivilian.length > 1 && sameposAT.length > 3){
	  // ޤäƤorĤƤͤ 2 Ͱʾ AT  4 Ͱʾ夤
	  if (id % 2 == 0){
	    // ͥʷͤʤ鷡ޤ
	    
	    // ## ޤäƤͤ뤫ɤ ##
	    buriednessID = objectManager.getBuriedCivilianListWD(self,time);
	    if(buriednessID != null){ // ޤäƤͤʤ -> 
	      io.writeMiscLog("ޤäƤͤ");
	      // ߽ư롼
	      if(actionRescue(self.getPosition(),buriednessID)){
		io.writeMiscLog("ޤäƤͤ actionRescue ǽλ");
		return;
	      }
	    }
	    // ## ޤäƤͤ뤫ɤ ޤ
	    
	    // ### ĤƤǽCivilian뤫ɤ ###
	    injuredID = objectManager.getDamagedCivilianList();
	    // ĤƤͤȤ, actionLoadAA_RESCUE_FINȯư
	    if(injuredID != null){ // ĤƤͤʤ -> 
	      Message[] mes = new Message[injuredID.length];
	      String buffer = "";
	      for (int i=0;i<injuredID.length;i++){
		mes[i] = messageManager_new.makeRescueFinMessage(injuredID[i]);
		if(mes[i] != null){
		  // ʬν°륻󥿡, Tell
		  if(hasMyCenterObject()){
		    messageManager_new.storeTellMessage(mes[i],1);
		  }
		  // Sayɬ
		  messageManager_new.storeSayMessage(mes[i],1);
		}
		buffer = buffer + injuredID[i] + " ";
	      }
	      io.writeMiscLog("ĤƤͤ : " + buffer);
	      // 롼
	      if(actionLoad(self.getPosition(),injuredID)){
		io.writeMiscLog("ĤƤ̱ actionLoad ǽλ");	  
		return;
	      }
	      io.writeMiscLog("Ǥ");
	    }
	    // ### ĤƤǽCivilian߽Ф뤫ɤ ޤ
	   
	    // ٤ -> Random Walk
	    randomWalk();
	    io.writeMiscLog("٤ -> Random Walk");
	    return;
	  }
	  else{
	    // ͥʱ٤ͤϱ֡  
	    // ### ĤƤǽCivilian뤫ɤ ###
	    injuredID = objectManager.getDamagedCivilianList();
	    if(injuredID != null){ // ĤƤͤʤ -> 
	      String buffer = "";
	      for (int i=0;i<injuredID.length;i++){
		buffer = buffer + injuredID[i] + " ";
	      }
	      io.writeMiscLog("ĤƤͤ : " + buffer);
	      // 롼
	      if(actionLoad(self.getPosition(),injuredID)){
		io.writeMiscLog("ĤƤ̱ actionLoad ǽλ");
		return;
	      }
	      io.writeMiscLog("Ǥ");
	    }
	    // ### ĤƤǽCivilian߽Ф뤫ɤ ޤ

	    // ## ޤäƤͤ뤫ɤ ##
	    buriednessID = objectManager.getBuriedCivilianListWD(self,time);
	    if(buriednessID != null){ // ޤäƤͤʤ -> 
	      io.writeMiscLog("ޤäƤͤ");
	      // ߽ư롼
	      if(actionRescue(self.getPosition(),buriednessID)){
		io.writeMiscLog("ޤäƤͤ actionRescue ǽλ");
		return;
	      }
	    }
	    // ## ޤäƤͤ뤫ɤ ޤ

	    // ٤ -> Random Walk
	    randomWalk();
	    io.writeMiscLog("٤ -> Random Walk");
	    return;
	  }	  
	}
      }

      // ̾
      // ### ĤƤǽCivilian뤫ɤ ###
      injuredID = objectManager.getDamagedCivilianList();
      if(injuredID != null){ // ĤƤͤʤ -> 
	String buffer = "";
	for (int i=0;i<injuredID.length;i++){
	  buffer = buffer + injuredID[i] + " ";
	}
	io.writeMiscLog("ĤƤͤ : " + buffer);
	// 롼
	if(actionLoad(self.getPosition(),injuredID)){
	  io.writeMiscLog("ĤƤ̱ actionLoad ǽλ");	  
	  return;
	}
	io.writeMiscLog("Ǥ");
      }
      // ### ĤƤǽCivilian뤫ɤ ޤ

      // ## ޤäƤͤ뤫ɤ ##
      buriednessID = objectManager.getBuriedCivilianListWD(self,time);
      if(buriednessID != null){ // ޤäƤͤʤ -> 
	io.writeMiscLog("ޤäƤͤ");
	// ߽ư롼
	if(actionRescue(self.getPosition(),buriednessID)){
	  io.writeMiscLog("ޤäƤͤ actionRescue ǽλ");
	  return;
	}
      }
      // ## ޤäƤͤ뤫ɤ ޤ

      if (target != -1){
	// Hear ˤߵλŻ³
	if(actionHearGo(nowPos,target)){
	  io.writeMiscLog("ߵη³actionHearGo ǽλ");
	  return;
	}	
      }
      else{
	// HearMessageTargetä -> ظ
	int htTarget = checkHearTargetList();
	if(htTarget != -1){
	  if(actionHearGo(nowPos,htTarget)){
	    io.writeMiscLog("ä actionHearGo ǽλ");
	    return;
	  }
	}	
      }

      // ٤ -> Random Walk
      randomWalk();
      io.writeMiscLog("٤ -> Random Walk");
      return;
      // $$$$ ư ޤ $$$$
    }
    // ***** KA_SENSE ޤ *****

    else{ // Kernel褿å(Networkκ?)
      //System.err.print("KA_Message Error!! MessageHeader:");
      for(int i=0; i<msg_header.length; i++){
	//System.err.print(" "+msg_header[i]);
      }
      //System.err.println();
    }
  }

  /********************************************************************/
    /*
  void randomWalk(int pos){
    // ӥˤȤꤢentranceޤǽФ
    RescueObject rob = objectManager.getObject(pos);
    if(rob.getType().equals("Building") || rob.getType().equals("Refuge")
       || rob.getType().equals("AmbulanceCenter") 
       || rob.getType().equals("PoliceOffice") 
       || rob.getType().equals("FireStation")){
      Building b = (Building)rob;
      int[] beside = {b.getEntrance()};
      io.setPrefixActLog("FromBuildingToEntrance"); // ܺ٥ޥɤΥå
      io.move(beside,self.getPosition());
      // actionLog("Move","EP",b.getID(),b.getEntrance());
    }
    else{
      route = objectManager.getRandomWalkRoute(self);
      if(route != null){
	io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
	// actionLog("Move","EX",route[0],route[route.length-1]);
      }
      else{
	io.setPrefixActLog("CannotMoving"); // ܺ٥ޥɤΥå
	io.rest(self.getPosition());
	// actionLog("NoMove->Rest","NL",self.getPosition(),0);
      }
    }
  }
    */
  /********************************************************************/
  // ߽йư롼 @pos : ʬΰ֡ ͤϹưɤ
  // TODO : 2ͰʾϰĤΥӥʤԤ褬ӥưʤʤ
  // TODO : ߽Ф̤ͥ٤

  boolean actionRescue(int pos,int[] civilList){
    // Ʊ֤˵߽RescueManObject(,ٻ,ߵ)Ȼ̱ޤä
    // Ȥ,߽η֤ͥ衣äơޤcivilList
    // Τ褦˥Ȥ롣
    int tmp_count = 0;
    for(int i=0;i<civilList.length;i++){
      if(objectManager.hasRescueManObject(civilList[i])){
	int tmpID = civilList[tmp_count];
	civilList[tmp_count] = civilList[i];
	civilList[i] = tmpID;
	tmp_count++;
      }
    }

    // 餬ε߽йư롼
    for(int i=0;i<civilList.length;i++){
      if(objectManager.hasCivilianObject(civilList[i])){ 
	// ޤäƤCivilianȯ
	Civilian c = objectManager.getCivilianObject(civilList[i]);
	//System.err.println("ID(source):"+civilList[i]); // debug
	//System.err.println("ID(get):"+c.getID()); // debug
	io.writeMiscLog("ID "+c.getID()+"λ̱ν");
	if(pos == c.getPosition()){ // 夤Ƥ -> ߽ -> λ
	  if(time-c.getTime() == 0){ // ¤ξ󤫤ǧ
	    io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	    io.rescue(c.getID(),pos);
	    // AA_RESCUE åι
	    Message mes = messageManager_new.makeRescueMessage(c.getID());
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	    io.writeMiscLog("߽ : 夤Ƥ ->  -> ΥƥåפϽλ : "+c.getID());
	    // actionLog("Rescue",null,c.getID(),pos);
	    return true;
	  }
	  else{
	    io.writeMiscLog("׾(̱ID:"+c.getID()+") : target");
	  }
	}
	// 夤Ƥʤ -> ư
	else if(objectManager.hasBuildingObject(c.getPosition())){
	  route = objectManager.goToDest(pos,c.getPosition(),true);

	  /*
	  // ⤷ӥˤʤȤꤢæ 
	  if(actionInBuildingMove(pos))
	    return true;
	    */

	  if(route[0] == pos && objectManager.isRouteClear(route)
	     && !objectManager.checkAlreadyWork(c.getPosition())){ 
	    //ãǽ->ư->λ
	    // ⤷ӥˤʤȤꤢæ 
	    if(actionInBuildingMove(pos))
	      return true;

	    io.setPrefixActLog("ForRescuingAgent"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	    String buffer = "";
	    for (int j=0;j<route.length;j++){
	      buffer = buffer + route[j] + " ";
	    }
	    io.writeMiscLog("߽ : ãǽ -> ư -> ΥƥåפϽλ : "+buffer);

	    // actionLog("Move","AR",route[0],route[route.length-1]);
	    //System.err.println(id + " ARMove " + route[0] + " -> " + route[route.length-1]);
	    return true;
	  }
	  else{
	    io.writeMiscLog("׼Ԥθé失롼Ȥʤ : target");
	  }
	}
	else{ // c.getPosition()  Building Ǥʤ!!(̤Ϥ!)
	    //System.err.println("ʻ̱ΰ־!!: cvID..."+c.getID()
	    //	     +", cvPos..."+c.getPosition());
	}
      }
    }

    return false;
  }

  /********************************************************************/
  // ʬƤ뤫ɤ椬ҤɤȤ
  // ToDo : ߥ졼󥹥ƥåפ 300 Ǥ벾꤬褯ʤ
    /*
  boolean AmIinjured_gotoRefuge(){
    if (self.getDamage() != 0){
      if ((self.getHP()-self.getDamage()*(300-time)) < 0){
	// Τޤޤȳμ¤˻ǤޤΤ
	// 	
	if(objectManager.hasRefugeObject(self.getPosition())){ 
	  // ʬrefugeˤ
	  io.setPrefixActLog("Curing"); // ܺ٥ޥɤΥå
	  io.rest(self.getPosition());
	  io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤ -> ٷ");
	  // actionLog("Rest",null,0,0);
	  return true;
	}
	else{
	  // ذư
	  // Ǥᤤ򸡺
	  refugeIDList = objectManager.sortByDist(objectManager.getPosX(self),
						objectManager.getPosY(self),
						refugeList);
	  for(int i=0;i<refugeIDList.length;i++){
	    route = 
	      objectManager.goToDest(self.getPosition(),refugeIDList[i],true);
	    
	    if(objectManager.isRouteClear(route)){ 
	      // routeĺɤʤ -> ư -> λ
	      io.setPrefixActLog("ForCuring"); // ܺ٥ޥɤΥå
	      io.move(route,self.getPosition());
	      String buffer = "";
	      for (int j=0;j<route.length;j++){
		buffer = buffer + route[j] + " ";
	      }
	      io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤʤ -> route ĺɤʤ -> ư (ϩ:" + buffer +")");
	      // ư
	      // actionLog("Move",null,route[0],route[route.length-1]);
	      return true; // ưƽλ
	    }
	    else{
	      // routeĺɤ -> ΥåȤ
	    }
	  } // for loop
	  // ˤʤȤʤ,ϩʤ
	  // ToDo : ۥȤˤǤΤ
	  randomWalk();
	  io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ -> ˤʤ -> ĺɤäƤɤˤ⤤ʤ -> ०");
	  return true;
	}
      }
      else if(self.getDamage() > 30){
	// ϤΤޤޤǻʤʤ椬ҤɤʤäƤƤΤ
	// ߤλŻʤɤˤä񤹤
	// ToDo : Ȥľɬפ	
	// 󷡤äƤʤ鷡³
	
      }
    }
    // ᡼ʤorޤ񤹤ɬפʤ
    return false;
  }
    */
  /********************************************************************/
  // ̱ôǤ

  boolean nowLoading(){
    if(nowLoading){
      // ôǤ뤫ɤΥå
      // 󤫤ĤȤΤ֤ID
      if (loadCivilianID == -1){
	return false;
      }
      RescueObject ro = objectManager.getObject(loadCivilianID);
      Civilian load_cv = null;
      if (ro != null){
	if (ro instanceof Civilian){
	  load_cv = (Civilian)ro;
	}
	else{
	  loadCivilianID = -1;
	  nowLoading = false;
	  return false;  
	}
      }
      else{
	loadCivilianID = -1;
	nowLoading = false;
	return false;
      }
      if (load_cv != null && load_cv.getPosition() != id){
	// ¤ôΤ˼ԤƤ
	loadCivilianID = -1;
	nowLoading = false;
	io.writeMiscLog("ôǤȻפäƤ,¤ϼԤƤ");
	return false;
      }

      if(objectManager.getObjectDatabase().
	 hasRefugeObject(self.getPosition())){ // ʬrefugeˤ
	//  -> λ
	io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	io.unload(loadCivilianID,self.getPosition());
	// AA_UNLOAD åι
	Message mes = messageManager_new.makeUnloadMessage(loadCivilianID);
	if(mes != null){
	  // ʬν°륻󥿡, Tell
	  if(hasMyCenterObject()){
	    messageManager_new.storeTellMessage(mes,1);
	  }
	  // Sayɬ
	  messageManager_new.storeSayMessage(mes,1);
	}
	io.writeMiscLog("ôǤ -> refugeˤ -> ");
	// actionLog("Unload",null,0,0);
	loadCivilianID = -1;
	nowLoading = false;
	return true;
      }
      else{ // ʬrefugeˤʤ
	// AA_LOADING åι
	Message mes = messageManager_new.makeLoadingMessage(loadCivilianID);
	if(mes != null){
	  // ʬν°륻󥿡, Tell
	  if(hasMyCenterObject()){
	    messageManager_new.storeTellMessage(mes,1);
	  }
	  // Sayɬ
	  messageManager_new.storeSayMessage(mes,1);
	}

	refugeIDList = objectManager.sortByDist(objectManager.getPosX(self),
					      objectManager.getPosY(self),
					      refugeList);
	for(int i=0;i<refugeIDList.length;i++){
	  route = 
	    objectManager.goToDest(self.getPosition(),refugeIDList[i],true);
	  
	  if(objectManager.isRouteClear(route)){ 
	    // routeĺɤʤ -> ư -> λ
	    io.setPrefixActLog("Loading"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	    String buffer = "";
	    for (int j=0;j<route.length;j++){
	      buffer = buffer + route[j] + " ";
	    }
	    io.writeMiscLog("ôǤ -> refugeˤʤ -> routeĺɤʤ -> ư(ϩ:" + buffer+")");
	    // ư
	    // actionLog("Move","LD",route[0],route[route.length-1]);
	    return true; // ưƽλ
	  }
	} // for loop
      }
    }
    // ôǤʤ
    return false;
  }

  /********************************************************************/
  // ʬȤޤäƤ -> ¾˵߽
  /*
  // ᥽åɤɲ
  boolean helpMe(){
    if (self.getBuriedness() > 0){
      // ʬȤޤäƤ -> ¾εߵ˵߽
      if(ambulanceCenterList != null && ambulanceCenterList[0] > 0){
	MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_BURY,self.getPosition());
	snd_msg.setBuffering(3);
	msgMan.addMsg(snd_msg);
	return true;
      }
      else{
	MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_BURY,self.getPosition());
	io.say(snd_msg);
	io.writeMiscLog("ʬޤäƤ뤱,ߵ޽꤬ʤΤǽƤ");
      }
      return true;
    }
    return false;
  }
  */
  /********************************************************************/
  // 롼
  // TODO : Υ᥽åɤθƤӽФǤ褯 routingtable 

  boolean actionLoad(int pos,int[] civilList){
    for(int i=0;i<civilList.length;i++){
      if(objectManager.hasCivilianObject(civilList[i])){ 
	Civilian c = objectManager.getCivilianObject(civilList[i]);
	if(pos == c.getPosition()){ // 夤Ƥ -> ô
	  if(c.getTime() == time){ // ΰ־ʪå
	                           // ˤ˻̱ʤ顢
	                           // ϺǿtimeˤʤäƤ뤫顣
	    io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	    io.load(c.getID(),self.getPosition());
	    // AA_LOAD åι
	    Message mes = messageManager_new.makeLoadMessage(c.getID());
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	    loadCivilianID = c.getID();
	    io.writeMiscLog(" : 夤Ƥ -> ô :̱ID:"+c.getID());
	    nowLoading = true;
	    return true;
	  }
	  else{ // 󤬸Ťְäͤ餯¾εߵ˱Ӥ줿
	    if(refugeIDList != null){
	      int tmppos = c.getPosition();
	      int tmpdmg = c.getDamage();
	      c.setPositionRefuge(refugeIDList[0]);
	      io.writeMiscLog("Ϥνˤʤ:(ˤ뤳Ȥˤ (ID "+c.getID()+" pos : "+tmppos+" -> "+c.getPosition()+")");
	      io.writeMiscLog("ƽȤˤ롣:)ˤϤ!? (ID "+c.getID()+" damage : "+tmpdmg+" -> "+c.getDamage()+")");
	    }
	    else{
	      io.writeMiscLog("Ϥνˤʤ:(");
	    }
	  }
	}
	else{ // 夤Ƥʤ -> ư
	  // ˤ̱ΰ֤,ˤ¾ΥȤ 
	  // ID(¿ʬߵ)ˤʤäƤ뤳ȤΤա
	  io.writeMiscLog("*** Debug for Civilian State ***");
	  io.writeMiscLog("self Pos: "+pos+", selfID: "+id);
	  io.writeMiscLog("target civilian id : "+c.getID());
	  io.writeMiscLog("target civilian pos: "+c.getPosition());
	  io.writeMiscLog("********************************");
	  if (objectManager.hasAmbulanceTeamObject(c.getPosition())){ 
	  // ̱ߵ˱ФƤȤڤƤ
	  // ¾εߵ⤬ǤäʤΤǤŪ˾ʬ
	  // 餯رФ줿ΤˤȤ˽񤭴
	    if(refugeIDList != null){
	      int tmppos = c.getPosition();
	      int tmpdmg = c.getDamage();
	      c.setPositionRefuge(refugeIDList[0]);
	      io.writeMiscLog("¾εߵ˱Ф줿:)ˤ뤳Ȥˤ (ID "+c.getID()+" pos : "+tmppos+" -> "+c.getPosition()+")");
	      io.writeMiscLog("ƽȤˤ롣:)ˤϤ!? (ID "+c.getID()+" damage : "+tmpdmg+" -> "+c.getDamage()+")");
	    }
	    else{
	      io.writeMiscLog("¾εߵ˱Ф줿:)");
	    }
	  }
	  else if (objectManager.hasRoadObject(c.getPosition()) || 
	      objectManager.hasNodeObject(c.getPosition()) || 
	      objectManager.hasBuildingObject(c.getPosition())){
	    route = 
	      objectManager.goToDest(pos,c.getPosition(),true);
	    if(route[0] == self.getPosition()){ // ưǽ -> ư -> λ
	      io.setPrefixActLog("ForGoingLoadPosition"); // ܺ٥ޥɥå
	      io.move(route,self.getPosition());
	      String buffer = "";
	      for (int j=0;j<route.length;j++){
		buffer = buffer + route[j] + " ";
	      }
	      io.writeMiscLog(" : 夤Ƥʤ ưǽ -> ư -> λ:"+buffer);
	      // actionLog("Move","AL",route[0],route[route.length-1]);
	      return true;
	    }
	  }
	  else{ // ФƤʤķʪƻϩˤ⤤ʤ(ꤨʤ!?)
	    io.writeMiscLog("target Civilian position error");
	    io.writeMiscLog("*** Debug for routingtable ***");
	    io.writeMiscLog("self Pos : "+pos+", selfID: "+id);
	    io.writeMiscLog("target civilian id : "+c.getID());
	    io.writeMiscLog("target civilian pos : "+c.getPosition());
	    io.writeMiscLog("******************************");
	  }
	}
      }
    }
    return false;
  }

  /********************************************************************/
  // ư롼Hear˹ư

  boolean actionHearGo(int pos,int tg){
    target = tg;
    if(self.getPosition() == target){
      //System.err.println(id + " htTarget already reach");
    }
    else{ // 夤Ƥʤ -> ư
      route = objectManager.goToDest(self.getPosition(),target,true);
      if(route[0] == self.getPosition() && objectManager.isRouteClear(route)
	 && !objectManager.checkAlreadyWork(target)){ //ãǽ->ư->λ
	// ӥˤȤꤢentranceޤǽФ
	if(pos != tg && actionInBuildingMove(pos))
	  return true;

	io.setPrefixActLog("ByHearInformation"); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
	String buffer = "";
	for (int i=0;i<route.length;i++){
	  buffer = buffer + route[i] + " ";
	}
	io.writeMiscLog("Hear˹ư : 夤Ƥʤ -> ư :"+buffer);
	// actionLog("Move","HT",route[0],route[route.length-1]);
	return true;
      }
      else if(objectManager.checkAlreadyWork(target)){ 
	//targetǴ˺ -> tgꥢ
	removeHearTargetList(target);
	target = -1;
      }
    }
    return false;
  }

  /********************************************************************/
  // ӥˤȤꤢentranceޤǽФaction

  boolean actionInBuildingMove(int pos){
    RescueObject rob = objectManager.getObject(pos);
    if(rob.getType().equals("Building") || rob.getType().equals("Refuge")
       || rob.getType().equals("AmbulanceCenter") 
       || rob.getType().equals("PoliceOffice") 
       || rob.getType().equals("FireStation")){
      Building b = (Building)rob;
      int[] beside = {b.getEntrance()};
      io.setPrefixActLog("FromBuildingToEntrance"); // ܺ٥ޥɤΥå
      io.move(beside,self.getPosition());
      io.writeMiscLog("ӥˤȤꤢentranceޤǽФ : "+beside[0]);
      // actionLog("Move","IB",b.getID(),b.getEntrance());
      return true;
    };

    return false;
   }

  /********************************************************************/

  void printRouteInfo(int[] route_array){
    /* 
   for(int i=0;i<route_array.length;i++){
      if(objectManager.hasNodeObject(route_array[i])){
	System.out.println("Node: " + route_array[i]);
      }
      else if(objectManager.hasRoadObject(route_array[i])){
	Road rob = objectManager.getRoadObject(route_array[i]);
	rob.printInfo();
      }
      else{
	System.out.println("????: " + route_array[i]);
      };
    };
    */
  }

  /********************************************************************/
  // hear & say
    /*
  public void receiveHear(Vector message){
    int senderID = msg_header[3];
    byte[] msg_data = (byte[])message.get(1); // åǡ

    // åΥॹפ򸫤
    if(prevMsgTime != time){
      heard_helpme = false;
      rcvMsg = 0; 
    }

    // ɤåϤ
    // ȤΰջַˤѤƤʤȤϤ
    // εȿǽΤǡ˺뤳
    // io.writeHearLog(KK_RCV,senderID,null);

    // *** å() ***
    //  o å°λ
    //    (1)꤬ʤǼʬʳεߵ⤬ȯʤм
    //    (2)꤬ǵߵ޽꤬ȯʤм
    //    (3)̱(߽[FB,AT,PF]Ǥʤ)ȯƤ(ߤ"help me"
    //       SayƤ뤳Ȥ餫)ʤ(Ʊ1)
    if (rcvMsg < Parameter.MAX_AGENT_RCVMSG_NUM){
      boolean tmp_rcv = false;
      if (ambulanceCenterList == null){ // ACʤȤ
	if(objectManager.hasAmbulanceTeamObject(senderID) && senderID != id){
          // *** å(ACʤȤ) ***
          //  o åʾäƤʤ
          //  o Ԥߵ(AmbulanceTeam)
          //  o ԤʬǤʤ
	  tmp_rcv = true;
	}
      }
      else{ // ambulanceCenterList != null ĤޤACä
	if (objectManager.hasAmbulanceCenterObject(senderID)){
          // *** å(ACȤ) ***
          //  o åʾäƤʤ
          //  o Ԥߵ޽(AmbulanceCenter)
	  tmp_rcv = true;
	}
      }
      if(tmp_rcv){ // åμ
	// åȻϿ      
	prevMsgTime = time;
	rcvMsg++;

	msgRC2002 = new MessageRoboCup2002();
	// msgRC2002.parseHearInfo(msg_header,msg_data,time); // Ϥ
	// ʲȤĢ碌
	int[] msg_data_int = new int[msg_data.length-3];
	msg_data_int[0] = (((int)msg_data[0] & 0xFF) << 24) | 
	    (((int)msg_data[1] & 0xFF) << 16) | 
	    (((int)msg_data[2] & 0xFF) << 8) | 
	    ((int)msg_data[3] & 0xFF); // åǡĹ
	for(int i=4,counter=1; i < msg_data.length; i++,counter++){
	    msg_data_int[counter] =(int)msg_data[i]; // ĤʬintѴ
	}
	int[] msg = mergeMessage(msg_header,msg_data_int); // åη
	// ȤĢ碌ޤǡ
	msgRC2002.parseHearInfo(msg,time); // ˺

	int command = msgRC2002.getCommand();
	if(command == -1){
	  System.out.println("̤ΤΥåʤΤ̵뤹롣");
	  return;
	}
	int[] pTarget = {msgRC2002.getTarget(0)}; // getTarget(0)Ͼ
	// int[] pTarget = msgRC2002.getTarget(); // ä(02-11-25)
	// System.out.println(" pTarget(AT)Ĺ "+ pTarget.length);
	io.writeHearLog(command,senderID,pTarget);  // check  02-11-23

	if((KK_BURY <= command &&
	    command <= KK_BURRY_SHALLOW_BURIED_HARD_INJURED) ||
	   (KK_BURY_RO <= command &&
	    command <= KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO)){
	  String buf = "";
	  for (int j=0;j<pTarget.length;j++){
	    buf += pTarget[j] + " ";
	  }
	  io.writeMiscLog("ԤϢ򤦤 : ޥ "+command+"(0x"
		     +(command/16)+(command%16)+") ;  "+senderID
		     +" ;  "+buf);
	  addHearTargetList(command,pTarget); // targetɲ
	}
	else if(command == KK_HEAR_BURIED_CIVILIAN){ // "help me"
	  for (int j=0;j<pTarget.length;j++){
	    // chkB_dataι볦¤30[m]ʤΤ30.0ᤦ
	    objectManager.updateCheckBuildingData(time,pTarget[j],30.0);
	    // Debug_use(ȤꤢõоݤϿ)
	    addHearTargetList(command,
			      objectManager.getBuildingIDListWithinCircle
			      (pTarget[j],30.0)); // targetɲ
	  }
	  String buf = "";
	  for (int j=0;j<pTarget.length;j++){
	    buf += pTarget[j] + " ";
	  }
	  io.writeMiscLog("ԤϢ򤦤 : ޥ "+command+"(0x"
		     +(command/16)+(command%16)+") ;  "+senderID
		     +" ;  "+buf+"30[m]");
	}
	else if(command == KK_FIN_HELP){
	  for (int j=0;j<pTarget.length;j++){
	    removeHearTargetList(pTarget[j]);
	  }
	}
	else if(command == KK_CLEAR){
	  for(int j=0;j<pTarget.length;j++){
	    if(objectManager.hasRoadObject(pTarget[j])){
	      Road r = objectManager.getObjectDatabase().
		  getRoadObject(pTarget[j]);
	      r.setBlockForce(0); // åˤĺɤ0
	    }
	  }
	}
	else{ 
	  // Bury,Clearʳ
	  io.writeMiscLog("Bury,Clearʳ");
	  io.writeMiscLog("command : "+command);
	  String tmp_buf = "";
	  for (int j=0;j<pTarget.length;j++){
	    tmp_buf = pTarget[j] + " ";
	  }
	  io.writeMiscLog("Id:"+ tmp_buf);
	}
      }
      // ̱"help me"ȶǤ
      // Civilian(̱)FireBrigade(),AmbulanceTeam(ߵ),
      // PoliceForce(ٻ)ޤǤΤǡϤ
      // ޤƱˣٰʾʹƤ̣ʤΤǣܤϡϤ
      else if(objectManager.hasCivilianObject(senderID)
	      && !objectManager.hasRescueManObject(senderID)
	      && !heard_helpme){
        // *** å(Ԥ̱λ) ***
        //  o åʾäƤʤ
        //  o Ԥ̱(CivilianRescueMan[FB,AT,PF]Ǥʤ)
	//  o ƱˤǤ˻̱ΥåƤʤ

	// åȻϿ      
	rcvMsg++;
	heard_helpme = true; // 塢ƱǤϻ̱HelpMe̵
	prevMsgTime = time;

	// commandKK_HEAR_BURIED_CIVILIAN˥å
	int command = KK_HEAR_BURIED_CIVILIAN;

	// ޤϡ¾εߵ
	boolean existAC = false;
	if(objectManager.getAmbulanceCenterObjectNum() > 0){ // ߵ޽꤬
	  existAC = true;
	}
	// ATʤΤtrueᤦ
	tellBurySaidCivilianMessage(self,existAC,true);

	// ͥ٥ǡ١ι볦¤30[m]ʤΤ30.0ᤦ
	objectManager.updateCheckBuildingData(time,self.getPosition(),30.0);
	// Debug_use(ȤꤢõоݤϿ)
	addHearTargetList(command,objectManager.getBuildingIDListWithinCircle
			  (self.getPosition(),30.0)); // targetɲ
      }
    }
  // å ޤ
  }
    */
  /********************************************************************/
  /** ƸİưΥȤˤȤä,٤åɤȽꤹ롣
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected boolean shouldReadMessage(int[] msg_header){
    boolean isReceive = false;
    int senderID = msg_header[3];
    if(hasMyCenterObject()){ // °륻󥿡, 
      if(msg_header[0] == KA_HEAR_TELL){ // HearTellλ, 
	if(rcvHearTellMsgCount < 3 &&
	   objectManager.hasAmbulanceCenterObject(senderID)){ // 3̤,AC
	  rcvHearTellMsgCount++; // ʹ򥫥
	  isReceive = true;
	}
      }
      else if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 1 &&  // ޤ٤ʹƤʤ,
	   objectManager.hasAmbulanceTeamObject(senderID)){   // ʬʳAT
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    else{ // °륻󥿡ʤ, 
      if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 3 &&  // 3̤, 
	   objectManager.hasAmbulanceTeamObject(senderID)){   // ʬʳAT
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    return isReceive;
  }

  /********************************************************************/
  /** ߽, ⤷ϻ꤫åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * , ϤåȤä, ǡ١ȥ֥ȤιԤʤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForRescueAgent(int ka_command,
					      int senderID, Message message){

    //  AA_BURIED_MYSELF_*, AA_BURIED_CIVILIAN_*, AA_RESCUE_FIN λ
    // ν򤹤Τ, ֤ʤΤǳ䰦
    // ToDo:ǯˤϺꤿ!?

    int command = message.getCommand();
    int[] msgData = message.getMessage();
    int buriedCVID;
    switch(command){
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
      buriedCVID = msgData[0]; // ޤȤäƤʤ
      if(objectManager.hasCivilianObject(buriedCVID)){
	Civilian cv = objectManager.getCivilianObject(buriedCVID);
	if(cv.getHP() == 0){ // ,˴ʤˤʤäƤޤäƤ
	  io.writeMiscLog("ޥAA_HEAR_BURIED_CIVILIAN_* : ľܤ..."
			  +senderID+", ޤäƤ̱ID..."+buriedCVID
			  +" -> ,ˤ˴ʤ...äõʤ");
	}
	else{ // ޤƤ
	  int hearPosition = msgData[1];
	  double hearPosEx = msgData[2]; // ޤȤäƤʤ
	  // chkB_dataι볦¤30[m]ʤΤ30.0ᤦ
	  objectManager.updateCheckBuildingData(time,hearPosition,
						hearPosEx,30.0);
	  // Debug_use(ȤꤢõоݤϿ)
	  addHearTargetList(command,
			    objectManager.getBuildingIDListWithinCircle
			    (hearPosition,hearPosEx,30.0)); // targetɲ
	  io.writeMiscLog("ޥAA_HEAR_BURIED_CIVILIAN_* : ľܤ..."
			  +senderID+", ޤäƤ̱ID..."+buriedCVID
			  +", ׾..."+hearPosition+" 30[m]");
	}
      }
      else{ // ̱ʤIDäƤ(褢ꤨʤ!)
	//System.err.print("̱ʤ![ATuniqueHearingForRescueAgent()]");
	//System.err.print(" Command:AA_HEAR_BURIED_CIVILIAN_*, ID:");
	//System.err.println(buriedCVID);
      }
      break;
    // AA_BURIED_MYSELF_* Ѥα޽(ϤäȤä)
    case AA_BURIED_MYSELF_FB:
    case AA_BURIED_MYSELF_AT:
    case AA_BURIED_MYSELF_PF:
    // AA_BURIED_CIVILIAN_* Ѥα޽(ϤäȤä)
    case AA_BURIED_CIVILIAN_FB:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
      // Debug_use(ȤꤢõоݤϿ)
      buriedCVID = msgData[0]; // ޤȤäƤʤ
      if(objectManager.hasCivilianObject(buriedCVID)){
	Civilian cv = objectManager.getCivilianObject(buriedCVID);
	if(cv.getHP() == 0){ // ,˴ʤˤʤäƤޤäƤ
	  io.writeMiscLog("ޥAA_BURIED_* : ľܤ..."
			  +senderID+", ޤäƤͤID..."+buriedCVID
			  +" -> ,ˤ˴ʤ...äõʤ");
	}
	else{ // ޤƤ
	  int[] buriedBuildingID = {msgData[1]};
	  addHearTargetList(command,buriedBuildingID); // targetɲ
	  io.writeMiscLog("ޥAA_BURIED_* : ľܤ..."
			  +senderID+", ޤäƤͤID..."+buriedCVID
			  +" -> õоݤɲ!!");
	}
      }
      else{ // ̱ʤIDäƤ(褢ꤨʤ!)
	//System.err.print("̱ʤ![ATuniqueHearingForRescueAgent()]");
	//System.err.println(" Command:AA_BURIED_*, ID:"+buriedCVID);
      }
      break;
    default:
      // Ȥꤢ⤷ʤ(顼ϤȤΤ⤪Τ)
    }// end switch(message.getCommand())

    return null; // ߤä֤ͤϤʤΤnull֤
  }

  /********************************************************************/
  /** ̱åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForCivilian(int ka_command,
					   int senderID, String message){

    //  'What_a_relief!' åλν򤹤Τ,
    // ֤ʤΤǳ䰦
    // ToDo:ǯˤϺꤿ!?

    if(message.equals("help_me")){
      int command = AA_HEAR_BURIED_CIVILIAN_AT;
      int buriedCVID = senderID; // ޤȤäƤʤ
      int hearPosition = self.getPosition();
      double hearPosEx = self.getPositionExtra();
      // ͥDatabase(chkB_data)ι볦¤30[m]ʤΤ30.0ᤦ
      objectManager.updateCheckBuildingData(time,hearPosition,hearPosEx,30.0);
      // Debug_use(ȤꤢõоݤϿ)
      addHearTargetList(command,
			objectManager.getBuildingIDListWithinCircle
			(hearPosition,hearPosEx,30.0)); // targetɲ
      io.writeMiscLog("̱ 'help_me' å : ľܤ..."
		      +senderID+", ޤäƤ̱(=)ID..."+buriedCVID
		      +", ׾..."+hearPosition+" 30[m]");
    }

    return null; // ߤä֤ͤϤʤΤnull֤
  }

  /********************************************************************/
  /**
   * ޤäƤ̤꤬ͤ˸ȤΡ<BR>
   * Υ᥽åɡ <i>MessageManager.java makeMessage(int command,
   * int[] data)</i> ˵ۼͽꡣ <BR><BR>
   * @fparam destID ޤäƤ(̱,߽)ID
   **/
    /*
  protected void tellBuryMessage(int[] destID){
    MessageRoboCup2002 snd_msg;
    // ToDo:⤽sayɬΤƤ˱ۤȤϤʤ
    //      ʲtellCenterΥץ
    //      äơ¾εߵľܱȤ䡢󥿡
    //      ʤȤˤsayʤȺ!ޤ˺٤!
    if(ambulanceCenterList != null && ambulanceCenterList[0] > 0){
      // System.err.println("Say or Tell !! (tellBuryMessage)");
      for (int i=0;i<destID.length;i++){
	Civilian cv = objectManager.getCivilianObject(destID[i]);
	if (cv != null){
	  // RescueManObjectä
	  if(objectManager.hasRescueManObject(destID[i])){
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
		snd_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED_RO,cv.getPosition());
		snd_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		snd_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED_RO,cv.getPosition());
		snd_msg.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
	        snd_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		snd_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		snd_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO,cv.getPosition());
		snd_msg.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(snd_msg);
	  }
	  else{ // RescueObjectǤʤʤCivilianä
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
	        snd_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED,cv.getPosition());
	        snd_msg.setBuffering(5);
	      }
	      else{
	        // cv.getDamage() >= 20
		snd_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED,cv.getPosition());
		snd_msg.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
		snd_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		snd_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		snd_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED,cv.getPosition());
		snd_msg.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(snd_msg);
	  }
	}
	else{
	  io.writeMiscLog("cannot get Civilian Object id = "+destID[i]);
	}
      }
      return;
    }
    else{
      // ToDo : say Ф󤸤ʤ
      if (sndMsg < Parameter.MAX_AGENT_SNDMSG_NUM && destID.length > 0){
	Civilian cv = objectManager.getCivilianObject(destID[0]);
	io.writeMiscLog("ߤΥå : " +sndMsg);
	io.writeMiscLog("ޤäƤͤ򸫤 id = " + cv.getPosition());
	
	snd_msg = new MessageRoboCup2002(KK_BURY,cv.getPosition());
	// io.say(snd_msg);
	sndMsg++;
	return;
      }
    }
  }
    */
  /********************************************************************/
  // ʬޤäƤưʤȤ
    /*
  void tellHaltMessage(int destPos){
    if(ambulanceCenterList != null && ambulanceCenterList[0] > 0){
      MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_HALT,destPos);
      msgMan.addMsg(snd_msg);
      int[] t = {destPos};
      // ǤAA_HALT_ATåästoreǤʤ)
      // io.writeHearLog(KK_TELL_HLT,id,t);
      // ºݤio.saytellLog()ߤʤΤǤɤ!?
      return;
    }
    else{
      // Ȥꤢ say Ƥߤ
      MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_HALT,destPos);
      // io.say(snd_msg);
      return;
    }
  }
    */
  /********************************************************************/
  // ꥹʲ
  // ToDo : ΥꥹȤǤΥθ

  void addHearTargetList(int com,int[] destID){
    if (-1 < getPriority(com) && getPriority(com) < 5){
      for(int i=0;i<destID.length;i++){
	msgPQ[getPriority(com)].add(new Integer(destID[i]));
	io.writeMiscLog("Command "+com+",ͥ(Pri) "+getPriority(com)+",TargetObject "+destID[i]);
      }
    }
  }

  /********************************************************************/
  // ꥹʺ + ͤ

  void removeHearTargetList(int destID){
    for(int i=0;i<msgPQ.length;i++){
      for (int j=0;j<msgPQ[i].size();j++){
	if (msgPQ[i].contains(new Integer(destID))){
	  msgPQ[i].remove(new Integer(destID));
	}
      }
    }
    if (destID == target){
      target = -1;
    }
  }

  /********************************************************************/
  // ꥹʸ

  int checkHearTargetList(){
    for(int i=0;i<msgPQ.length;i++){
      for (int j=0;j<msgPQ[i].size();j++){
	return ((Integer)msgPQ[i].get(j)).intValue();
      }
    }
    return -1;
  }

  /********************************************************************/
  // ͥ٤֤(0---4)

  int getPriority(int aa_command){
    int pri;
    switch(aa_command){
    // case KK_BURY:
    // case KK_BURY_RO:
    // case KK_BURRY_DEPTH_BURIED_LIGHT_INJURED_RO:
    // case KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED_RO:
    // case KK_BURRY_DEPTH_BURIED_HARD_INJURED_RO:
    // case KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO:
    case AA_BURIED_MYSELF_FB:
    case AA_BURIED_MYSELF_AT:
    case AA_BURIED_MYSELF_PF:
      pri = 0;
      break;
    // case KK_BURRY_DEPTH_BURIED_LIGHT_INJURED:
    //  pri = 3;
    //  break;
    // case KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED:
    // case KK_HEAR_BURIED_CIVILIAN:
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
      pri = 4;
      break;
    // case KK_BURRY_DEPTH_BURIED_HARD_INJURED:
    case AA_BURIED_CIVILIAN_FB:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
      pri = 1;
      break;
    // case KK_BURRY_SHALLOW_BURIED_HARD_INJURED:
    //  pri = 2;
    //  break;
    default:
      pri = -1; // פʤȤ
    }
    return pri;
  }

  /********************************************************************/
  // ʬưʤưʤ
    /*
  boolean checkHalt(RescueObject rsob){
    if(rsob.getType().equals("Road") || rsob.getType().equals("Node")){
      if(nowPos == prevPos){
	samePosCount++;
	if(samePosCount > 3){ // 3ʾƱˤ
	  if(rsob.getType().equals("Road")){
	    Road rd = (Road)rsob;
	    if(rd.getBlock() > 0){
	      tellHaltMessage(rd.getID());
	      //System.err.println(id + " tell Halt!!");
	      samePosCount = 0;
	      return true;
	    };
	  }
	  else if(rsob.getType().equals("Node")){
	    Node nd = (Node)rsob;
	    int[] edge = nd.getEdge();
	    boolean loopEnd = false;
	    for(int i=0;i<edge.length;i++){
	      RescueObject rt = objectManager.getObject(edge[i]);
	      if(rt.getType().equals("Road")){
		Road rd = (Road)rt;
		if(rd.getBlock() < 1){ // ̤ƻä롼פȴ
		  loopEnd = true;
		  break;
		};
	      };
	    }; // for loop
	    if(!loopEnd){
	      tellHaltMessage(nd.getID());
	      //System.err.println(id + " tell Halt!!");
	      samePosCount = 0;		
	      return true;
	    };
	  }; // if Node
	}
      }
      else{
	samePosCount = 0;
      }
    }

    return false;
  }
    */
  /********************************************************************/
}


