package Controller;

import java.util.*;
import rescueAgent.RescueObject.*;

/**
 * Rescueߥ졼ǥ饹ɽ륯饹<BR>
 * Cluster:
 * Expression the Cluster in Rescue simulation
 **/
class Cluster{
  private Vector cluster;
  private int size;
  // 饹濴 x ɸ y ɸ
  private double x;
  private double y;
  // Υ饹°ʪʿѤ礭
  private double avg_AreaTotal;

  /********************************************************************/

  public Cluster(Building b){
    cluster = new Vector();
    cluster.add(b);
    size = 1;
    // 饹濴
    this.x = b.getX();
    this.y = b.getY();
    this.avg_AreaTotal = b.getAreaTotal();
  }

  /********************************************************************/

  public void merge(Cluster c){
    // ޤǤκɸͤȱپѤιפ
    double sum_x = this.x*size;
    double sum_y = this.y*size;
    double sum_AreaTotal = this.avg_AreaTotal*size;
    
    // 饹Ͽ
    Iterator it = c.iterator();
    // Ͽʪ x  y ɸι
    double sum_new_x = 0;
    double sum_new_y = 0;
    double sum_new_AreaTotal = 0;
    while(it.hasNext()){
      // ˥ǡɲ
      Building b = (Building)it.next();
      cluster.add(b);
      // Ͽʪ x  y ɸιפ
      sum_new_x += b.getX();
      sum_new_y += b.getY();
      sum_new_AreaTotal += b.getAreaTotal(); 
      size++;
    }

    // 饹濴,پѤʿѤι
    this.x = (sum_x + sum_new_x)/size;
    this.y = (sum_y + sum_new_y)/size;
    this.avg_AreaTotal = (sum_AreaTotal + sum_new_AreaTotal)/size;
  }

  /********************************************************************/
  
  public Object getElements(int index){
    if (index < size){
      return cluster.get(index);
    }
    return null;
  }

  /********************************************************************/
  
  public Iterator iterator(){
    return cluster.iterator();
  }

  /********************************************************************/
  
  public int getSize(){
    return size;
  }

  /********************************************************************/
  
  public boolean hasID(int id){
    Iterator it = cluster.iterator();
    while(it.hasNext()){
      Building b = (Building)it.next();
      if (b.getID() == id){
	return true;
      }
    }
    return false;
  }

  /********************************************************************/
  // 饹濴μ
  
  public double getX(){
    return x;
  }
  
  public double getY(){
    return y;
  }
  
  /********************************************************************/
  // پѤʿͤμ

  public double getAVGAreaTotal(){
    return avg_AreaTotal;
  }

  /********************************************************************/
  // Ϥ줿ɸȥ饹濴ȤεΥ
  
  public double getDistance(double input_x,double input_y){
    return Math.sqrt((input_x-getX())*(input_x-getX())+ 
		     (input_y-getY())*(input_y-getY()));
  }
  
  /********************************************************************/

  public String toString(){
    StringBuffer buf = new StringBuffer();
    buf.append("center coordinate : ("+getX()+","+getY()+")\n\n");
    buf.append("<Member id & coordinate (total : "+size+"s)>\n");
                         
    Iterator it = cluster.iterator();
    while(it.hasNext()){
      Building b = (Building)it.next();
      buf.append("          id = "+b.getID()+"  (x,y) = ("+b.getX()+","+b.getY()+")\n");
    }

    return buf.toString();
  }
}




