package Controller;

import java.util.*;

/**
 * Rescueߥ졼ǥ饹ν륯饹<BR>
 * Cluster:
 * Managing the Set of Cluster in Rescue simulation
 **/
class ClusterSet{
  Vector clusterSet;
  double threshold;  // ñ̤ m?
  boolean clusteringFin;
  int clusterSize;

  /********************************************************************/
  
  public ClusterSet(double thres){
    clusterSet = new Vector();
    clusteringFin = false;
    clusterSize = 0;
    setThreshold(thres);
  }

  /********************************************************************/
  /**  **/
  public void init(){
    clusterSet.clear();
    clusterSize = 0;
    clusteringFin = false;
  }

  /********************************************************************/
  /** 饹˥饹ɲä롣<BR>
   * ToDo : Ǥˤʪɲäʤ褦ˤȤ⡣
   * Ǥ¹ԻŪ꤬뤫⡣<BR><BR>
   * @param c ɲä륯饹
   **/
  public void add(Cluster c){
    clusterSet.add(c);
    clusterSize++;
    // 1 ĤǤǤ䤷Ϻƥ饹󥰤ɬ
    clusteringFin = false;
  }

  /********************************************************************/
  /** 饹󥰡
   * ͤ꾮 2 ĤΥ饹 1 ĤΥ饹˹롣<BR><BR>
   **/
  public void clustering(){
    // ʪοˤäƥ르ꥺؤ
    // ʤʤ餳Υ르ꥺϾʤƤ O(n^3) Τ

    // Todo: 饹󥰤򤷤ʤȤϤǺ뤫
    // Ȥꤢ 100 ˤ 6/1
    if (clusterSize < 100){ // ꤹɬפϤʤʤäϤ?
      boolean loop = true;
      while(loop){
	if (clusterSize != 1){
	  // Υޥȥåη׻
	  Double[][] dist_matrix = new Double[clusterSize][clusterSize];
	  for (int i=0;i<clusterSize;i++){
	    for (int j=i+1;j<clusterSize;j++){
	      Cluster c1 = (Cluster)clusterSet.get(i);
	      Cluster c2 = (Cluster)clusterSet.get(j);
	      dist_matrix[i][j] = new Double(distance(c1,c2));
	    }
	  }

	  // Ǿͤη׻
	  int cluster_id1 = 0;
	  int cluster_id2 = 1;
	  for (int i=0;i<clusterSize;i++){
	    for (int j=i+1;j<clusterSize;j++){
	      if (dist_matrix[cluster_id1][cluster_id2].compareTo(dist_matrix[i][j])>0){
		cluster_id1 = i;
		cluster_id2 = j;
	      }
	    }
	  }
	  
	  // 饹󥰤̵ͭ
	  if (dist_matrix[cluster_id1][cluster_id2].doubleValue() < threshold){
	    // Ǿͤͤ꾮äΤǥ饹
	    ((Cluster)clusterSet.get(cluster_id1)).
	      merge((Cluster)clusterSet.get(cluster_id2));
	    clusterSet.remove(cluster_id2);
	    clusterSize--;
	  }
	  else{
	    // Ǿͤͤ礭ΤǤʾ奯饹󥰤ʤ
	    loop = false;
	  }
	}
	else{
	  loop = false;
	}
      }
      clusteringFin = true;
    }
    else{
      // ǳƤʪ¿μͤ٤
      // Ȥꤢϵ켰Υ饹󥰤򤷤ʤˤ
    }
  }
  
  /********************************************************************/
  /** ͤ **/
  
  public void setThreshold(double threshold){
    this.threshold = threshold;
  }

  /********************************************************************/
  /** ͤμ **/

  public double getThreshold(){
    return threshold;
  }

  /********************************************************************/
  /** Υ饹 **/

  public int getClusterSize(){
    return clusterSize;
  }

  /********************************************************************/

  public int[] getSizeEachClusterHave(){
    int[] ret = new int[clusterSize];
    for (int i=0;i<clusterSize;i++){
      ret[i] = ((Cluster)clusterSet.get(i)).getSize(); 
    }
    return ret;
  }

  /********************************************************************/

  public Cluster getCluster(int num){
    return (Cluster)clusterSet.get(num);
  }

  /********************************************************************/

  public Cluster[] getCluster(){
    Cluster[] ret = new Cluster[clusterSize];
    int index = 0;
    Iterator it = clusterSet.iterator();
    while(it.hasNext()){
      ret[index++] = (Cluster)it.next();
    }
    return ret;
  }

  /********************************************************************/

  public boolean hasIDInClusterX(int id,int cluster_x){
    return true;
  }

  /********************************************************************/

  public boolean isClusteringFinished(){
    return clusteringFin;
  }

  /********************************************************************/
  
  public double distance(Cluster c1,Cluster c2){
    return Math.sqrt((c1.getX()-c2.getX())*(c1.getX()-c2.getX())+
		     (c1.getY()-c2.getY())*(c1.getY()-c2.getY()));
  }

  /********************************************************************/
  
  public String toString(){
    StringBuffer buf = new StringBuffer();
    buf.append("*** Debug ClusterSet.java ***\n");
    buf.append("Now Cluster Total Number : "+clusterSize+"\n");
    
    int index = 1;
    Iterator it = clusterSet.iterator();
    while(it.hasNext()){
      Cluster c = (Cluster)it.next();
      buf.append("< "+index+" th Cluster information>\n");
      buf.append(c.toString());
      buf.append("\n");
      index++;
    }

    return buf.toString();
  }

  /********************************************************************/
  
}


