/*
  # Contoroller/PoliceForceController.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  #
  # $Id: PoliceForceController.java,v 1.21 2002/06/10 03:22:23 yoshikia Exp $
 */
package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼Ƿٻ⥨Ȥ򥳥ȥ뤹륯饹<BR>
 * PoliceForceController:
 * Controll PoliceForce Agent in Rescue simulation
 **/
public class PoliceForceController extends MovingObjectController{
  boolean verbose = false;
  
  //int target = -1;
  int[] blockedID;

  //int nowPos = -1;
  //int prevPos = -1;
  boolean prevClear = false;

  int[] prevPosHist;
  int[] PosHist;

  //int prevMsgTime = 0; // ˥åäλ
  //int rcvMsg = 0; // λ֤˼äå
  //int sndMsg = 0;
  int msgTargetID = -1;
  int msgTargetSetTime = -1;
  //int prevMsgTarget = -1;

  int samePosCount = 0;

  // å
  //MessageManager msgMan;
  //MessageRoboCup2002 msgRC2002;

  //###### DEBUG Parameter 
  boolean debug = false;
  boolean miscLogMode = true; // misc ˥Ϥ⡼

  //int[] policeOfficeList;
  //int[] refugeList;

  // ưȤοݻ
  //int fbNum; 
  //int atNum;
  int pfNum;
  //int poNum;

  // ʬô
  // ƻϩݽⵡǽ
  int kansenTarget = -1;
  Vector kansenAgent; // ƻϩݽΥꥹ
  boolean kansen;
  Vector kansenList;
  Random random;

  /********************************************************************/
  // 󥹥ȥ饯

  public PoliceForceController(int id,IO io,int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);

    // tmp
    //policeOfficeList = getPoliceOfficeList();
    //refugeList = objectManager.getRefugeIDList(); // Ͽޤrefuge

    //objectManager.makeRouteTable();
    //objectManager.printRouteHash();

    //fbNum = objectManager.getFireBrigadeObjectNum();
    //atNum = objectManager.getAmbulanceTeamObjectNum();
    pfNum = objectManager.getPoliceForceObjectNum();
    //poNum = objectManager.getPoliceOfficeObjectNum();

    // Debug Use
    /*
    System.out.println("ٻ(PF)ο : "
		       +objectManager.getPoliceForceObjectNum());
    System.out.println("ٻ(PO)ο : "
		       +objectManager.getPoliceOfficeObjectNum());
    */
    // å
    //System.out.print("ٻ(PF)ǤMessage Send...");
    //System.out.print(Parameter.MAX_AGENT_SNDMSG_NUM +", Recieve...");
    //System.out.println(Parameter.MAX_AGENT_RCVMSG_NUM);
    //msgMan = new MessageManager(Parameter.MAX_AGENT_SNDMSG_NUM,true);
    
    System.gc(); // ١쥯μ¹
    //System.out.println("My ID: "+ id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SubClassܺٵʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){

    // ޤsuperƤ, ưΥȶ̤ν¹
    super.init(msg_header,msg_data);

    // ʲǵߵͭν򤹤
    // ʬ ID ˤ괴ƻϩôˤʤ
    if (id % 2 == 0){
      kansen = true;
      // ƻϩô륨Ȥξ
      kansenAgent = new Vector();
      Enumeration enum = 
	objectManager.getObjectDatabase().getPoliceForceTable().keys();
      while(enum.hasMoreElements()){
	Integer pfid = (Integer)enum.nextElement();
	if ((pfid.intValue()%2) == 0){
	  kansenAgent.add(pfid);
	}
      }
      // ʬܤǤ뤫Ĵ٤
      int index = 0;
      // ʬ꾮 ID Ĥ뤫
      for (int i=0;i<kansenAgent.size();i++){
	if (((Integer)kansenAgent.get(i)).intValue() < id){
	  index++;
	}
      }

      // 5 m  Road Ͽ
      Vector tmpKansenList = objectManager.getWideRoad(5000);
      // ʬôʬͤؤ
      kansenList = new Vector();
      for (int i=0;i<tmpKansenList.size();i++){
	if (i%kansenAgent.size() == index){
	  kansenList.add(tmpKansenList.get(i)); 
	}
      }
      
      String buf = "";
      for (int i=0;i<kansenList.size();i++){
	buf += ((Integer)kansenList.get(i)).intValue()+" ";
      }
      io.writeMiscLog("ƻϩ ôս : " + buf);
      // åȷ
      random = new Random();
    }
    else{
      kansen = false;
    }
  }

  /********************************************************************/
  /** ưΥȸͭιưԤʤ<BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected int[] uniqueDeciding(int[] msg_header, int[] msg_data){

    // Ѥ AA_CLEAR_FIN ޤȤ˼ˤϻ֤ʤΤ,
    // ǴʰŪ˼(ľ!!)
    Vector updateIDset = senseInfoParser.getRenewObjectsID();
    if(updateIDset != null){
      if(updateIDset.size() > 0){
	Iterator it = updateIDset.iterator();
	while(it.hasNext()){
	  int upID = ((Integer)it.next()).intValue();
	  // ƻϩΤȤ, 
	  if(objectManager.hasRoadObject(upID)){
	    Road r = objectManager.getRoadObject(upID);
	    // ĺɤˤʤʤä
	    if(r.getBlock() == 0){
	      // AA_CLEAR_FIN å
	      Message mes = messageManager_new.makeClearFinMessage(upID);
	      if(mes != null){
		// ʬν°륻󥿡, Tell
		if(hasMyCenterObject()){
		  messageManager_new.storeTellMessage(mes,1);
		}
		// Sayɬ
		messageManager_new.storeSayMessage(mes,1);
	      }
	    }
	  }
	}
      }
    }

    // СĢ碌 
    Vector message = new Vector();
    message.add(msg_header);
    message.add(msg_data);
    decideCommand(message);
    // СĢ碌 ޤ

    return null; // Ȥꤢnull֤
  }

  /********************************************************************/
  /** ٻ⥨ȤΥᥤ롼򵭽Ҥ᥽åɡ<BR><BR>
   * @param message kernelƤå
   **/

  public void decideCommand(Vector message){

    msg_header = (int[])message.get(0); // åإå

    // ***** ʪKA_SENSE *****
    if(msg_header[0]==CommandTable.KA_SENSE){
      // $$$$ ι $$$$
      int[] msg_data = (int[])message.get(1); // åǡ
      //senseInfoParser.parseSenseInfo(msg_header,msg_data); // Ϥ

      //time = objectManager.getTime();
      //self = (PoliceForce)objectManager.getSelfInfo(); // ʤξι
      //RescueObject rsob = objectManager.getObject(self.getPosition());

      //sndMsg = 0;
      //if(debug)
      //  rsob.printInfo();
      
      // ʬΰ֤ 
      //prevPos = nowPos;
      //nowPos = self.getPosition();
      //io.writeMiscLog("nowPos(ID):"+nowPos+", prevPos(ID):"+prevPos);
      //io.writeSelfLog(self.getPosition(),self.getPositionExtra()); // selfLog

      if(!prevClear && prevPos == nowPos){ // ưʤʤäŬư
	samePosCount++;
	if(samePosCount > 5){
	  samePosCount = 0;
	  route = objectManager.getRandomWalkRoute(self);
	  if(route!=null){
	    io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	    if(miscLogMode){
	      String buffer = "";
	      for (int i=0;i<route.length;i++){
		buffer = buffer + route[i] + " ";
	      }
	      io.writeMiscLog("ưʤʤäΤŬư :" + buffer);
	    }	
	  }
	  else{
	    io.setPrefixActLog("CannotMoving"); // ܺ٥ޥɤΥå
	    io.rest(self.getPosition());
	    // AA_REST_* åι
	    Message mes = messageManager_new.makeRestMessage();
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	  }
	  prevClear = false;
	  return;
	}
      }
      else{
	samePosCount = 0;
      }

      // ޤäƤCivilianΥå
      //int[] buryCiv = objectManager.checkBuriedCivilian(time);
      //if(buryCiv != null){
      //  tellBuryMessage(buryCiv);
      //}
      
      // MessageManager ίäƤåФ
      //for (int i=0;i<msgMan.size();i++){
      //  io.tell(msgMan.getMsg(i));
      //  io.writeMiscLog("Tell Message");
      //  io.writeMiscLog(msgMan.getMsg(i).toString());
      //}
      
      // Debug
      //io.writeMiscLog("*** Display msgMan ***");
      //io.writeMiscLog(msgMan.toString());
      // $$$$ ι ޤ $$$$


      // $$$$ ư $$$$
      // Damage  40 ¿ʤäذư
      // TODO : ĥ⡼ɤ
      //if (amIinjured_gotoRefuge(40)){
      //  // Damage 礭Τ˰ư
      //  io.writeMiscLog("Damage 礭Τ˰ư");
      //  return;
      //}

      // ϤޤäľϤȤꤢɥȤε߽ФϤ򤢤
      if (kansen && time > 80){
	if (kansenList.size() != 0){
	  // Step.1 ̲Ǥƻ kansenList 鳰Ƥ
	  if (route != null){
	    for (int i=0;i<route.length;i++){
	      if (route[i] == nowPos){
		break;
	      }
	      RescueObject ro = objectManager.getObject(route[i]);
	      if (ro instanceof Road){
		Road r = (Road)ro;
		if (kansenList.contains(new Integer(r.getID()))){
		  kansenList.remove(new Integer(r.getID()));
		  io.writeMiscLog("åλ : "+r.getID());
		}
		else{
		  io.writeMiscLog("å or оݳ : "+r.getID());
		}
	      }
	      else{
		if (ro instanceof Node){
		  // ʤ
		}
		else{
		  io.writeMiscLog("̤äΤʤˤ褯狼ʤ...");
		}
	      }
	    }
	  }

	  // Step.2 åȤη
	  if (kansenList.size() != 0){
	    if(kansenTarget == -1 || nowPos == kansenTarget){
	      kansenTarget = ((Integer)kansenList.get(random.nextInt(kansenList.size()))).intValue();
	      io.writeMiscLog("åȤ (ƻϩ) : " + kansenTarget);
	      // ?? åȤؤ٤Ǥϡ
	      route = null;
	    }
	    else{
	      // ߤΥåȤ³ô
	    }
	  }
	  else{
	    // ƻϩΥåλ
	    //target = setTarget();
	    kansen = false;
	  }

	  // Step.3 ʬμդͤޤäƤʤ鷡
	  //  5 ƥåװξǼʬΤ֤ͤޤäƤ -> 
	  //  5 ƥåפȤΤ 20 m Ĺƻкǡ
	  int ttg = objectManager.nextTargetBlocked(self.getPosition(),time);
	  if(ttg>0){
	    io.setPrefixActLog("MySurroundingRoad"); // ܺ٥ޥɤΥå
	    io.clear(ttg);
	    // AA_CLEAR åι
	    Message mes = messageManager_new.makeClearMessage(ttg);
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	    if(miscLogMode){
	      io.writeMiscLog("<ƻϩ>ʬΤ֤ͤޤäƤ-> :" + ttg);
	    }	
	    prevClear = true;
	    //tellClearMessage(ttg);
	    return;
	  }

	  // Step.4 åȤ˸ưư
	  // routeι
	  if (route != null){
	    int[] nextRoute = objectManager.recycleRoute(route,nowPos); 
	    // ʤ֤ޤǵͤ
	    if(nextRoute != null){
	      io.writeMiscLog("ϩꥵ");
	      route = nextRoute;
	    }
	    else{
	      io.writeMiscLog("ϩľ");
	      route = 
		objectManager.goToDest(self.getPosition(),kansenTarget,false);
	    }
	  }
	  else{
	    route = 
	      objectManager.goToDest(self.getPosition(),kansenTarget,false);
	  }

	  if (route != null){
	    if(miscLogMode){
	      String buffer = "";
	      for (int i=0;i<route.length;i++){
		buffer = buffer + route[i] + " ";
		}
	      io.writeMiscLog("<ƻϩ> ͤޤäƤʤ -> ư :" + buffer);
	    }
	    io.setPrefixActLog("ForClearingTrunkRoad"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	    prevClear = false;
	    return;
	  }
	  else{
	    io.writeMiscLog("ϤˤʤϤʤ...");
	  }
	}
	else{
	  // ƻϩΥåλ
	  kansen = false;
	}
      }
      else{
	// ̾λŻ
	target = setTarget();
	if(target == -999){
	  return;
	}
	
	// routeι
	int[] nextRoute = objectManager.recycleRoute(route,nowPos); 
	// ʤ֤ޤǵͤ
	if(nextRoute != null){
	  route = nextRoute;
	  //printRoute(); // ϩĴ
	}
	
	// ˤĤƤϺͥǷ
	// TODO : äꤢ
	if (target == msgTargetID && isInTarget(self.getPosition(),target,true)){
	  // ʤΤ,ܥΡɤⷡ
	  // ֤ˤ->
	  io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	  io.clear(target);
	  // AA_CLEAR åι
	  Message mes = messageManager_new.makeClearMessage(target);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	  if(miscLogMode){
	    io.writeMiscLog(":֤ˤ-> :" + target);
	  }	
	  prevClear = true;
	  //tellClearMessage(target);
	  return;
	}
	
	//  5 ƥåװξǼʬΤ֤ͤޤäƤ -> 
	// 20 m Ĺƻк
	int ttg = objectManager.nextTargetBlocked(self.getPosition(),time);
	if(ttg>0){ 
	  io.setPrefixActLog("MySurroundingRoad"); // ܺ٥ޥɤΥå
	  io.clear(ttg);
	  // AA_CLEAR åι
	  Message mes = messageManager_new.makeClearMessage(ttg);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	  if(miscLogMode){
	    io.writeMiscLog("ʬΤ֤ͤޤäƤ-> :" + ttg);
	  }	
	  prevClear = true;
	  //tellClearMessage(ttg);
	  return;
	}
	
	// ɸξ򷡤
	if(isInTarget(self.getPosition(),target,false)){ 
	  // ֤ˤ->
	  //objectManager.printRoadInfo(target); // !!!!!!
	  io.setPrefixActLog(null); // ܺ٥ޥɤΥå
	  io.clear(target);
	  // AA_CLEAR åι
	  Message mes = messageManager_new.makeClearMessage(target);
	  if(mes != null){
	    // ʬν°륻󥿡, Tell
	    if(hasMyCenterObject()){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	    // Sayɬ
	    messageManager_new.storeSayMessage(mes,1);
	  }
	  if(miscLogMode){
	    io.writeMiscLog("֤ˤ-> :" + target);
	  }	
	  prevClear = true;
	  //tellClearMessage(target);
	  return;
	}
	else if(target > 0){ // ֤ˤʤ->ޤǤ
	  if(miscLogMode){
	    io.writeMiscLog("֤ˤʤ->ޤǤ");
	  }	
	  route = 
	    objectManager.goToDest(self.getPosition(),target,false);
	  int[] tmpRoute = objectManager.checkBlockedRoute(id,route);
	  // κɤäƤƻޤǥå
	  
	  if(tmpRoute == null || 
	     (tmpRoute.length==1 && tmpRoute[0]==self.getPosition()) || 
	     (tmpRoute.length==1 && 
	      isInTarget(self.getPosition(),tmpRoute[0],false)) || 
	     tmpRoute.length<route.length){
	    // ؤ롼Ȥ椬ͤޤäƤ
	    if(isInTarget(self.getPosition(),tmpRoute[tmpRoute.length-1],false)
	       && objectManager.isTargetBlocked(tmpRoute[tmpRoute.length-1])){
	      // ֤ˤ
	      io.setPrefixActLog("RoadOnTheRoute"); // ܺ٥ޥɤΥå
	      io.clear(tmpRoute[tmpRoute.length-1]);
	      // AA_CLEAR åι
	      Message mes = messageManager_new.
		  makeClearMessage(tmpRoute[tmpRoute.length-1]);
	      if(mes != null){
		// ʬν°륻󥿡, Tell
		if(hasMyCenterObject()){
		  messageManager_new.storeTellMessage(mes,1);
		}
		// Sayɬ
		messageManager_new.storeSayMessage(mes,1);
	      }
	      if(miscLogMode){
		io.writeMiscLog("ؤ롼Ȥ椬ͤޤäƤ -> ֤ˤ :" + tmpRoute[tmpRoute.length-1]);
	      }	
	      prevClear = true;
	      //tellClearMessage(tmpRoute[tmpRoute.length-1]);
	      return;
	    }
	    else{
	      // ʤ
	      route = tmpRoute;
	      if(miscLogMode){
		String buffer = "";
		for (int i=0;i<route.length;i++){
		  buffer = buffer + route[i] + " ";
		}
		io.writeMiscLog("ؤ롼Ȥ椬ͤޤäƤ -> ֤ˤʤ :" + buffer);
	      }		    
	      io.setPrefixActLog("ForClearingRoadOnTheRoute"); // ܺ٥ޥɤΥå
	      io.move(route,self.getPosition());
	      prevClear = false;
	      return;
	    }
	  }
	  else if(objectManager.isRouteClear(route)){
	    // ͤޤäƤʤ  ưǽ -> ư
	    if(miscLogMode){
	      String buffer = "";
	      for (int i=0;i<route.length;i++){
		buffer = buffer + route[i] + " ";
	      }
	      io.writeMiscLog(" ͤޤäƤʤ  ưǽ -> ư :" + buffer);
	    }
	    io.setPrefixActLog("ForClearing"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	    prevClear = false;
	    return;
	  };
	  
	  // عԤʤԤ
	  if(tmpRoute != null && tmpRoute[0] == self.getPosition() && 
	     objectManager.isRouteClear(tmpRoute)){
	    if(isInTarget(self.getPosition(),tmpRoute[tmpRoute.length-1],false)
	       && objectManager.isTargetBlocked(tmpRoute[tmpRoute.length-1])){
	      // ܤƻͤޤäƤ
	      io.setPrefixActLog("RoadOnTheRoute"); // ܺ٥ޥɤΥå
	      io.clear(tmpRoute[tmpRoute.length-1]);
	      // AA_CLEAR åι
	      Message mes = messageManager_new.
		  makeClearMessage(tmpRoute[tmpRoute.length-1]);
	      if(mes != null){
		// ʬν°륻󥿡, Tell
		if(hasMyCenterObject()){
		  messageManager_new.storeTellMessage(mes,1);
		}
		// Sayɬ
		messageManager_new.storeSayMessage(mes,1);
	      }
	      if(miscLogMode){
		io.writeMiscLog("ؤ롼Ȥ椬ͤޤäƤ -> ֤ˤ :" + tmpRoute[tmpRoute.length-1]);
	      }	
	      
	      prevClear = true;
	      //tellClearMessage(tmpRoute[tmpRoute.length-1]);
	      return;
	    }
	    else{
	      target = tmpRoute[tmpRoute.length-1];
	      printRoute(); // ϩĴ
	      route = tmpRoute;
	      if(miscLogMode){
		String buffer = "";
		for (int i=0;i<route.length;i++){
		  buffer = buffer + route[i] + " ";
		}
		io.writeMiscLog(" ͤޤäƤʤ  ưǽ -> ư :" + buffer);
	      }
	      io.setPrefixActLog("ForClearingRoadOnTheRoute"); // ܺ٥ޥɤΥå
	      io.move(route,self.getPosition());
	      prevClear = false;
	      return;
	    }
	  }  
	}
	
	// ٤ -> Random Walk
	route = objectManager.getRandomWalkRoute(self);
	io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
	if(miscLogMode){
	  io.writeMiscLog("٤ -> Random Walk");
	}	
	prevClear = false;
	return;
      }// ̾Ǥ̳ ޤ

      // $$$$ ư ޤ $$$$
      
    }
    // ***** KA_SENSE ޤ *****

    else{ // Kernel褿å(Networkκ?)
      //System.err.print("KA_Message Error!! MessageHeader:");
      for(int i=0; i<msg_header.length; i++){
	//System.err.print(" "+msg_header[i]);
      }
      //System.err.println();
    }
  }

  /********************************************************************/
  /**
   * target򥻥åȡʤʤ-999
   **/

  int setTarget(){
    if(target>0 && !objectManager.isTargetBlocked(target)){
      //  target ĺɲλ
      // TODO : KK_CLEAR_FIN Ƴ
      //tellClearMessage(target);      
      target = -1;
    }
    
    if (time-msgTargetSetTime > 10){
      // ŤʤäϾõ
      // 20 m Ĺ road  node 鷡ä
      msgTargetID = -1;
      msgTargetSetTime = -1;
    }
    
    // getObjectTime(msgTarget)>0 ,¬γǧ
    // -1 ξ,ǽϿޥǡξʤΤѤǤʤ
    if(msgTargetID > 0 && !objectManager.isTargetBlocked(msgTargetID) &&
       objectManager.getObjectTime(msgTargetID) > 0 &&
       (time-msgTargetSetTime) > 5){
      msgTargetID = -1;
      msgTargetSetTime = -1;
      //System.err.println("MsgTarget Clear!!!");
    };
    
    if(msgTargetID>0 && objectManager.getObjectTime(msgTargetID) < 1){ 
      // ߱ΤäåȤХå???
      if(miscLogMode){      
	io.writeMiscLog("߱ΤäåȤХå target:" + msgTargetID);
      }
      return msgTargetID;
    }
    else if(target>0 && objectManager.isTargetBlocked(target)){
      // targetޤɤäƤ
      if(miscLogMode){      
	io.writeMiscLog("targetޤɤäƤ target:" + target);
      }
      return target;
    }
    else{ // ¾
      blockedID = objectManager.getBlockedRoadListWW(self);
      // ĺɤƻϩΥꥹȤ֤
      if(blockedID != null){
	if(miscLogMode){
	  io.writeMiscLog("ĺɤƻϩΥꥹȤ֤ target" + blockedID[0]);      
	}
	return blockedID[0];
      }
      else{
	blockedID = objectManager.getBlockedRoadList(self);
	// ߤΤƻϩΥꥹȤ֤
	if(blockedID != null){
	  if(miscLogMode){
	    io.writeMiscLog("ߤΤƻϩΥꥹȤ֤ target" + blockedID[0]);
    	  }
	  return blockedID[0];
	}
	else{	    
	  route = objectManager.getRandomWalkRoute(self);
	  if(route!=null){
	    io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
	    io.move(route,self.getPosition());
	  }
	  prevClear = false;
	  return -999; // ޥɽλ
	}
      }
    }
  }

  /********************************************************************/
  // srcIDdestID,ޤܤƤ
  // over20  true ξ,ܥΡɤ鷡뤳Ȥ

  boolean isInTarget(int srcID,int targetID,boolean over20){
    // 20m ʾƻϩǤ,ƻϩθǤξܺ٤ʾ node Ǥ
    // ʤ,ĺɤroadäĺɲ򤹤ɬפ롣
    
    if (over20){
      RescueObject ro = objectManager.getObject(srcID);
      if(ro.getType().equals("Road")){
	Road r = (Road)ro;
	if(r.getHead() == targetID || r.getTail() == targetID){
	  return true;
	}
      }
      else if(ro.getType().equals("Node")){
	Node n = (Node)ro;
	int[] edgeList = n.getEdge();
	for(int i=0;i<edgeList.length;i++){
	  if(edgeList[i] == targetID){
	    return true;
	  }
	}
      }
    }
    else{
      if(srcID == targetID){
	return true;
      }
    }
    
    return false;
  }

  /********************************************************************/
  // ʾ򤷤Ƥ뤫ɤȽꡣ
  // Ƥ򤹤
  // ToDo : ĥ⡼ɤ
    /*
  boolean amIinjured_gotoRefuge(int dam){
    if (self.getDamage() > dam){
      if(miscLogMode){
	io.writeMiscLog("᡼¿ʤäƤߤΥ᡼ :" + self.getDamage());
      }
      // ToDo : ֶᤤõ٤
      route = objectManager.goToDest(self.getPosition(),refugeList[0],true);
      if (route != null){
	if (objectManager.isRouteClear(route)){
	  // routeĺɤʤ -> refuge عư
	  io.setPrefixActLog("ForCuring"); // ܺ٥ޥɤΥå
	  io.move(route,self.getPosition());
	  if(miscLogMode){
	    String buffer = "";
	    for (int i=0;i<route.length;i++){
	      buffer = buffer + route[i] + " ";
	    }
	    io.writeMiscLog("᡼¿Τذư :" + buffer);
	    return true;
	  }	
	}
	else{
	  // ToDo : ξäƤɤ餤Ρ
	  if(miscLogMode){
	    String buffer = "";
	    for (int i=0;i<route.length;i++){
	      buffer = buffer + route[i] + " ";
	    }
	    io.writeMiscLog("㡪۵ޡ᡼¿ĺɤǤʤ :" + buffer);
	  }		  
	}		  
      }
      else{
	if(miscLogMode){
	  io.writeMiscLog("᡼¿,routeǤʤ");
	}		  
      }
    }
    return false;
  }
    */
  /********************************************************************/
  // hear & say
    /*
  public void receiveHear(Vector message){
    int senderID = msg_header[3];
    byte[] msg_data = (byte[])message.get(1); // åǡ
    
    // åΥॹפ򸫤
    if(prevMsgTime != time)
      rcvMsg = 0;

    // ʲ3Τɤ줬ŬڤϿƤ. 켰Ϥʤ.(02-11-25)
    //    hearLog("RCV",senderID,null); // 켰(com="RCV"String)
    // io.writeHearLog(KK_RCV,senderID,null); // (com:int,destID=null:) 
    //    hearLog(KK_RCV,senderID,-1); // (com:int,destID=-1:int)

    // å
    // !!! åParameter
    if (poNum != 0){
      if(rcvMsg < Parameter.MAX_AGENT_RCVMSG_NUM && 
         (objectManager.hasPoliceOfficeObject(senderID))){
        //System.out.println(id + " Receive Message from " + senderID);

        // åȻϿ
        prevMsgTime = time;
        rcvMsg++;

        // ToDo : MessageRoboCup2002 ϰٽ clear() ʤɤ
        // ƽǤ褦ˤ٤Х饹̾ѤäƤ ok!
        msgRC2002 = new MessageRoboCup2002();
	// msgRC2002.parseHearInfo(msg_header,msg_data,time); // Ϥ
	// ʲȤĢ碌
	int[] msg_data_int = new int[msg_data.length-3];
	msg_data_int[0] = (((int)msg_data[0] & 0xFF) << 24) | 
	    (((int)msg_data[1] & 0xFF) << 16) | 
	    (((int)msg_data[2] & 0xFF) << 8) | 
	    ((int)msg_data[3] & 0xFF); // åǡĹ
	for(int i=4,counter=1; i < msg_data.length; i++,counter++){
	    msg_data_int[counter] =(int)msg_data[i]; // ĤʬintѴ
	}
	int[] msg = mergeMessage(msg_header,msg_data_int); // åη
	// ȤĢ碌ޤǡ
	msgRC2002.parseHearInfo(msg,time); // ˺

        int command = msgRC2002.getCommand();
	if(command == -1){
	  System.out.println("̤ΤΥåʤΤ̵뤹롣");
	  return;
	}
        int[] pTarget = {msgRC2002.getTarget(0)}; //  ? 0Ϥޤ?(02-11-25)
        // int[] pTarget = msgRC2002.getTarget(); // ä(02-11-25)
        // System.out.println(" pTarget(PF) Ĺ "+ pTarget.length);
	io.writeHearLog(command,senderID,pTarget);  // check(02-11-25)
    */
        // ToDo : 褯狼ʤǽ褦
        /*
        int[] rcvList = hearInfoParser.getReceiver(i);
	  boolean containSelfID = false;
	  for(int k=0;k<rcvList.length;k++){
	    if(rcvList[k] == id){
	      containSelfID = true;
	      break;
	    };
	  };
	  */
    /*
        //if(containSelfID && command == KK_HALT){ 
        if(command == KK_HALT || command == KK_MAYBE_HALT){ 
	  int t;
	  // ʬФƤƤ
	  if (poNum != 0){
	    t = isHelp(pTarget); //pTargetΥ᥽åɤƤ
          }                      // ŪˤpTargetintˤ٤?(02-11-25)
	  else{
	    t = pTarget[0]; //   ϴ롪׽!! (02-11-25)
	  }
	  if(msgTargetID == -1 && t > 0){ // !!! ׽
	    msgTargetID = t;
	    msgTargetSetTime = msgRC2002.getTime();
	  }
	  else{
	    //System.out.println(id + " msgTarget already set or not mine");
	  }
	}
        else if(command == KK_CLEAR){
	  for(int j=0;j<pTarget.length;j++){
	    //System.out.println("Receive.Objective : " + objective + " " + pTarget[j]);	
	    if(objectManager.hasRoadObject(pTarget[j])){
	      Road r = objectManager.getObjectDatabase().
	        getRoadObject(pTarget[j]);
	      r.setBlockForce(0); // åˤĺɤ0
	    }
	  }
	}
        else{
	  // ʬʳФƤΥåξ
	  // Bury,Clearʳ
	  io.writeMiscLog("ʬʳ");
	  io.writeMiscLog("command : "+command);
	  String tmp_buf = "";
	  for (int j=0;j<pTarget.length;j++){
	    tmp_buf = pTarget[j] + " ";
	  }
	  io.writeMiscLog("Id:"+ tmp_buf);
	}
      }
      // ̱"help me"ȶǤ
      else if(!objectManager.hasRescueManObject(senderID) &&
	 objectManager.hasCivilianObject(senderID)){
	boolean existPO = false;
	if(objectManager.getPoliceOfficeObjectNum() > 0){ // ٻ𤬤
	  existPO = true;
	}
	// ATǤʤΤfalseᤦ
	tellBurySaidCivilianMessage(self,existPO,false);
      }
    }
    else {
      if(rcvMsg < Parameter.MAX_AGENT_RCVMSG_NUM && 
	 (objectManager.hasFireBrigadeObject(senderID) ||
          objectManager.hasAmbulanceTeamObject(senderID))){
        //System.out.println(id + " Receive Message from " + senderID);

        // åȻϿ
        prevMsgTime = time;
        rcvMsg++;

        // ToDo : MessageRoboCup2002 ϰٽ clear() ʤɤ
        // ƽǤ褦ˤ٤Х饹̾ѤäƤ ok!
        msgRC2002 = new MessageRoboCup2002();
	// msgRC2002.parseHearInfo(msg_header,msg_data,time); // Ϥ
	// ʲȤĢ碌
	int[] msg_data_int = new int[msg_data.length-3];
	msg_data_int[0] = (((int)msg_data[0] & 0xFF) << 24) | 
	    (((int)msg_data[1] & 0xFF) << 16) | 
	    (((int)msg_data[2] & 0xFF) << 8) | 
	    ((int)msg_data[3] & 0xFF); // åǡĹ
	for(int i=4,counter=1; i < msg_data.length; i++,counter++){
	    msg_data_int[counter] =(int)msg_data[i]; // ĤʬintѴ
	}
	int[] msg = mergeMessage(msg_header,msg_data_int); // åη
	// ȤĢ碌ޤǡ
	msgRC2002.parseHearInfo(msg,time); // ˺

        int command = msgRC2002.getCommand();
	if(command == -1){
	  System.out.println("̤ΤΥåʤΤ̵뤹롣");
	  return;
	}
        int[] pTarget = {msgRC2002.getTarget(0)}; //  ? 0Ϥޤ?(02-11-25)
        // int[] pTarget = msgRC2002.getTarget(); // ä(02-11-25)
        // System.out.println(" pTarget(PF) Ĺ "+ pTarget.length);
	io.writeHearLog(command,senderID,pTarget);  // check(02-11-25)
    */
        // ToDo : 褯狼ʤǽ褦
        /*
        int[] rcvList = hearInfoParser.getReceiver(i);
	  boolean containSelfID = false;
	  for(int k=0;k<rcvList.length;k++){
	    if(rcvList[k] == id){
	      containSelfID = true;
	      break;
	    };
	  };
	  */
/*
        //if(containSelfID && command == KK_HALT){ 
        if(command == KK_HALT || command == KK_MAYBE_HALT){ 
	  int t;
	  // ʬФƤƤ
	  if (poNum != 0){
	    t = isHelp(pTarget); //pTargetΥ᥽åɤƤ
          }                      // ŪˤpTargetintˤ٤?(02-11-25)
	  else{
	    t = pTarget[0]; //   ϴ롪׽!! (02-11-25)
	  }
	  if(msgTargetID == -1 && t > 0){ // !!! ׽
	    msgTargetID = t;
	    msgTargetSetTime = msgRC2002.getTime();
	  }
	  else{
	    //System.out.println(id + " msgTarget already set or not mine");
	  }
	}
        else if(command == KK_CLEAR){
	  for(int j=0;j<pTarget.length;j++){
	    //System.out.println("Receive.Objective : " + objective + " " + pTarget[j]);	
	    if(objectManager.hasRoadObject(pTarget[j])){
	      Road r = objectManager.getObjectDatabase().
	        getRoadObject(pTarget[j]);
	      r.setBlockForce(0); // åˤĺɤ0
	    }
	  }
	}
        else{
	  // ʬʳФƤΥåξ
	  // Bury,Clearʳ
	  io.writeMiscLog("ʬʳ");
	  io.writeMiscLog("command : "+command);
	  String tmp_buf = "";
	  for (int j=0;j<pTarget.length;j++){
	    tmp_buf = pTarget[j] + " ";
	  }
	  io.writeMiscLog("Id:"+ tmp_buf);
	}
      }
      else if(!objectManager.hasRescueManObject(senderID) &&
	      objectManager.hasCivilianObject(senderID)){
	// ̱"help me"ȶǤ
	boolean existPO = false;
	if(objectManager.getPoliceOfficeObjectNum() > 0){ // ٻ𤬤
	  existPO = true;
	}
	// ATǤʤΤfalseᤦ
	tellBurySaidCivilianMessage(self,existPO,false);
      }
    }
      // å ޤ
  }
*/
  /********************************************************************/
  /** ƸİưΥȤˤȤä,٤åɤȽꤹ롣
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected boolean shouldReadMessage(int[] msg_header){
    boolean isReceive = false;
    int senderID = msg_header[3];
    if(hasMyCenterObject()){ // °륻󥿡, 
      if(msg_header[0] == KA_HEAR_TELL){ // HearTellλ, 
	if(rcvHearTellMsgCount < 3 &&
	   objectManager.hasPoliceOfficeObject(senderID)){ // 3̤,PO
	  rcvHearTellMsgCount++; // ʹ򥫥
	  isReceive = true;
	}
      }
      else if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 1 &&  // ޤ٤ʹƤʤ,
	   objectManager.hasPoliceForceObject(senderID)){   // ʬʳPF
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    else{ // °륻󥿡ʤ, 
      if(msg_header[0] == KA_HEAR_SAY){ // HearSayλ, 
	if(rcvHearSayMsgByRescueManCount < 3 &&  // 3̤, 
	   objectManager.hasPoliceForceObject(senderID)){   // ʬʳPF
	  rcvHearSayMsgByRescueManCount++; // ʹ򥫥
	  isReceive = true;
	}
	else if(hearSayMsgByCivilian == false && // ޤ٤ʹƤʤ,
		objectManager.hasCivilianObject(senderID) &&
		!objectManager.hasRescueManObject(senderID)){ // ̱
	  hearSayMsgByCivilian = true; // λǤϤ⤦ʹե饰ON
	  isReceive = true;
	}
      }
    }
    return isReceive;
  }

  /********************************************************************/
  /** ߽, ⤷ϻ꤫åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * , ϤåȤä, ǡ١ȥ֥ȤιԤʤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForRescueAgent(int ka_command,
					      int senderID, Message message){

    //  AA_HALT_*, AA_CONGESTED_*, AA_BLOCKADE_*, AA_CLEAR_FIN λ
    // ν򤹤Τ, ֤ʤΤǳ䰦
    // ToDo:ǯˤϺꤿ!?

    int command = message.getCommand();
    int[] msgData = message.getMessage();
    int haltAgentID;
    int haltAgentPos;
    int hopeGoRoadID;
    switch(command){
    // ΤΤȤĢ碌ʤΤ, 塹ϤȺꤿ!
    case AA_HALT_FB:
    case AA_HALT_AT:
    case AA_HALT_PF:
      haltAgentID = msgData[0];
      haltAgentPos = msgData[1];
      msgTargetID = haltAgentPos;
      msgTargetSetTime = message.getDataTime();
      break;
    // äΤΤȤĢ碌ʤΤ, 塹ϤȺꤿ!
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
      haltAgentID = msgData[0];
      haltAgentPos = msgData[1];
      hopeGoRoadID = msgData[2];
      if(objectManager.hasRoadObject(hopeGoRoadID)){
	msgTargetID = hopeGoRoadID;
      }
      else{
	msgTargetID = haltAgentPos;
      }
      msgTargetSetTime = message.getDataTime();
      break;
    default:
      // Ȥꤢ⤷ʤ(顼ϤȤΤ⤪Τ)
    }// end switch(message.getCommand())

    return null; // ߤä֤ͤϤʤΤnull֤
  }

  /********************************************************************/
  /** ̱åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * ߤΤȤ, Υ᥽åɤǼ¹Ԥ뤳ȤϤʤΤǲ⤷ʤ֤롣
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForCivilian(int ka_command,
					   int senderID, String message){
    // ⤬Ǥ뤳Ȥϲʤ
    return null; // ⤷ʤΤnull֤
  }

  /********************************************************************/
  // ˹Ԥ֤IDȽ   pTarget餳ä
  //                  ŪˤϲintǤΥ᥽åɤȤ٤⡩(02-11-25)

  int isHelp(int[] dest){
    for(int i=0;i<dest.length;i++){
      if(dest[i]%(pfNum/2) == id%(pfNum/2)){
	//System.err.println(id + " go help to " + dest[i]);
	return dest[i];
      }
      else{
	//System.err.println(id + " ignore help to " + dest[i]);
      };
    };
    return -1;
  }

  /********************************************************************/
  // ˹Ԥ֤IDȽ
  // äȤ 6/17

  int isHelp(int dest){
    if(dest%(pfNum/2) == id%(pfNum/2)){
      return dest;
    }
    else{
	//System.err.println(id + " ignore help to " + dest[i]);
    }
    return -1;
  }

  /********************************************************************/
  // clear ˤƻ̤Ȥ
    /*
  void tellClearMessage(int tgtID){
    if(policeOfficeList != null && policeOfficeList[0] > 0){
      int[] t = {tgtID};
      //io.tell(KK_CLEAR_FIN,t);
      sayBuffer = null;
      // ǤAA_CLEAR_FINåästoreǤʤ)
      // io.writeHearLog(KK_TELL_CLR,id,t);
      // ºݤio.saytellLog()ߤʤΤǤɤ!?
      return;
    }
    else{
      //System.err.println(id + " has no PO!!");
      // ToDo : ɤ뤫ͤ롣
      sayBuffer = null;
      return;
    }
  }
    */
   /********************************************************************/
  // clear ˤƻ̤Ȥ äǤ

/*
  void tellClearMessage(int tgtID){
    if(policeOfficeList != null && policeOfficeList[0] > 0){
      //MessageRoboCup2002 msgRC2002 = new MessageRoboCup2002(KK_CLEAR_FIN,tgtID);
      //msgMan.addMsg(msgRC2002);
      //      hearLog(KK_TELL_CLR,id,tgtID);
      return;
    }
    else{
      //System.err.println(id + " has no PO!!");
      // ToDo : ɤ뤫ͤ롣
      //sayBuffer = null;
      return;
    }
  }
*/

 /********************************************************************/
  // ޤäƤ̤꤬ͤ˸Ȥ
  /*
  void tellBuryMessage(int destID[]){
    if(policeOfficeList != null && policeOfficeList[0] > 0){
      for (int i=0;i<destID.length;i++){
	Civilian cv = objectManager.getCivilianObject(destID[0]);
	if (cv != null){
	  MessageRoboCup2002 tmp_msg;
	  if (cv.getType().equals("Civilian")){ // Civilianä
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
	        tmp_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED,cv.getPosition());
	        tmp_msg.setBuffering(5);
	      }
	      else{
	        // cv.getDamage() >= 20
		tmp_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED,cv.getPosition());
		tmp_msg.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
		tmp_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		tmp_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		tmp_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED,cv.getPosition());
		tmp_msg.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(tmp_msg);
	  }
	  // RescueObjectä
	  else if(cv.getType().equals("FireBrigade") || cv.getType().equals("AmbulanceTeam") || cv.getType().equals("PoliceForce")){
	    if (cv.getBuriedness() >= 45){
	      if (cv.getDamage() < 20){
		tmp_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_LIGHT_INJURED_RO,cv.getPosition());
		tmp_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		tmp_msg = new MessageRoboCup2002(KK_BURRY_DEPTH_BURIED_HARD_INJURED_RO,cv.getPosition());
		tmp_msg.setBuffering(5);
	      }
	    }
	    else{
	      // cv.getBuriedness() < 45
	      if (cv.getDamage() < 20){
	        tmp_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,cv.getPosition());	
		tmp_msg.setBuffering(5);
	      }
	      else{
		// cv.getDamage() >= 20
		tmp_msg = new MessageRoboCup2002(KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO,cv.getPosition());
		tmp_msg.setBuffering(5);
	      }	  
	    }
	    msgMan.addMsg(tmp_msg);
	  }
	}
	else{
	  io.writeMiscLog("cannot get Civilian Object id = "+destID[i]);
	}
      }
      return;
    }
    else{
      if (sndMsg < Parameter.MAX_AGENT_SNDMSG_NUM && destID.length > 0){
	Civilian cv = objectManager.getCivilianObject(destID[0]);
	io.writeMiscLog("ߤΥå : " +sndMsg);
	io.writeMiscLog("ޤäƤͤ򸫤 id = " + cv.getPosition());
	MessageRoboCup2002 snd_msg = new MessageRoboCup2002(KK_BURY,cv.getPosition());
	//io.say(snd_msg);
	sndMsg++;
	return;
      }
      // ToDo : ͤ롣ٻ𤬤ʤ say 뤫
      sayBuffer = null;
      return;
    }
  }
  */
  /********************************************************************/
  // ٻIDꥹȤκ
    /*
  int[] getPoliceOfficeList(){
    //return null;
    int[] tmp = new int[8];
    int count = 0;

    Enumeration enum = 
      objectManager.getObjectDatabase().getPoliceOfficeTable().keys();
    while(enum.hasMoreElements()){
      Integer d = (Integer)enum.nextElement();
      tmp[count] = d.intValue();
      count++;
    }

    int[] ret = null;
    if (count != 0){
      ret = new int[count];
      System.arraycopy(tmp,0,ret,0,count);
    }
    return ret;
  }
    */
  /********************************************************************/

  void printRoute(){
    for(int i=0;i<route.length;i++){
      if(verbose);
	//System.out.print(route[i] + "->");
    };
    if(verbose);
      //System.out.println();
  }
  
  /********************************************************************/
}









