class Main{
  static String hostname = "localhost";
  static String conf_file = "AgentConf.txt";

  static int roop = 0; // 饤ȿ
  static int firebrigade_num = 0;
  static int ambulanceteam_num = 0;
  static int policeforce_num = 0;
  static int civilian_num = 0;
  static int fireStation_num = 0;
  static int ambulanceCenter_num = 0;
  static int policeOffice_num = 0;

  static int argcount=0; // ޥɰĹ
  static int typenum = 0;
  static boolean dummyAgent = false; // ߡȤɤ

  static Agent[] agent;

  /********************************************************************/

  public static void main(String[] args){
    // Υå
    optionCheck(args);

    // ʤˤUsage
    if(argcount==0){
      Usage();
    }

    agent = new Agent[firebrigade_num + ambulanceteam_num + 
		     policeforce_num + civilian_num + fireStation_num
		     + ambulanceCenter_num + policeOffice_num];

    connectAgent("FireBrigade",firebrigade_num);
    connectAgent("AmbulanceTeam",ambulanceteam_num);
    connectAgent("PoliceForce",policeforce_num);
    connectAgent("Civilian",civilian_num);
    connectAgent("FireStation",fireStation_num);
    connectAgent("AmbulanceCenter",ambulanceCenter_num);
    connectAgent("PoliceOffice",policeOffice_num);

    // ٤ƤΥ饤ȤλޤԤ
    for(int i=0;i<roop;i++){
      try{
	agent[i].join(); 
      }
      catch(Exception e){
	e.printStackTrace();
      };
    };
  }

  /********************************************************************/

  static void optionCheck(String[] argv){
    while(argcount<argv.length){
      if(argv[argcount].equals("-h")){
	hostname = argv[argcount+1];
	argcount+=2;
      }
      else if(argv[argcount].equals("-f")){
	conf_file = argv[argcount+1];
	argcount+=2;
      }
      else if(argv[argcount].equals("-CV") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// Civilian³
	civilian_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-FB") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// FireBrigade³
	firebrigade_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-AT") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// AmbulanceTeam³
	ambulanceteam_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-PF") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// policeForce³
	policeforce_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-FS") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// fireStation³
	fireStation_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-AC") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// ambulanceCenter³
	ambulanceCenter_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-PO") && 
	      Character.isDigit(argv[argcount+1].charAt(0))){
	// policeOffice³
	policeOffice_num = Integer.valueOf(argv[argcount+1]).intValue();
	argcount+=2;
      }
      else if(argv[argcount].equals("-d")){
	// ߡ³
	dummyAgent = true;
	argcount++;
      }
      else{
	Usage();
      }
    };
  }


  /********************************************************************/
  // ̤˥Ȥ³

  static void connectAgent(String type,int num){
    if(type.equals("FireBrigade")){
      typenum = 2;
    }
    else if(type.equals("AmbulanceTeam")){
      typenum = 8;
    }
    else if(type.equals("PoliceForce")){
      typenum = 32;
    }
    else if(type.equals("Civilian")){
      typenum = 1;
    }
    else if(type.equals("FireStation")){
      typenum = 4;
    }
    else if(type.equals("AmbulanceCenter")){
      typenum = 16;
    }
    else if(type.equals("PoliceOffice")){
      typenum = 64;
    }
    else{
      //System.err.println("No Matching : " + type);
      return;
    };

    for(int i=0;i<num;i++){
      //agent[i+roop].setConfFile(conf_file);
      agent[i+roop] = new Agent(hostname,typenum,dummyAgent,conf_file);
      try{
	agent[i+roop].start();
	//System.out.println("Connect : " + type);
      }
      catch(Exception e){
	e.printStackTrace();
      };
    };    
    roop+=num;
  }

  /********************************************************************/

  static void Usage(){
	System.err.println("Usage:java Main [num]");
	System.err.println("     :java Main -h [hostname]");
	System.err.println("     :java Main -f [conf_file_name]");
	System.err.println("     :java Main [type option]... [num]");
	System.err.println("       [type option] :");
	System.err.println("         -CV : Civilian");
	System.err.println("         -FB : FireBrigade");
	System.err.println("         -AT : AmburanceTeam");
	System.err.println("         -PF : PoliceForce");
	System.err.println("         -FS : FireStation");
	System.err.println("         -AC : AmbulanceCenter");
	System.err.println("         -PO : PoliceOffice");
	System.err.println("       [num] : number of agent");
	System.exit(1);
  }

  /********************************************************************/
}
