/*
  # Message.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: Message.java,v 1.4.1 2002/06/02 22:42:04 honji Exp $
*/
package rescueAgent.ObjectSet;

/**
 * å֥Ȥɽ饹
 **/
public class Message implements AACommand{
  /********************************************************************/
  /** åξι **/
  private int dataTime;
  /** åν **/
  private int importance;
  /** å̿byte沽Ǥɤ(Τ) **/
  private boolean encodeOK = false;
  /** å̿Хȿ **/
  private int msgLength;
  /** ޥ̾(ͤ AA_Command ˽[󤭤]) **/
  private int command;
  /** ºݤΥåǡ(â٤intѴ) **/
  private int[] data;

  /** åν() **/
  public static final int IMPORTANCE_HIGH = 3;
  /** åν() **/
  public static final int IMPORTANCE_MIDDLE = 2;
  /** åν() **/
  public static final int IMPORTANCE_LOW = 1;

  /********************************************************************/
  // 󥹥ȥ饯
  /** ǡΥå **/
  public Message(){
    importance = IMPORTANCE_MIDDLE;
  }

  /********************************************************************/
  /** ǡΤߤꤷΥå<BR><BR>
   * @param time åξι
   **/
  public Message(int time){
    dataTime = time;
    importance = IMPORTANCE_MIDDLE;
  }

  /********************************************************************/
  /** ǡΤƼꤷå<BR><BR>
   * @param time åξι
   * @param imp åν
   * @param length å̿Хȿ
   * @param com ޥ̾(ͤ AA_Command ˽[󤭤])
   **/
  public Message(int time, int imp, int length, int com){
    dataTime = time;
    importance = imp;
    msgLength = length;
    command = com;
  }

  /********************************************************************/
  /** Ƥξꤷå<BR><BR>
   * @param time åξι
   * @param imp åν
   * @param length å̿Хȿ
   * @param com ޥ̾(ͤ AA_Command ˽[󤭤])
   * @param msg ºݤΥåǡ(â٤intѴ)
   **/
  public Message(int time, int imp, int length, int com, int[] msg){
    dataTime = time;
    importance = imp;
    msgLength = length;
    command = com;
    data = msg;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /** åξι֤ꡣ<BR><BR>
   * @param time åξι
   **/
  public void setDataTime(int time){
    dataTime = time;
  }

  /********************************************************************/
  /** åν٤ꡣ<BR><BR>
   * @param imp åν
   **/
  public void setImportance(int imp){
    importance = imp;
  }

  /********************************************************************/
  /** å̿byte沽Ǥɤꡣ<BR><BR>
   * @param encodeOK true...byteѴ, false..(̥Сʤɤ)
   **/
  protected void setEncodeOK(boolean flag){
    encodeOK = flag;
  }

  /********************************************************************/
  /** å̿Хȿꡣ<BR><BR>
   * @param length å̿Хȿ
   **/
  public void setMsgLength(int length){
    msgLength = length;
  }

  /********************************************************************/
  /** ޥ̾ꡣ(ͤ AA_Command ˽[󤭤]) <BR><BR>
   * @param com ޥ̾(ͤ AA_Command ˽[󤭤])
   **/
  public void setCommand(int com){
    command = com;
  }

  /********************************************************************/
  /** ºݤΥåǡꡣ(â٤intѴ) <BR><BR>
   * @param msg ºݤΥåǡ(â٤intѴ)
   **/
  public void setMessage(int[] msg){
    data = msg;
  }

  /********************************************************************/
  /** åξι֤<BR><BR>
   * @return åξι
   **/
  public int getDataTime(){
    return dataTime;
  }

  /********************************************************************/
  /** åν٤<BR><BR>
   * @return åν
   **/
  public int getImportance(){
    return importance;
  }

  /********************************************************************/
  /** å̿byte沽Ǥɤ<BR><BR>
   * @return true...byteѴ, false..(̥Сʤɤ)
   **/
  public boolean getEncodeOK(){
    return encodeOK;
  }

  /********************************************************************/
  /** å̿Хȿ<BR><BR>
   * @return å̿Хȿ
   **/
  public int getMsgLength(){
    return msgLength;
  }

  /********************************************************************/
  /** ޥ̾(ͤ AA_Command ˽[󤭤]) <BR><BR>
   * @return ޥ̾(ͤ AA_Command ˽[󤭤])
   **/
  public int getCommand(){
    return command;
  }

  /********************************************************************/
  /** ºݤΥåǡ(â٤intѴ) <BR><BR>
   * @return ºݤΥåǡ(â٤intѴ)
   **/
  public int[] getMessage(){
    return data;
  }

  /********************************************************************/
}

