/*
  # Message.java
  # $Id: MessageRoboCup2002.java,v 1.4 2002/05/28 12:23:50 yoshikia Exp $
  */

package rescueAgent.ObjectSet;

import java.util.*;

//import rescueAgent.RescueObject.*;
//import rescueAgent.RescueLib.ServerSetting;

public class MessageRoboCup2002 implements Cloneable{
  // ǡ,ɤ߹߳ϰ
  final int START_POSITION = 5;

  // target(IDΤ)ȷ Vector Ѥ롣
  // ͳƱưΤǡ2İʾΥƱȯ
  // ǡ뤪줬ʤ顣ʬ®٤뤬...
  int command;
  int senderID;
  int time;       // Υǡλ
  Vector target;
  Vector digit;

  // ǡ,ѿ
  int[] tmp_id;
  int[] dataArray;

  // ΥƥåפǾä٤åɤ
  boolean deadBuffer = true;
  int availableTime = -1;

  /********************************************************************/
  // 󥹥ȥ饯
  public MessageRoboCup2002(){
    this.command = -1;
    senderID = -1;
    time = -1;
    target = new Vector();
    digit = new Vector();
  }

  public MessageRoboCup2002(int command,int id){
    this.command = -1;
    senderID = -1;
    target = new Vector();
    digit = new Vector();

    initMessage(command,id);
  }

  public MessageRoboCup2002(int command,int[] id){
    this.command = -1;
    senderID = -1;
    target = new Vector();
    digit = new Vector();

    initMessage(command,id);
  }
  // 󥹥ȥ饯ޤ
  /********************************************************************/
  // åν

  public int initMessage(int command,int id){
    // Ǥ˽ʤƤ뤫ɤ
    if (this.command == -1){
      this.command = command;
      addID(command,id);
      return 0;
    }
    // Ǥ˽
    return -1;
  }

  public int initMessage(int command,int[] id){
    // Ǥ˽ʤƤ뤫ɤ
    if (this.command == -1){
      this.command = command;
      for (int i=0;i<id.length;i++){
	addID(command,id[i]);
      }
      return 0;
    }
    // Ǥ˽
    return -1;
  }

  /********************************************************************/

  // Hear ˤåϤ
  public void parseHearInfo(int[] intArray,int time){
    int parsed_command;
    // ID Ǽΰν 
    tmp_id = new int[5]; // ID Ϻ 5 ĤȲ
    //tmp_id = new int[10]; // ID Ϻ 10 ĤȲ
    
    // åǼ
    dataArray = intArray;

    // TODO:HearInfoParser Ѥ local ѿǤ??
    //int length = dataArray[1]/4;
    //recverID = dataArray[2];
    senderID = dataArray[3];    
    
    // 
    this.time = time;

    // ɤߤȤ(ϰ֤)
    int read_index = START_POSITION;
    // ɤߤȤǡĹǼ(NITRescueǤ12ǸΤϤ) 03-06-13
    int dataLength = dataArray[START_POSITION-1];
    
    // ޥʬβ
    parsed_command = (dataArray[read_index++]-0x30)*10+(dataArray[read_index++]-0x30);

    // ID ʬζɽ "0" 
    while (dataArray[read_index] == 0x30){
      read_index++;
    }
    
    // ID ο򵭲ѿ
    int rec_index = 0;

    // NITRescue12kkID̿ȤȲ
    // ƧޤdataArray[4](=ѥåĹ)12bytesǤʤä
    // NITRescueHEARǡǤϤʤȿ¬
    // ǡifʸǲϤ̵餻롪
    if(dataArray[4] != 12){ // 12kkIDʤ(NITRescueʳHEAR message!!)
      read_index = 99999; // ꤨʤͤƲwhileʸ̤ʤ
      System.out.println("̤ΤHEARǡߡ:"+dataArray[4]+"bytes data");
      return;
    }

    // ǤΤǲѤȤʤ 03-06-13
    while (read_index < START_POSITION + dataLength){ // 03-06-13
    // while (read_index != START_POSITION+12){ // 12Ǹϥޥ
      // 10 ӥåɤ߽ޤǰʲ򷫤֤
          // while (read_index != START_POSITION+50){   50kkIDλ
          // 50 ӥåɤ߽ޤǰʲ򷫤֤        ˤȤ
      read_index += parseID(rec_index++,read_index); // ʬ
    }

    // åν
    initMessage(parsed_command,tmp_id[--rec_index]);

    // ID ɲ
    for (int i=rec_index-1;i>-1;i--){
      addID(parsed_command,tmp_id[i]);
    }
  }
  
  /********************************************************************/
  // ID β
  // ͤɤ߹ӥåȿ

  private int parseID(int recID,int digit_index){
    int josu=1;
    // ϲ⤷ʤǲϤλ褦˻Ÿ
    // IDserver0.43Ǥ34塢server0.44Ǥ89Ǥ뤬
    // Ϥ10ʾˤʤǽ!! 04-02-24
    // ToDo: ID10ʾλˤбǤɬͭꡪ
    if((int)(dataArray[digit_index]-0x30)>10){ // ͤǤ9ޤǤʤΤ(Ŭ)
      System.out.println("IDη۾ߡ");
      return 99999; // ɬǡκǸ礭ͤȤ֤Ƥ
    }
    for(int j=(int)(dataArray[digit_index]-0x30); j>0; j--){
      // ʬ,
      tmp_id[recID] += (dataArray[digit_index+j] - 0x30) * josu;
      josu *= 10;
    }
    return (dataArray[digit_index]-0x30)+1;
  }

  /********************************************************************/
  // ID ɲá 0 Ԥ -1

  public int addID(int command,int id){
    // ޥɤפƤɲø
    if (this.command == command){
      // 10/28 ߤΥƥǤƱ ID 
      /*
      //  ID ǤϿѤߤʤϿϤʤ
      for (int i=0;i<getTargetSize();i++){
	if (getTarget(i) == id){
	  return -1;
	}
      }
      */
      // ID η+1¤10(50kkID48)ۤʤ->ID ɲ      
      // ݻƤ ID η׻
      int local_digit = 0;
      for (int i=0;i<digit.size();i++){
	local_digit += (getDigit(i) + 1);
      }

      if ((local_digit + calcDigit(id) + 1) <= 10){ // 50kkID1048ˤ
	target.add(new Integer(id));
	digit.add(new Integer(calcDigit(id)));
	return 0;
      }
    }
    return -1;
  }

  /********************************************************************/
  
  public int addMsg(MessageRoboCup2002 msg){
    // ޥɤΰפ ID ϿѤߤɤθ addID() Ǥ
    int ret = -1;
    for (int i=0;i<msg.getTargetSize();i++){
      ret = addID(msg.getCommand(),msg.getTarget(i));
      if (ret == 0){
	return 0;
      }
    }
    return -1;
  }
  
  /********************************************************************/
  
  public void setBuffering(int ttl){
    // ΥƥåפǺƤϤʤ
    deadBuffer = false;
    availableTime = ttl;
  }
  
  /********************************************************************/
  
  public boolean isBufferingDeletable(){
    return deadBuffer;
  }
  
  /********************************************************************/
  
  public int getBufferingLastTime(){
    return availableTime;
  }
  
  /********************************************************************/
  // Хåեι

  public void updateBuffer(){
    if (deadBuffer == false){
      availableTime--;
      if (availableTime == 0){
	deadBuffer = true;
      }
    }
  }

  /********************************************************************/

  public boolean equals(MessageRoboCup2002 msg){
    // ޥɤΰפǧ
    if (getCommand() != msg.getCommand()){
      return false;
    }

    // ID ΰפǧ
    // ID θĿϴطʤmsg äƤ ID  this 
    // äƤаפȤ롣㤨 this  ID  100,200
    // msg  ID  200 ξǤ true Ǥ
    boolean eql;
    for (int i=0;i<msg.getTargetSize();i++){
      eql = false;
      for (int j=0;j<getTargetSize();j++){
	if (getTarget(j) == msg.getTarget(i)){
	  eql = true;
	}
      }
      if (eql == false){
	return false;
      }
    }

    // פ
    return true;
  }

  /********************************************************************/

  public int getCommand(){
    return command;
  }

  /********************************************************************/

  public int getTargetSize(){
    return target.size();
  }

  /********************************************************************/

  public int getTarget(int num){
    if (num < target.size()){
      return ((Integer)target.get(num)).intValue();
    }
    return -1;
  }

  public int[] getTarget(){
    int[] ret = new int[target.size()];
    for (int i=0;i<target.size();i++){
      ret[i] = getTarget(i);
    }
    return ret;
  }

  /********************************************************************/

  public int getDigit(int num){
    if (num < digit.size()){
      return ((Integer)digit.get(num)).intValue();
    }
    return -1;    
  }

  public int[] getDigit(){
    int[] ret = new int[digit.size()];
    for (int i=0;i<digit.size();i++){
      ret[i] = getDigit(i);
    }
    return ret;
  }

  /********************************************************************/

  public int senderID(){
    return senderID;
  }

  /********************************************************************/

  public int getTime(){
    return time;
  }

  /********************************************************************/

  public MessageRoboCup2002 getObject(){
    try{
      return (MessageRoboCup2002)this.clone();
    }
    catch(Exception e){
      e.printStackTrace();
      return null;
    }
  }

  /********************************************************************/
  //  id η֤᥽å
  // Math.log ϼ¹®٤٤Τ,任ǵƤ

  public int calcDigit(int id){
    int digit = 1;
    int calc_id = id;
    while ((calc_id /= 10) != 0){
      digit++;
    }
    return digit;
  }

  /********************************************************************/
  // ʸϤ

  public String getMsgString(){
    int[] buffer = new int[10];
    // int[] buffer = new int[48]; //  50kkID
    int index = buffer.length-1;
    StringBuffer msg = new StringBuffer();
    
    // commandʬ
    msg.append((char)(command/10+0x30)); //ASCII Ѵ
    msg.append((char)(command%10+0x30)); //ASCII Ѵ

    // ID ʬ
    for (int i=0;i<target.size();i++){
      // оݤȤʤ ID
      int tmp = getTarget(i);
      do{
	buffer[index--] = tmp%10;
	tmp /= 10;
      }
      while(tmp != 0);
      buffer[index--] = getDigit(i);
    }
    
    // IDºݤ˽񤭹
    for (int i=0;i<buffer.length;i++){
      msg.append((char)(buffer[i]+0x30)); // ASCII Ѵ 
    }
    return msg.toString();
  }

  /********************************************************************/
  // ʸint[](ASCII)Ϥ

  public int[] getMsgIntArray(int t){

    this.time = t; // 
    int[] buffer = new int[10];
    // int[] buffer = new int[48]; //  50kkID
    int index = buffer.length-1;
    // ͤ
    int[] ret = new int[12];
    // int[] ret = new int[50]; //  50kkID
    
    // commandʬ
    ret[0] = command/10 + 0x30; //ASCII Ѵ
    ret[1] = command%10 + 0x30; //ASCII Ѵ

    // ID ʬ
    for (int i=0;i<target.size();i++){
      // оݤȤʤ ID
      int tmp = getTarget(i);
      do{
	buffer[index--] = tmp%10 + 0x30; // ASCII Ѵ
	tmp /= 10;
      }
      while(tmp != 0);
      buffer[index--] = getDigit(i) + 0x30; // ASCII Ѵ
    }
    
    for (int i=index;i>-1;i--){
      buffer[i] += 0x30; // ASCII Ѵ
    }
    
    // IDºݤ˽񤭹
    for (int i=0;i<buffer.length;i++){
      System.arraycopy(buffer,0,ret,2,10); 
      // System.arraycopy(buffer,0,ret,2,48); //  50kkID
    }

    // ƥǥХåʬ(04-02-23)
    System.out.print("ǡ(t="+time+"):");
    for(int i=0;i<ret.length;i++){
	System.out.print(ret[i]+", ");
    }
    System.out.println();

    return ret;
  }

  /********************************************************************/
  
  public String toString(){
    StringBuffer ret = new StringBuffer();
    ret.append("Time : "+time+"\n");
    ret.append("Command : "+command+"\n");
    ret.append("ID :");
    
    int[] ret_id = getTarget();
    for (int i=0;i<ret_id.length;i++){
      ret.append(" "+ret_id[i]);
    }
    ret.append("\n");
    
    if (deadBuffer == true){
      ret.append("Dead Buffer? : true\n");
    }
    else{
      ret.append("Dead Buffer? : false\n");
      ret.append("ttl : " + availableTime + "\n");
    }

    return ret.toString();
  }
}





