/*
  # ObjectDatabase.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  #
  # $Id: ObjectDatabase.java,v 1.4 2002/04/22 07:06:01 yoshikia Exp $
 */

package rescueAgent.ObjectSet;

import java.util.*;
import rescueAgent.RescueObject.*;
import rescueAgent.RescueLib.ServerSetting;

/**
 * ֥ȾǼ,ξ򰷤Υ᥽åɤ
 * 饹
 **/
public class ObjectDatabase{
  int time; // ߤλ
  int id; // ȤID

  World world;
  // ϥåơ֥ͽۤǡ1.5˶ᤤǿ֤ɤ
  Hashtable civilian_Table = new Hashtable(137); //    (90*1.5= 135)˶ᤤǿ
  Hashtable fireBrigade_Table = new Hashtable(23); //  (15*1.5=22.5)˶ᤤǿ
  Hashtable ambulanceTeam_Table = new Hashtable(13); // (8*1.5=  12)˶ᤤǿ
  Hashtable policeForce_Table = new Hashtable(23); //  (15*1.5=22.5)˶ᤤǿ
  Hashtable building_Table = new Hashtable(1901); // (1266*1.5=1899)˶ᤤǿ
  Hashtable node_Table = new Hashtable(2053); //   (1369*1.5=2053.5)˶ᤤǿ
  Hashtable road_Table = new Hashtable(2221); //     (1480*1.5=2220)˶ᤤǿ

  // ǳƤʪΥϥåơ֥
  Hashtable burningBuilding_Table = new Hashtable();

  // ʪ׼Ԥ뤫ɤΥե饰ϥåơ֥
  // (ߵ⤬ᥤǻȤ¾Ȥǡ١)
  Hashtable checkBuilding_Table = new Hashtable(1901); // buildingƱ

  Hashtable refuge_Table = new Hashtable(11);         // (5*1.5=7.5)˶ᤤǿ
  Hashtable fireStation_Table = new Hashtable(3);     // (1*1.5=1.5)˶ᤤǿ
  Hashtable ambulanceCenter_Table = new Hashtable(3); // (1*1.5=1.5)˶ᤤǿ
  Hashtable policeOffice_Table = new Hashtable(3);    // (1*1.5=1.5)˶ᤤǿ

  /********************************************************************/
  // 󥹥ȥ饯

  ObjectDatabase(int ID){
    this.id = ID;
    time = 0;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * ǡ١˥֥Ȥä롣
   *<BR><BR>
   * @param ObjectID ֥ID
   * @param RObject ֥
   **/
  public void addObject(int ObjectID,RescueObject RObject){
    Integer id = new Integer(ObjectID);

    // ʪ⡢׼¸߾ǡ١
    Integer[] tmp_int= new Integer[5];
    tmp_int[0]= id;              // ʬ(ʪ)ID
    tmp_int[1]= new Integer(-1); // ʲξκǽ(time)
    tmp_int[2]= new Integer(-1); // ʪ׼Ԥ뤫ɤ
                                 // (-1:̤õ,0:ʤȤǧ,
                                 //   1:׼ͭ)
    tmp_int[3]= new Integer(2);  // ߽ưʪͥ(5---1)
                                 // (5:⡦ߵ⡦ٻ⤬ޤäƤ,
                                 //  4:̱ޤäƤ,
                                 //  3:̱ޤäƤǽ,
                                 //  2:̤õʪ[default],
                                 //  1:ʤ,߽ޤ
                                 //  ͥ٤ʣͤꤦ,Ǥ
                                 //  礭ͤ򤽤ηʪͥ٤Ȥ롣)
    tmp_int[4]= new Integer(-1); // ʪˤͤε߽ͥ(4----0)
                                 // (4:KK_BURRY_SHALLOW_BURIED_LIGHT_INJURED,
                                 //  3:KK_BURRY_DEPTH_BURIED_LIGHT_INJURED,
                                 //  2:KK_BURRY_SHALLOW_BURIED_HARD_INJURED,
                                 //  1:KK_BURRY_DEPTH_BURIED_HARD_INJURED,
                                 //  0:KK_BURY(ĤޤDEPTH,INJURED)
                                 //  ͥ٤ʣͤꤦ,Ǥ
                                 //  礭ͤ򤽤ηʪͥ٤Ȥ롣)

    // ƥ֥Ȥʬ¸
    String type = RObject.getType();
    if(type.equals("Building")){
      building_Table.put(id,RObject);
      checkBuilding_Table.put(id,tmp_int);
    }
    else if(type.equals("Node")){
      node_Table.put(id,RObject);
    }
    else if(type.equals("Road")){
      road_Table.put(id,RObject);
    }
    else if(type.equals("Civilian")){
      civilian_Table.put(id,RObject);
    }
    else if(type.equals("FireBrigade")){
      fireBrigade_Table.put(id,RObject);
      civilian_Table.put(id,RObject);
    }
    else if(type.equals("AmbulanceTeam")){
      ambulanceTeam_Table.put(id,RObject);
      civilian_Table.put(id,RObject);
    }
    else if(type.equals("PoliceForce")){
      policeForce_Table.put(id,RObject);
      civilian_Table.put(id,RObject);
    }
    else if(type.equals("Refuge")){
      building_Table.put(id,RObject);
      checkBuilding_Table.put(id,tmp_int);
      refuge_Table.put(id,RObject);
    }
    else if(type.equals("FireStation")){
      building_Table.put(id,RObject);
      checkBuilding_Table.put(id,tmp_int);
      fireStation_Table.put(id,RObject);
    }
    else if(type.equals("AmbulanceCenter")){
      building_Table.put(id,RObject);
      checkBuilding_Table.put(id,tmp_int);
      ambulanceCenter_Table.put(id,RObject);
    }
    else if(type.equals("PoliceOffice")){
      building_Table.put(id,RObject);
      checkBuilding_Table.put(id,tmp_int);
      policeOffice_Table.put(id,RObject);
    }
    else if(type.equals("World")){
      world = (World)RObject;
    }
    else{
      //System.out.println("ObjectDB.addObject:No Entry; " + type);
    };
  }

  /********************************************************************/
  /**
   * Ϥ줿IDΥ֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param ObjectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasObject(int ObjectID){
    Integer id = new Integer(ObjectID);
    if(building_Table.containsKey(id) || 
       node_Table.containsKey(id) ||
       road_Table.containsKey(id) || 
       civilian_Table.containsKey(id) ||
       hasWorldObject()){
      return true;
    }
    else{
      return false;
    }
  }

  /********************************************************************/
  /**
   * Ϥ줿IDΥ֥Ȥ֤
   *<BR><BR>
   * @param ObjectID ֥ID
   **/
  public RescueObject getObject(int ObjectID){
    if(hasBuildingObject(ObjectID)){
      return getBuildingObject(ObjectID);
    }
    else if(hasNodeObject(ObjectID)){
      return getNodeObject(ObjectID);
    }
    else if(hasRoadObject(ObjectID)){
      return getRoadObject(ObjectID);
    }
    else if(hasCivilianObject(ObjectID)){
      return getCivilianObject(ObjectID);
    }
    else if(hasFireBrigadeObject(ObjectID)){
      return getFireBrigadeObject(ObjectID);
    }
    else if(hasAmbulanceTeamObject(ObjectID)){
      return getAmbulanceTeamObject(ObjectID);
    }
    else if(hasPoliceForceObject(ObjectID)){
      return getPoliceForceObject(ObjectID);
    }
    else if(hasRefugeObject(ObjectID)){
      return getRefugeObject(ObjectID);
    }
    else if(hasFireStationObject(ObjectID)){
      return getFireStationObject(ObjectID);
    }
    else if(hasAmbulanceCenterObject(ObjectID)){
      return getAmbulanceCenterObject(ObjectID);
    }
    else if(hasPoliceOfficeObject(ObjectID)){
      return getPoliceOfficeObject(ObjectID);
    }
    else{
      return null;
    }
  }

  /********************************************************************/
  /**
   * Ϥ줿IDΥ֥Ȥ֤
   *<BR><BR>
   * @param ObjectID ֥ID
   * @param TYPE ֥ȥ
   **/
  public RescueObject getObject(int ObjectID,int TYPE){
    switch(TYPE){
    case ServerSetting.TYPE_BUILDING:
      return getBuildingObject(ObjectID);
    case ServerSetting.TYPE_ROAD:
      return getRoadObject(ObjectID);
    case ServerSetting.TYPE_NODE:
      return getNodeObject(ObjectID);
    case ServerSetting.TYPE_CIVILIAN:
      return getCivilianObject(ObjectID);
    case ServerSetting.TYPE_FIREBRIGADE:
      return getFireBrigadeObject(ObjectID);
    case ServerSetting.TYPE_AMBULANCETEAM:
      return getAmbulanceTeamObject(ObjectID);
    case ServerSetting.TYPE_POLICEFORCE:
      return getPoliceForceObject(ObjectID);
    case ServerSetting.TYPE_REFUGE:
      return getRefugeObject(ObjectID);
    case ServerSetting.TYPE_FIRESTATION:
      return getFireStationObject(ObjectID);
    case ServerSetting.TYPE_AMBULANCECENTER:
      return getAmbulanceCenterObject(ObjectID);
    case ServerSetting.TYPE_POLICEOFFICE:
      return getPoliceOfficeObject(ObjectID);
    case ServerSetting.TYPE_WORLD:
      return getWorldObject();
    default:
      //System.err.println("ObjectDatabase: No Type Matching :" + TYPE);
      Throwable t = new Throwable();
      t.printStackTrace();
      return null;
    }
  }

  /********************************************************************/
  // ###  Building  ###
  /**
   * Ϥ줿IDBuilding֥Ȥ¸ߤ뤫å
   * Buildingϻ(FS,AC,PO)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasBuildingObject(int objectID){
    return building_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * Building֥Ȥ֤
   * Buildingϻ(FS,AC,PO)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @return BuildingNum ʪ
   **/
  public int getBuildingObjectNum(){
    return building_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDBuilding֥Ȥ֤
   * Buildingϻ(FS,AC,PO)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @param objectID ֥ID
   * @return Building IDб֥
   **/
  public Building getBuildingObject(int objectID){
    return (Building)building_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * BuildingHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return BuildingHashtable
   **/
  public Hashtable getBuildingTable(){
    return building_Table;
  }

  /********************************************************************/
  // ###  Node  ###
  /**
   * Ϥ줿IDNode֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasNodeObject(int objectID){
    return node_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * Node֥Ȥ֤
   *<BR><BR>
   * @return NodeNum 
   **/
  public int getNodeObjectNum(){
    return node_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDNode֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return Node IDб֥
   **/
  public Node getNodeObject(int objectID){
    return (Node)node_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * NodeHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return NodeHashtable
   **/
  public Hashtable getNodeTable(){
    return node_Table;
  }

  /********************************************************************/
  // ###  Road  ###
  /**
   * Ϥ줿IDRoad֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasRoadObject(int objectID){
    return road_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * Road֥Ȥ֤
   *<BR><BR>
   * @return RoadNum ƻϩ
   **/
  public int getRoadObjectNum(){
    return road_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDRoad֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return Road IDб֥
   **/
  public Road getRoadObject(int objectID){
    return (Road)road_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * RoadHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return RoadHashtable
   **/
  public Hashtable getRoadTable(){
    return road_Table;
  }

  /********************************************************************/
  // ###  Civilian  ###
  /**
   * Ϥ줿IDCivilian֥Ȥ¸ߤ뤫å
   * Civilianϵ߽(FB,AT,PF)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasCivilianObject(int objectID){
    return civilian_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * Civilian֥Ȥ֤
   * Civilianϵ߽(FB,AT,PF)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @return CivilianNum ̱(߽ޤ)
   **/
  public int getCivilianObjectNum(){
    return civilian_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDCivilian֥Ȥ֤
   * Civilianϵ߽(FB,AT,PF)ޤǤ뤳Ȥ!!
   *<BR><BR>
   * @param objectID ֥ID
   * @return Civilian IDб֥
   **/
  public Civilian getCivilianObject(int objectID){
    return (Civilian)civilian_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * CivilianHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return CivilianHashtable
   **/
  public Hashtable getCivilianTable(){
    return civilian_Table;
  }

  /********************************************************************/
  // ###  FireBrigade  ###
  /**
   * Ϥ줿IDFireBrigade֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasFireBrigadeObject(int objectID){
    return fireBrigade_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * FireBrigade֥Ȥ֤
   *<BR><BR>
   * @return FireBrigadeNum 
   **/
  public int getFireBrigadeObjectNum(){
    return fireBrigade_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDFireBrigade֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return FireBrigade IDб֥
   **/
  public FireBrigade getFireBrigadeObject(int objectID){
    return (FireBrigade)fireBrigade_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * FireBrigadeHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return FireBrigadeHashtable
   **/
  public Hashtable getFireBrigadeTable(){
    return fireBrigade_Table;
  }

  /********************************************************************/
  // ###  AmbulanceTeam  ###
  /**
   * Ϥ줿IDAmbulanceTeam֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasAmbulanceTeamObject(int objectID){
    return ambulanceTeam_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * AmbulanceTeam֥Ȥ֤
   *<BR><BR>
   * @return AmbulanceTeamNum ߵ
   **/
  public int getAmbulanceTeamObjectNum(){
    return ambulanceTeam_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDAmbulanceTeam֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return AmbulanceTeam IDб֥
   **/
  public AmbulanceTeam getAmbulanceTeamObject(int objectID){
    return (AmbulanceTeam)ambulanceTeam_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * AmbulanceTeamHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return AmbulanceTeamHashtable
   **/
  public Hashtable getAmbulanceTeamTable(){
    return ambulanceTeam_Table;
  }

  /********************************************************************/
  // ###  PoliceForce  ###
  /**
   * Ϥ줿IDPoliceForce֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasPoliceForceObject(int objectID){
    return policeForce_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * PoliceForce֥Ȥ֤
   *<BR><BR>
   * @return PoliceForceNum ٻ()
   **/
  public int getPoliceForceObjectNum(){
    return policeForce_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDPoliceForce֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return PoliceForce IDб֥
   **/
  public PoliceForce getPoliceForceObject(int objectID){
    return (PoliceForce)policeForce_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * PoliceForceHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return PoliceForceHashtable
   **/
  public Hashtable getPoliceForceTable(){
    return policeForce_Table;
  }

  /********************************************************************/
  // ###  Refuge  ###
  /**
   * Ϥ줿IDRefuge֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasRefugeObject(int objectID){
    return refuge_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * Refuge֥Ȥ֤
   *<BR><BR>
   * @return RefugeNum 
   **/
  public int getRefugeObjectNum(){
    return refuge_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDRefuge֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return Refuge IDб֥
   **/
  public Refuge getRefugeObject(int objectID){
    return (Refuge)refuge_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * RefugeHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return RefugeHashtable
   **/
  public Hashtable getRefugeTable(){
    return refuge_Table;
  }

  /********************************************************************/
  // ###  FireStation  ###
  /**
   * Ϥ줿IDFireStation֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasFireStationObject(int objectID){
    return fireStation_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * FireStation֥Ȥ֤
   *<BR><BR>
   * @return FireStationNum ɽ
   **/
  public int getFireStationObjectNum(){
    return fireStation_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDFireStation֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return FireStation IDб֥
   **/
  public FireStation getFireStationObject(int objectID){
    return (FireStation)fireStation_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * FireStationHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return FireStationHashtable
   **/
  public Hashtable getFireStationTable(){
    return fireStation_Table;
  }

  /********************************************************************/
  // ###  AmbulanceCenter  ###
  /**
   * Ϥ줿IDAmbulanceCenter֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasAmbulanceCenterObject(int objectID){
    return ambulanceCenter_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * AmbulanceCenter֥Ȥ֤
   *<BR><BR>
   * @return AmbulanceCenterNum ߵ޽
   **/
  public int getAmbulanceCenterObjectNum(){
    return ambulanceCenter_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDAmbulanceCenter֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return AmbulanceCenter IDб֥
   **/
  public AmbulanceCenter getAmbulanceCenterObject(int objectID){
    return (AmbulanceCenter)ambulanceCenter_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * AmbulanceCenterHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return AmbulanceCenterHashtable
   **/
  public Hashtable getAmbulanceCenterTable(){
    return ambulanceCenter_Table;
  }

  /********************************************************************/
  // ###  PoliceOffice  ###
  /**
   * Ϥ줿IDPoliceOffice֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @param objectID ֥ID
   * @return true=¸ߤ
   **/
  public boolean hasPoliceOfficeObject(int objectID){
    return policeOffice_Table.containsKey(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * PoliceOffice֥Ȥ֤
   *<BR><BR>
   * @return PoliceOfficeNum ٻ
   **/
  public int getPoliceOfficeObjectNum(){
    return policeOffice_Table.size();
  }

  /********************************************************************/
  /**
   * Ϥ줿IDPoliceOffice֥Ȥ֤
   *<BR><BR>
   * @param objectID ֥ID
   * @return PoliceOffice IDб֥
   **/
  public PoliceOffice getPoliceOfficeObject(int objectID){
    return (PoliceOffice)policeOffice_Table.get(new Integer(objectID));
  }

  /********************************************************************/
  /**
   * PoliceOfficeHashtable򤽤Τޤ֤
   *<BR><BR>
   * @return PoliceOfficeHashtable
   **/
  public Hashtable getPoliceOfficeTable(){
    return policeOffice_Table;
  }

  /********************************************************************/
  /********************************************************************/
  /**
   * ʪ׼ԾΥϥåơ֥Ф
   *<BR><BR>
   * @return ʪ׼ԾHashtable
   **/
  public Hashtable getCheckBuildingTable(){
    return checkBuilding_Table;
  }

  /********************************************************************/
  /**
   * ʪIDʪ (ʪID,׼Ԥ̵ͭ,߽ͥ,׼ID)
   * 
   *<BR><BR>
   * @param buildingID ʪID
   * @return buildingIDǥޥåפƤHashtableξ󥪥֥
   **/
  public Integer[] getCheckBuildingData(int buildingID){
    // (Integer[])ȤҤʤ
    return (Integer[])checkBuilding_Table.get(new Integer(buildingID));
  }

  /********************************************************************/
  // ###  World  ###
  /**
   * World֥Ȥ¸ߤ뤫å
   *<BR><BR>
   * @return true=¸ߤ
   **/
  public boolean hasWorldObject(){
    if(world != null)
      return true;
    else
      return false;
  }

  /********************************************************************/
  /**
   * World֥Ȥ֤
   *<BR><BR>
   * @return World֥
   **/
  public World getWorldObject(){
    return world;
  }

  /********************************************************************/

  public void printTable(){
    printBuildingTable();
    printRoadTable();
    printNodeTable();
    printCivilianTable();
    printFireBrigadeTable();
    printAmbulanceTeamTable();
    printPoliceForceTable();
  }

  /********************************************************************/

  public void printBuildingTable(){
    Enumeration enum = building_Table.elements();

    //System.out.println("### BuildingObject ###");
    while(enum.hasMoreElements()){
      Building ro = (Building)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printNodeTable(){
    Enumeration enum = node_Table.elements();

    //System.out.println("### NodeObject ###");
    while(enum.hasMoreElements()){
      Node ro = (Node)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printRoadTable(){
    Enumeration enum = road_Table.elements();

    //System.out.println("### RoadObject ###");
    while(enum.hasMoreElements()){
      Road ro = (Road)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printCivilianTable(){
    Enumeration enum = civilian_Table.elements();

    //System.out.println("### CivilianObject ###");
    while(enum.hasMoreElements()){
      Civilian ro = (Civilian)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printFireBrigadeTable(){
    Enumeration enum = fireBrigade_Table.elements();

    //System.out.println("### FireBrigadeObject ###");
    while(enum.hasMoreElements()){
      FireBrigade ro = (FireBrigade)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printAmbulanceTeamTable(){
    Enumeration enum = ambulanceTeam_Table.elements();

    //System.out.println("### AmbulanceTeamObject ###");
    while(enum.hasMoreElements()){
      AmbulanceTeam ro = (AmbulanceTeam)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printPoliceForceTable(){
    Enumeration enum = policeForce_Table.elements();

    //System.out.println("### PoliceForceObject ###");
    while(enum.hasMoreElements()){
      PoliceForce ro = (PoliceForce)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/

  public void printRefugeTable(){
    Enumeration enum = refuge_Table.elements();

    //System.out.println("### RefugeObject ###");
    while(enum.hasMoreElements()){
      Refuge ro = (Refuge)enum.nextElement();
      ro.printInfo();
    };
  }

  /********************************************************************/
  /**
   *  糧åȤ롣
   *  <BR><BR>
   *  @param time  
   **/
  public void setTime(int time){
    this.time = time;
  }

  /********************************************************************/
  /**
   *  ߤλ֤
   *  <BR><BR>
   *  @return    ߤλ
   **/
  public int getTime(){
    return time;
  }

  /********************************************************************/
  /**
   *  ȤID֤
   *  <BR><BR>
   *  @return  ȤID
   **/
  public int getID(){
    return id;
  }

  /********************************************************************/
}
