package rescueAgent.RescueLib;
/**
 * 쥹塼ߥ졼ǳƥ֥Ȥ̤뤿μֹ
 **/
public class ServerSetting{
  /** World֥Ȥɽ̻ҡ(208) **/
  public static final int TYPE_WORLD = 208;

  /** Civilian֥Ȥɽ̻ҡ(232) **/
  public static final int TYPE_CIVILIAN = 232;
  /** FireBrigade֥Ȥɽ̻ҡ(233) **/
  public static final int TYPE_FIREBRIGADE = 233;
  /** AmbulanceTeam֥Ȥɽ̻ҡ(234) **/
  public static final int TYPE_AMBULANCETEAM = 234;
  /** PoliceForce֥Ȥɽ̻ҡ(235) **/
  public static final int TYPE_POLICEFORCE = 235;

  /** Road֥Ȥɽ̻ҡ(168) **/
  public static final int TYPE_ROAD = 168;
  /** Node֥Ȥɽ̻ҡ(200) **/
  public static final int TYPE_NODE = 200;

  /** River֥Ȥɽ̻ҡ(169) **/
  public static final int TYPE_RIVER = 169;
  /** RiverNode֥Ȥɽ̻ҡ(201) **/
  public static final int TYPE_RIVERNODE = 201;

  /** Building֥Ȥɽ̻ҡ(176) **/
  public static final int TYPE_BUILDING = 176;
  /** Refuge֥Ȥɽ̻ҡ(184) **/
  public static final int TYPE_REFUGE = 184;
  /** FireStation֥Ȥɽ̻ҡ(185) **/
  public static final int TYPE_FIRESTATION = 185;
  /** AmbulanceCenter֥Ȥɽ̻ҡ(186) **/
  public static final int TYPE_AMBULANCECENTER = 186;
  /** PoliceOffice֥Ȥɽ̻ҡ(187) **/
  public static final int TYPE_POLICEOFFICE = 187;

  /********************************************************************/
  /** ֥Ȥμ̻Ҥ饪֥̾ʸ֤<BR><BR>
   * @param type ֥ȼ̻
   * @param isShort ֤ʸʸ˽̤뤫ɤ
   * @return ֥̾
  **/
  public static String getAgentType(int type, boolean isShort){
    String objname;
    switch(type){
    // Virtual Object
    case 208:
      if(isShort){
	objname = "WD";
      }
      else{
	objname = "World";
      }
      break;
    // Non-Agent Object (Real Object)
    case 168:
      if(isShort){
	objname = "RD";
      }
      else{
	objname = "Road";
      }
      break;
    case 200:
      if(isShort){
	objname = "ND";
      }
      else{
	objname = "Node";
      }
      break;
    case 169:
      if(isShort){
	objname = "RV";
      }
      else{
	objname = "River";
      }
      break;
    case 201:
      if(isShort){
	objname = "RN";
      }
      else{
	objname = "RiverNode";
      }
      break;
    case 176:
      if(isShort){
	objname = "BD";
      }
      else{
	objname = "Building";
      }
      break;
    case 184:
      if(isShort){
	objname = "RF";
      }
      else{
	objname = "Refuge";
      }
      break;
    // Agent Object (Real Object)
    case 232:
      if(isShort){
	objname = "CV";
      }
      else{
	objname = "Civilian";
      }
      break;
    case 233:
      if(isShort){
	objname = "FB";
      }
      else{
	objname = "FireBrigade";
      }
      break;
    case 234:
      if(isShort){
	objname = "AT";
      }
      else{
	objname = "AmbulanceTeam";
      }
      break;
    case 235:
      if(isShort){
	objname = "PF";
      }
      else{
	objname = "PoliceForce";
      }
      break;
    case 185:
      if(isShort){
	objname = "FS";
      }
      else{
	objname = "FireStation";
      }
      break;
    case 186:
      if(isShort){
	objname = "AC";
      }
      else{
	objname = "AmbulanceCenter";
      }
      break;
    case 187:
      if(isShort){
	objname = "PO";
      }
      else{
	objname = "PoliceOffice";
      }
      break;
    default:
      System.err.println("No Object Type : " + type);
      if(isShort){
	objname = "UN";
      }
      else{
	objname = "UnknownObject";
      }
    } // end switch
    return objname;
  }

  /********************************************************************/  
}
