package rescueAgent.RescueObject;
/**
 * Rescueߥ졼RiverNodeRiverNode֥󥯤ɽ
 * ֥
 **/

public class River extends Edge{
  //󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time ֥Ȥξ󹹿줿
   **/

  public River(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public River(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_HEAD)
      setHead(value[0]);
    else if(propID == PROPERTY_TAIL)
      setTail(value[0]);
    else if(propID == PROPERTY_LENGTH)
      setLength(value[0]);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      River(169) Parser:
        Type(169),ID(ex.1521),Head,Tail,Length

      (NUM)[=Parameter Name]            Attribute       (Value)
      ---------------------------------------------------------------------
      ( 12)[=PROPERTY_HEAD]             Head            (RiverNodeObjectID)
      ( 13)[=PROPERTY_TAIL]             Tail            (RiverNodeObjectID)
      ( 24)[=PROPERTY_LENGTH]           Length          (PositiveIntNumber)
     */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case 12 : // Head
	offset += setHead(data[start+offset+1]);
	break;
      case 13 : // Tail
	offset += setTail(data[start+offset+1]);
	break;
      case 24 : // Length
	offset += setLength(data[start+offset+1]);
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  public String getType(){
    return "River";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println("RiverID        : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     Head      : " + head);
    System.out.println("     Tail      : " + tail);
    System.out.println("     Length    : " + length);
  }

  /********************************************************************/
 }
